<?php
/**
 * Helper function for writing the javascript needed for an AJAX call to load Tiny_MCE
 *
 * @param string $module     Nombre del modulo que se esta subiendo la llamada ajax
 * @param string $action     Nombre de la accion que se esta subiendo la llamada ajax
 * @param string $link_text  Texto a usar como link
 * @param string $update_id  ID de la etiqueda div q se va a actualizar
 * @param string $var        nombre de la viriable a usar para pasar el elemento ID :(textareaID)
 * @param string $element_id El id del textarea  que  sera editado eg(textareaID=myElementID)
 * @param string $options    Cualquier parametro adicional que se quiera pasar por la URL al module/action ej: (&productID=1&category=2) etc
 */
function tiny_mce_ajax($module, $action, $link_text, $update_id, $var, $element_id, $options='')
{

 ?>
	  <script type="text/javascript">
		//<![CDATA[
   
		tinyMCE.init({
		  mode: "exact",
		  language: "en",
		  plugins : "imagemanager,spellchecker,style,layer,table,save,advhr,advimage,advlink,emotions,iespell,insertdatetime,preview,zoom,flash,searchreplace,print,contextmenu,paste,directionality,fullscreen,noneditable",
		  theme: "advanced",
		  theme_advanced_buttons1_add_before : "save,newdocument,separator",
			theme_advanced_buttons1_add : "fontselect,fontsizeselect",
			theme_advanced_buttons2_add : "separator,insertdate,inserttime,preview,separator,forecolor,backcolor",
			theme_advanced_buttons2_add_before: "cut,copy,paste,pastetext,pasteword,separator,search,replace,separator",
			theme_advanced_buttons3_add_before : "tablecontrols,separator",
			theme_advanced_buttons3_add : "emotions,iespell,flash,advhr,separator,print,separator,ltr,rtl,separator,fullscreen",
			theme_advanced_buttons4 : "insertlayer,moveforward,movebackward,absolute,|,styleprops,|,spellchecker",
			theme_advanced_toolbar_location : "top",
			theme_advanced_toolbar_align : "left",
			theme_advanced_path_location : "bottom",
			plugin_insertdate_dateFormat : "%Y-%m-%d",
		  plugin_insertdate_timeFormat : "%H:%M:%S",
		  theme_advanced_resizing : true,
			apply_source_formatting : true,
		  extended_valid_elements: "img[class|src|border=0|alt|title|hspace|vspace|width|height|align|onmouseover|onmouseout|name],hr[class|width|size|noshade],font[face|size|color|style],span[class|align|style]",
		  relative_urls: false,
		  spellchecker_languages : "+English=en,Danish=da,Dutch=nl,Finnish=fi,French=fr,German=de,Italian=it,Polish=pl,Portuguese=pt,Spanish=es,Swedish=sv",
		  debug: false,
		  auto_reset_designmode : true,
		});
		//]]>
   
		function initEditor(){
		  tinyMCE.execCommand('mceAddControl', true, '<?php echo $element_id;?>');
		}
	  </script >

  		<?php

		  echo link_to_remote($link_text, array(
				'url'      => '$module/$action?$var=$element_id&$options',
				'script'   => true,
				'update'   => array('success' => $update_id),
				'loading'  => '', //set this as you link for a default
				'loaded'   => '', //set this as you link for a default
				'complete' => "initEditor();"
			  ));
	}
?>
