<?php
class sfTCPDFView extends sfPHPView
{

  public function getEngine()
  {
	return 'sfTCPDF';
  }

  public function configure()
  {
	parent::configure();

	// load some config values for this view
	//$moduleName = $this->moduleName;
	//require(sfConfigCache::getInstance()->checkConfig(sfConfig::get('sf_app_module_dir_name').'/'.$this->moduleName.'/'.sfConfig::get('sf_app_module_config_dir_name').'/tcpdf.yml'));

  }

  protected function initPDF()
  {
	if (sfConfig::get('sf_logging_enabled'))
	{
	  $this->getContext()->getLogger()->info('{sfTCPDFView} initPDF');
	}
	//the used values should go into config
	$pdf = new sfTCPDF(PDF_PAGE_ORIENTATION, PDF_UNIT, PDF_PAGE_FORMAT, true);
	$pdf->SetFont("FreeSerif", "", 12);
	return $pdf;
  }

  public function render($templateVars = null)
  {
	$template = $this->getDirectory().'/'.$this->getTemplate();
	$context = $this->getContext();
	$response = $context->getResponse();

	if (sfConfig::get('sf_logging_enabled'))
	{
	  $context->getLogger()->info('{sfTCPDFView} render "'.$template.'"');
	}

	//backup render mode
	$renderMode = $context->getController()->getRenderMode();
	// override render mode : We dont want sfPHPView to render directly to the client
	$context->getController()->setRenderMode(sfView::RENDER_VAR);
	//let sfPHPView render our template to $retval
	$retval = parent::render($templateVars);
	//saved render mode
	$context->getController()->setRenderMode($renderMode);

	$pdf = $this->initPDF();
	$pdf->AddPage();
	$pdf->writeHTML($retval, true, 0);
	$pdfcontent = $pdf->Output('foo.pdf', 's');

	$response->setContentType('application/pdf');

	// render to client
	if ($renderMode == sfView::RENDER_CLIENT)
	{
		$response->setContent($pdfcontent);
	}
	return $pdfcontent;
  }
}