<?php

/**
 * expediente actions.
 *
 * @package    sf_sandbox
 * @subpackage expediente
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 2288 2006-10-02 15:22:13Z fabien $
 */
class expedienteActions extends autoexpedienteActions
{

   function executeResumen(){
        $c= new Criteria;
        $c->add(ExpedientePeer::FECHA_INICIO, date('Y-m-d'));
        $cantidad=ExpedientePeer::doCount($c);
        $this->cantidad=$cantidad;
        
        $c= new Criteria;               
        $c->add(ExpedientePeer::FECHA_INICIO, '((month(FECHA_INICIO) = '.date('m').') and ('.'year(FECHA_INICIO) = '.date('Y').') )', Criteria::CUSTOM);
        $cantidad_mes=ExpedientePeer::doCount($c);
        $this->cantidad_mes=$cantidad_mes;
   }
   
   protected function updateExpedienteFromRequest()
   {
       $con_facultades_id = $this->getRequestParameter('con_facultades_id');// Manejar la entrada del camnpo parcial
       $con_carreras_id = $this->getRequestParameter('con_carreras_id');
       $alumno_id = $this->getRequestParameter('alumno_id');

        if ($con_facultades_id)
            $this->expediente->setConFacultadesId($con_facultades_id);
        if ($con_carreras_id)
            $this->expediente->setConCarrerasId($con_carreras_id);
        if ($alumno_id)
            $this->expediente->setAlumnoId($alumno_id);
        parent::updateExpedienteFromRequest();  // Let symfony handle the other fields
   }
   
   protected function addFiltersCriteria($c) {
       
       if (isset($this->filters['con_facultades_id']) && $this->filters['con_facultades_id'] != '' && $this->filters['con_facultades_id'] != 0) 
            $c->add(ExpedientePeer::CON_FACULTADES_ID, $this->filters['con_facultades_id']);        
   
       if (isset($this->filters['con_carreras_id']) && $this->filters['con_carreras_id'] != '' && $this->filters['con_carreras_id'] != 0) 
            $c->add(ExpedientePeer::CON_CARRERAS_ID, $this->filters['con_carreras_id']);               
       
       if (isset($this->filters['alumno_id']) && $this->filters['alumno_id'] != '' && $this->filters['alumno_id'] != 0)
            $c->add(ExpedientePeer::ALUMNO_ID, $this->filters['alumno_id']);               
       
       if (isset($this->filters['nro_exp_fac']) && $this->filters['nro_exp_fac'] != '' && $this->filters['nro_exp_fac'] != 0)
            $c->add(ExpedientePeer::NRO_EXP_FAC, $this->filters['nro_exp_fac']);               
            
   
       if (isset($this->filters['fecha_inicio_is_empty']))
        {
          $criterion = $c->getNewCriterion(ExpedientePeer::FECHA_INICIO, '');
          $criterion->addOr($c->getNewCriterion(ExpedientePeer::FECHA_INICIO, null, Criteria::ISNULL));
          $c->add($criterion);
        }
        else if (isset($this->filters['fecha_inicio']))
        {
          if (isset($this->filters['fecha_inicio']['from']) && $this->filters['fecha_inicio']['from'] !== '')
          {
            $criterion = $c->getNewCriterion(ExpedientePeer::FECHA_INICIO, date('Y-m-d', $this->filters['fecha_inicio']['from']), Criteria::GREATER_EQUAL);
          }
          if (isset($this->filters['fecha_inicio']['to']) && $this->filters['fecha_inicio']['to'] !== '')
          {
            if (isset($criterion))
            {
              $criterion->addAnd($c->getNewCriterion(ExpedientePeer::FECHA_INICIO, date('Y-m-d', $this->filters['fecha_inicio']['to']), Criteria::LESS_EQUAL));
            }
            else
            {
              $criterion = $c->getNewCriterion(ExpedientePeer::FECHA_INICIO, date('Y-m-d', $this->filters['fecha_inicio']['to']), Criteria::LESS_EQUAL);
            }
          }
          if (isset($criterion))
          {
            $c->add($criterion);
          }
        } 
   
   
   
       if (isset($this->filters['estado']) && $this->filters['estado'] != '' && $this->filters['estado'] != 0)
            switch ($this->filters['estado']) {
                case 1:// en el area

                    //EA - Rec. Minist.
                    $criterion_2 = $c->getNewCriterion(ExpedientePeer::FECHA_RECIBIDO_MINISTERIO, null, Criteria::ISNOTNULL);

                    //EA Rec. Sec. Adm.
                    //pONGO ESTA POR QUE EN LA PRIMER MIGRACION NO PONIAN FECHA DE REC DE SEC ADMINISTRATIVA
//                    $criterion_3  = $c->getNewCriterion(ExpedientePeer::FECHA_RECIBIDO_SEC_ADM, null, Criteria::ISNOTNULL);
                    $criterion_3= $c->getNewCriterion(ExpedientePeer::RES_RECTORAL, '', Criteria::NOT_EQUAL);
                    $criterion_3_0= $c->getNewCriterion(ExpedientePeer::FECHA_PASE_MINISTERIO, null, Criteria::ISNULL);                    //$criterion_3_2=$c->getNewCriterion(ExpedientePeer::FECHA_RETIRO_FAC, null, Criteria::ISNULL);
                    $criterion_3->addAnd($criterion_3_0);
                    
                    //EA - Iniciado.
                    $criterion_4  = $c->getNewCriterion(ExpedientePeer::FECHA_PASE_SEC_ADM, null, Criteria::ISNULL);
                    $criterion_4_1= $c->getNewCriterion(ExpedientePeer::FECHA_RECIBIDO_MINISTERIO, null, Criteria::ISNULL);
                    $criterion_4_2= $c->getNewCriterion(ExpedientePeer::FECHA_PASE_MINISTERIO, null, Criteria::ISNULL);                    //$criterion_4_3= $c->getNewCriterion(ExpedientePeer::FECHA_RETIRO_FAC, null, Criteria::ISNULL);
                    $criterion_4->addAnd($criterion_4_1);
                    $criterion_4->addAnd($criterion_4_2);                    
                    
                    $criterion_3->addOr($criterion_4);         
                    
                    // PARA SABER Q NO EXISTA EN LA FACULTAD 
                    $subSelect = "expediente.id NOT IN (
                                                    SELECT
                                                          expediente_pasefacultad.expediente_id 
                                                    FROM
                                                          expediente_pasefacultad
                                                    WHERE
                                                         expediente_pasefacultad.FECHA_RETORNO IS NULL
                                                  )";
                    $c->add(ExpedientePeer::ID, $subSelect, Criteria::CUSTOM);
                    $c->add($criterion_3);
                    $c->add(ExpedientePeer::FECHA_RETIRO_FAC, null, Criteria::ISNULL);                    
                    $c->setDistinct();
                    
                break;
                case 2://Tramite Finalizado
                    $c->add(ExpedientePeer::FECHA_RETIRO_FAC, null, Criteria::ISNOTNULL);
                break;
                case 3://En Ministerio de Educacion
                    $c->add(ExpedientePeer::FECHA_RETIRO_FAC, null, Criteria::ISNULL);
                    $c->add(ExpedientePeer::FECHA_RECIBIDO_MINISTERIO, null, Criteria::ISNULL);
                    $c->add(ExpedientePeer::FECHA_PASE_MINISTERIO, null, Criteria::ISNOTNULL);
                break;
                case 4:// Sec Administrativa
                    $c->add(ExpedientePeer::FECHA_PASE_SEC_ADM, null, Criteria::ISNOTNULL);
                    $c->add(ExpedientePeer::RES_RECTORAL,'');
                    $c->add(ExpedientePeer::FECHA_RECIBIDO_SEC_ADM, null, Criteria::ISNULL);
                    $c->add(ExpedientePeer::FECHA_PASE_MINISTERIO, null, Criteria::ISNULL);
                    $c->add(ExpedientePeer::FECHA_RETIRO_FAC, null, Criteria::ISNULL);
                break;
                case 5:// Sec Administrativa
                    
                    $c->addJoin(ExpedientePeer::ID, ExpedientePasefacultadPeer::EXPEDIENTE_ID);
                    $c->add(ExpedientePasefacultadPeer::FECHA_RETORNO, null, Criteria::ISNULL);
                    
                    $c->add(ExpedientePeer::FECHA_PASE_SEC_ADM, null, Criteria::ISNULL);
                    $c->add(ExpedientePeer::FECHA_RECIBIDO_SEC_ADM, null, Criteria::ISNULL);
                    $c->add(ExpedientePeer::FECHA_PASE_MINISTERIO, null, Criteria::ISNULL);
                    $c->add(ExpedientePeer::FECHA_RETIRO_FAC, null, Criteria::ISNULL);
                break;
            } 
            //$c->add(ExpedientePeer::CON_CARRERAS_ID, $this->filters['con_carreras_id']);               
        //$this->addFiltersCriteria($c);
        $this->processFilters();
   }
    function executePasefacultad(){
        $this->redirect('expedientepasefacultad/list?expediente_id='.$this->getRequestParameter('id').'&filter=filter&filters%5Bexpediente_id%5D='.$this->getRequestParameter('id'));
    }  
    
    function executeListapases(){
            $this->expediente_id = $this->getRequestParameter('expediente_id');
            $this->processSort(); // pager                                            
            $this->pager = new sfPropelPager('ExpedientePasefacultad', 20);
            $c = new Criteria();
            #$this->addSortCriteria($c);
            //$this->addFiltersCriteria($c);
            $c->add(ExpedientePasefacultadPeer::EXPEDIENTE_ID, $this->getRequestParameter('expediente_id'));
            $this->pager->setCriteria($c);
            $this->pager->setPage($this->getRequestParameter('page', 1));
            $this->pager->init();
    }
    
}
