<?php

/**
 * Subclass for performing query and update operations on the 'art_alumno_modulo' table.
 *
 * 
 *
 * @package lib.model
 */ 
class ArtAlumnoModuloPeer extends BaseArtAlumnoModuloPeer
{
        public static function getAprobadosxModulo($anio = 2010){
                $con = Propel::getConnection(self::DATABASE_NAME);
                $sql = "select tabla.modulo, sum(tabla.cantidad)as cant, sum(tabla.aprobados) as aprob FROM
                (
                SELECT 
                                 art_modulo.NOMBRE as modulo,
                                  COUNT(art_alumno_modulo.ART_ALUMNO_ID) cantidad,
                                  0 aprobados 
                                FROM art_alumno_modulo INNER JOIN art_modulo ON (art_alumno_modulo.ART_MODULO_ID=art_modulo.ID)
                                WHERE art_alumno_modulo.ANIO = ".$anio." 
                                GROUP BY art_modulo.NOMBRE
       
                                UNION ALL
                (SELECT 
                                  art_modulo.NOMBRE AS modulo,
                                  0 as cantidad,
                                  COUNT(art_alumno_modulo.ART_ALUMNO_ID) AS aprobados
                                FROM art_alumno_modulo INNER JOIN art_modulo ON (art_alumno_modulo.ART_MODULO_ID=art_modulo.ID)
                                WHERE  art_alumno_modulo.APROBADO > 0 AND art_alumno_modulo.ANIO =  ".$anio." 
                                GROUP BY art_modulo.NOMBRE )
                ) tabla
                group by tabla.modulo ";
                
                $stmt = $con->createStatement();
                $rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_NUM);
                return $rs;
        }

        public static function getPorEdad(){
                $con = Propel::getConnection(self::DATABASE_NAME);
                $sql = " SELECT
                          (YEAR(CURDATE())-YEAR(art_alumno.FECHA_NAC)) - (RIGHT(CURDATE(),5)<RIGHT(art_alumno.FECHA_NAC,5)) AS Edad,
                          COUNT( art_alumno_modulo.ID) AS Cantidad
                        FROM
                         art_alumno_modulo
                         INNER JOIN art_alumno ON (art_alumno_modulo.ART_ALUMNO_ID=art_alumno.ID)
                         INNER JOIN art_comision ON (art_alumno_modulo.ART_COMISION_ID=art_comision.ID)
                        WHERE
                         ((YEAR(CURDATE())-YEAR(art_alumno.FECHA_NAC)) - (RIGHT(CURDATE(),5)<RIGHT(art_alumno.FECHA_NAC,5)) > 10) 
                         AND 
                         ((YEAR(CURDATE())-YEAR(art_alumno.FECHA_NAC)) - (RIGHT(CURDATE(),5)<RIGHT(art_alumno.FECHA_NAC,5)) < 50)
                         AND
                          art_alumno.anio = 2010
                        GROUP BY
                         (YEAR(CURDATE())-YEAR(art_alumno.FECHA_NAC)) - (RIGHT(CURDATE(),5)<RIGHT(art_alumno.FECHA_NAC,5)) ";
                        
                $stmt = $con->createStatement();
                $rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_NUM);
                //return self::populateObjects($rs);
                return $rs;
        }

        public static function getOrientados($anio = 2010){
                $con = Propel::getConnection(self::DATABASE_NAME);
                $sql = " SELECT 
                  COUNT( art_alumno_modulo.ID) AS 'Cantidad Inscriptos', 
                   (SELECT count(*) 
                    FROM art_alumno 
                    WHERE art_alumno.OTROS_ORIENTACION = 1  
                   ) AS 'Cant. Orientados'
                FROM
                 art_alumno_modulo
                 INNER JOIN art_alumno ON (art_alumno_modulo.ART_ALUMNO_ID=art_alumno.ID)
                 INNER JOIN art_comision ON (art_alumno_modulo.ART_COMISION_ID=art_comision.ID)
                WHERE  art_alumno_modulo.ANIO = ".$anio;
                $stmt = $con->createStatement();
                $rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_NUM);//return self::populateObjects($rs);
                return $rs;
        }
        
        public static function getCompletaron($anio = 2010){
                $con = Propel::getConnection(self::DATABASE_NAME);
                $sql = " SELECT 
                  COUNT( art_alumno_modulo.ID) AS 'Cantidad Inscriptos', 
                   (SELECT count(*) 
                    FROM art_alumno_modulo
                    WHERE (art_alumno_modulo.APROBADO = 1) and (art_alumno_modulo.ANIO =".$anio.")
                     				                    
                   ) AS 'Cant. Terminaron'
                FROM
                 art_alumno_modulo
                 INNER JOIN art_alumno ON (art_alumno_modulo.ART_ALUMNO_ID=art_alumno.ID)
                 INNER JOIN art_comision ON (art_alumno_modulo.ART_COMISION_ID=art_comision.ID)
                WHERE  art_alumno_modulo.ANIO = ".$anio;
                $stmt = $con->createStatement();
                $rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_NUM); //return self::populateObjects($rs);
                return $rs;
        }

     static public function getAlumnoCertificado( Criteria $criteria, $id)
    {  
     
     $criteria = clone $criteria;  // Clonamos el objeto para evitar modificar el original
     $criteria->clearSelectColumns(); // Eliminamos la columnas de seleccion en caso de que esten definidas

     // Agregamos las columnas de las tablas que queremos recuperar

     $criteria->addSelectColumn(ArtAlumnoPeer::ID);
     $criteria->addSelectColumn(ArtAlumnoPeer::APELLIDO);
     $criteria->addSelectColumn(ArtAlumnoPeer::NOMBRE);
     $criteria->addSelectColumn(ArtAlumnoPeer::DNI);
     $criteria->addSelectColumn(ArtModuloPeer::NOMBRE);
     
     $criteria->addSelectColumn(self::APROBADO);
     $criteria->addSelectColumn(self::ART_MODULO_ID);
     $criteria->addSelectColumn(self::FECHA_APROBADO);
     $criteria->addSelectColumn(self::APROBADO);
     $criteria->addSelectColumn(self::ANIO);
     $criteria->addSelectColumn(ArtComisionPeer::CARGA_HORARIA);
     $criteria->addSelectColumn(ArtComisionPeer::NOMBRE);
     $criteria->addSelectColumn(ArtComisionPeer::HORARIO);

     // Hacemos joins
     $criteria->addJoin(self::ART_ALUMNO_ID,ArtAlumnoPeer::ID);
     $criteria->addJoin(self::ART_MODULO_ID,ArtModuloPeer::ID);
     $criteria->addJoin(self::ART_COMISION_ID,ArtComisionPeer::ID);

     if ($id != 0){
        $criteria->add(self::ID,$id);
     }

     $rs = self::doSelectRS($criteria);  
     return $rs;
  }          





        
}










/*               $c = new Criteria();
                $c->add(self::ID, $results, Criteria::IN);
                // JOIN them with the article IDs
                $c->addJoin(self::ART_ALUMNO_ID, ArtAlumno::ID);
                $c->addJoin(self::ART_COMISION_ID, ArtComision::ID);
                // list each author only once and count the number of articles they have worked on
                $c->addGroupByColumn('Edad');
                $c->addAsColumn('numArticles', 'COUNT('.AuthorPeer::ID.')');
                // optionally retrieve only those authors that have a certain number of articles (like 'numArticles=2' or 'numArticles>2')
                // the first argument does not really matter since this is a custom criteria
                // according to the SQL standard this cannot be done with a WHERE clause
                $c->addHaving($c->getNewCriterion(AuthorPeer::ID, 'numArticles=2', Criteria::CUSTOM));
*/
