<?php

/**
 * Subclass for performing query and update operations on the 'expediente' table.
 *
 * 
 *
 * @package lib.model
 */ 
class ExpedientePeer extends BaseExpedientePeer
{

        

     static public function getEnArea($fac=1,$carr=1){// En el area
                $criteria = clone $criteria;
                $criteria->clearSelectColumns(); //expediente.con_facultades_id,
                $sql=" SELECT   con_facultades.nombre as facultad,
                                con_carreras.NOMBRE,
                                count(expediente.ID) as 'Cantidad'
                  FROM expediente  INNER JOIN con_carreras on (con_carreras.`id` = expediente.`con_carreras_id`)
                                   INNER JOIN con_facultades ON (expediente.con_facultades_id=con_facultades.id)
                  WHERE    expediente.con_facultades_id = ".$fac." and
                           expediente.con_carreras_id = ".$carr."  and
                           expediente.id NOT IN ( SELECT expediente_pasefacultad.expediente_id 
                                             FROM expediente_pasefacultad 
                                             WHERE expediente_pasefacultad.FECHA_RETORNO IS NULL )
                      AND (  (expediente.RES_RECTORAL <> 0 AND expediente.FECHA_PASE_MINISTERIO IS NULL )
                             OR (     (expediente.FECHA_PASE_SEC_ADM IS NULL AND expediente.FECHA_RECIBIDO_MINISTERIO IS NULL ) 
                                      AND expediente.FECHA_PASE_MINISTERIO IS NULL 
                                )
                                OR expediente.FECHA_RECIBIDO_MINISTERIO IS NOT NULL
                                ) 
                      AND expediente.FECHA_RETIRO_FAC IS NULL 
                  GROUP BY 
                        con_carreras.NOMBRE
                  ORDER BY expediente.CON_FACULTADES_ID ASC ";
                  
                $stmt = $con->createStatement();
                $rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_NUM); //return self::populateObjects($rs);
                return $rs;                  
        }

     static public function getFinalizado($fac=1,$carr=1){
                $criteria = clone $criteria;  // Clonamos el objeto para evitar modificar el original
                $criteria->clearSelectColumns(); // Eliminamos la columnas de seleccion en caso de que esten definidas
                $sql="  SELECT  con_facultades.nombre as facultad,
                                con_carreras.NOMBRE,
                                count(expediente.ID) as 'Cantidad'
                        FROM expediente  INNER JOIN con_carreras on (con_carreras.`id` = expediente.`con_carreras_id`)
                                         INNER JOIN con_facultades ON (expediente.con_facultades_id=con_facultades.id)
                        WHERE   expediente.con_facultades_id = ".$fac." AND 
                                expediente.con_carreras_id = ".$carr."  AND
                                expediente.FECHA_RETIRO_FAC IS NOT NULL 
                        GROUP BY con_carreras.NOMBRE
                        ORDER BY con_facultades.`id` ASC ";
                $stmt = $con->createStatement();
                $rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_NUM); //return self::populateObjects($rs);
                return $rs;
        }
 
        static public function getEnministerio($fac=1,$carr=1){
           $criteria = clone $criteria;
           $criteria->clearSelectColumns();
           $sql="       SELECT con_facultades.nombre as facultad,
                                con_carreras.NOMBRE,
                                count(expediente.ID) as 'Cantidad'
                         FROM expediente  INNER JOIN con_carreras on (con_carreras.`id` = expediente.`con_carreras_id`)
                                          INNER JOIN con_facultades ON (expediente.con_facultades_id=con_facultades.id)
                         WHERE  expediente.con_facultades_id = ".$fac." AND
                                expediente.con_carreras_id = ".$carr."  AND
                                expediente.FECHA_RETIRO_FAC IS NULL AND 
                                expediente.FECHA_RECIBIDO_MINISTERIO IS NULL AND 
                                expediente.FECHA_PASE_MINISTERIO IS NOT NULL 
                        GROUP BY con_carreras.NOMBRE
                        ORDER BY expediente.CON_FACULTADES_ID ASC,
                                 expediente.CON_CARRERAS_ID ASC";
                $stmt = $con->createStatement();
                $rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_NUM); //return self::populateObjects($rs);
                return $rs;                                
        }

        static public function getEnsecadministrativa($fac=1,$carr=1){
           $criteria = clone $criteria;
           $criteria->clearSelectColumns();
           $sql="       SELECT  con_facultades.nombre as facultad,
                                con_carreras.NOMBRE,
                                count(expediente.ID) as 'Cantidad'
                         FROM expediente  INNER JOIN con_carreras on (con_carreras.`id` = expediente.`con_carreras_id`)
                                          INNER JOIN con_facultades ON (expediente.con_facultades_id=con_facultades.id)
                         WHERE  expediente.con_facultades_id = ".$fac." AND 
                                expediente.con_carreras_id = ".$carr."  AND 
                                expediente.FECHA_PASE_SEC_ADM IS NOT NULL AND 
                                expediente.FECHA_RECIBIDO_SEC_ADM IS NULL AND 
                                expediente.RES_RECTORAL=0 AND 
                                expediente.FECHA_PASE_MINISTERIO IS NULL AND 
                                expediente.FECHA_RETIRO_FAC IS NULL 
                        GROUP BY con_carreras.NOMBRE
                        ORDER BY expediente.CON_FACULTADES_ID ASC,
                                 expediente.CON_CARRERAS_ID ASC";
                $stmt = $con->createStatement();
                $rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_NUM); //return self::populateObjects($rs);
                return $rs;                                
        }
 
         static public function getDevueltosafacultad($fac=1,$carr=1){
           $criteria = clone $criteria;
           $criteria->clearSelectColumns();
           $sql=" SELECT con_facultades.nombre as facultad,
                         con_carreras.NOMBRE,
                         count(expediente.ID) as 'Cantidad'
                  FROM expediente  INNER JOIN con_carreras on (con_carreras.`id` = expediente.`con_carreras_id`)
                                          INNER JOIN con_facultades ON (expediente.con_facultades_id=con_facultades.id)
                                          INNER JOIN expediente_pasefacultad ON (expediente.id = expediente_pasefacultad.expediente_id)
                  WHERE    expediente.con_facultades_id = ".$fac." AND 
                           expediente.con_carreras_id = ".$carr." AND 
                           expediente_pasefacultad.FECHA_RETORNO IS NULL AND 
                           expediente.FECHA_PASE_SEC_ADM IS NULL AND 
                           expediente.FECHA_RECIBIDO_SEC_ADM IS NULL AND 
                           expediente.FECHA_PASE_MINISTERIO IS NULL AND 
                           expediente.FECHA_RETIRO_FAC IS NULL 
                  GROUP BY con_carreras.NOMBRE
                  ORDER BY expediente.CON_FACULTADES_ID ASC,
                           expediente.CON_CARRERAS_ID ASC ";
                $stmt = $con->createStatement();
                $rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_NUM); //return self::populateObjects($rs);
                return $rs;                                
        }
 
 
        static public function getExpedientesTotales(){
           $con = Propel::getConnection(self::DATABASE_NAME);
           //$criteria->clearSelectColumns();
           $sql="
           SELECT  'Totales' as nombre,
                   sum(Z.area) as area,  
                   sum(Z.finalizado) as finalizado,
                   sum(Z.ministerio) as ministerio,
                   sum(Z.administrativa) as administrativa,
                   sum(Z.devueltofacultad) as devueltofacultad
FROM (
                       (SELECT  count(expediente.ID) as 'area',
                                0 as finalizado,
                                0 as ministerio,
                                0 as administrativa,
                                0 as devueltofacultad
                  FROM expediente  
                  WHERE     
                           expediente.id NOT IN ( SELECT expediente_pasefacultad.expediente_id 
                                             FROM expediente_pasefacultad 
                                             WHERE expediente_pasefacultad.FECHA_RETORNO IS NULL )
                      AND (  (expediente.RES_RECTORAL <> 0 AND expediente.FECHA_PASE_MINISTERIO IS NULL )
                             OR (     (expediente.FECHA_PASE_SEC_ADM IS NULL AND expediente.FECHA_RECIBIDO_MINISTERIO IS NULL ) 
                                      AND expediente.FECHA_PASE_MINISTERIO IS NULL 
                                )
                                OR expediente.FECHA_RECIBIDO_MINISTERIO IS NOT NULL
                                ) 
                      AND expediente.FECHA_RETIRO_FAC IS NULL 
                  ) union (
                  SELECT  0 as 'area',
                          count(expediente.ID) as 'finalizado',
                          0 as ministerio,
                          0 as administrativa,
                          0 as devueltofacultad
                        FROM expediente  
                        WHERE 
                                expediente.FECHA_RETIRO_FAC IS NOT NULL 


                   ) union 
                  (
                         SELECT 0 as 'area',
                                0 as 'finalizado',
                                count(expediente.ID) as 'ministerio',
                                0 as administrativa,
                                0 as devueltofacultad
                         FROM expediente  
                         WHERE   
                                expediente.FECHA_RETIRO_FAC IS NULL AND 
                                expediente.FECHA_RECIBIDO_MINISTERIO IS NULL AND 
                                expediente.FECHA_PASE_MINISTERIO IS NOT NULL 

                  ) union 
                  (
                    SELECT 
                                0 as 'area',
                                0 as 'finalizado',
                                0 as 'ministerio',
                                count(expediente.ID) as 'administrativa',
                                0 as 'devueltofacultad'
                         FROM expediente  
                         WHERE   
                                expediente.FECHA_PASE_SEC_ADM IS NOT NULL AND 
                                expediente.FECHA_RECIBIDO_SEC_ADM IS NULL AND 
                                expediente.RES_RECTORAL=0 AND 
                                expediente.FECHA_PASE_MINISTERIO IS NULL AND 
                                expediente.FECHA_RETIRO_FAC IS NULL 
                  ) union 
                  (select
                                0 as 'area',
                                0 as 'finalizado',
                                0 as 'ministerio',
                                0 as administrativa,
                                count(expediente.ID) as 'devueltofacultad'
                  FROM expediente  INNER JOIN expediente_pasefacultad ON (expediente.id = expediente_pasefacultad.expediente_id)
                  WHERE     
                           expediente_pasefacultad.FECHA_RETORNO IS NULL AND 
                           expediente.FECHA_PASE_SEC_ADM IS NULL AND 
                           expediente.FECHA_RECIBIDO_SEC_ADM IS NULL AND 
                           expediente.FECHA_PASE_MINISTERIO IS NULL AND 
                           expediente.FECHA_RETIRO_FAC IS NULL 
                  )

                  ) Z 
           ";
           $stmt = $con->createStatement();
           $rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_NUM); //return self::populateObjects($rs);
           return $rs;                                
        }



        static public function getExpedientesEstado($fac='',$carr=''){
           $facu_y_carr="";
           
           if (($fac != '')&&($carr!='')){
                $facu_y_carr=" expediente.con_facultades_id = ".$fac." AND ";
                $facu_y_carr.= "expediente.con_carreras_id = ".$carr." AND ";
           }
           
           $con = Propel::getConnection(self::DATABASE_NAME);
           $sql=" SELECT Z.facultad,
                         Z.carrera, 
                         sum(Z.area) as area, 
                         sum(Z.finalizado) as finalizado,
                         sum(Z.ministerio) as ministerio,
                         sum(Z.administrativa) as administrativa,
                         sum(Z.devueltofacultad) as devueltofacultad
                  FROM (
                       
                       (SELECT  con_facultades.nombre_largo as facultad,
                                con_carreras.NOMBRE as carrera,
                                count(expediente.ID) as 'area',
                                0 as finalizado,
                                0 as ministerio,
                                0 as administrativa,
                                0 as devueltofacultad
                  FROM expediente  INNER JOIN con_carreras on (con_carreras.`id` = expediente.`con_carreras_id`)
                                   INNER JOIN con_facultades ON (expediente.con_facultades_id=con_facultades.id)
                  WHERE     ".$facu_y_carr."
                           expediente.id NOT IN ( SELECT expediente_pasefacultad.expediente_id 
                                             FROM expediente_pasefacultad 
                                             WHERE expediente_pasefacultad.FECHA_RETORNO IS NULL )
                      AND (  (expediente.RES_RECTORAL <> 0 AND expediente.FECHA_PASE_MINISTERIO IS NULL )
                             OR (     (expediente.FECHA_PASE_SEC_ADM IS NULL AND expediente.FECHA_RECIBIDO_MINISTERIO IS NULL ) 
                                      AND expediente.FECHA_PASE_MINISTERIO IS NULL 
                                )
                                OR expediente.FECHA_RECIBIDO_MINISTERIO IS NOT NULL
                                ) 
                      AND expediente.FECHA_RETIRO_FAC IS NULL 
                  GROUP BY 
                        con_carreras.NOMBRE
                  ORDER BY expediente.CON_FACULTADES_ID ASC 
                  
                  ) union 
                  
                  (
                  SELECT        con_facultades.nombre_largo as facultad,
                                con_carreras.NOMBRE as carrera,
                                0 as 'area',
                                count(expediente.ID) as 'finalizado',
                                0 as ministerio,
                                0 as administrativa,
                                0 as devueltofacultad
                        FROM expediente  INNER JOIN con_carreras on (con_carreras.`id` = expediente.`con_carreras_id`)
                                         INNER JOIN con_facultades ON (expediente.con_facultades_id=con_facultades.id)
                        WHERE ".$facu_y_carr."
                                expediente.FECHA_RETIRO_FAC IS NOT NULL 
                        GROUP BY con_carreras.NOMBRE
                        ORDER BY con_facultades.`id` ASC 
                   ) union 
                  (
                         SELECT con_facultades.nombre_largo as facultad,
                                con_carreras.NOMBRE as carrera,
                                0 as 'area',
                                0 as 'finalizado',
                                count(expediente.ID) as 'ministerio',
                                0 as administrativa,
                                0 as devueltofacultad
                         FROM expediente  INNER JOIN con_carreras on (con_carreras.`id` = expediente.`con_carreras_id`)
                                          INNER JOIN con_facultades ON (expediente.con_facultades_id=con_facultades.id)
                         WHERE   ".$facu_y_carr."
                                expediente.FECHA_RETIRO_FAC IS NULL AND 
                                expediente.FECHA_RECIBIDO_MINISTERIO IS NULL AND 
                                expediente.FECHA_PASE_MINISTERIO IS NOT NULL 
                        GROUP BY con_carreras.NOMBRE
                        ORDER BY expediente.CON_FACULTADES_ID ASC,
                                 expediente.CON_CARRERAS_ID ASC
                  ) union 
                  (
                    SELECT con_facultades.nombre_largo as facultad,
                                con_carreras.NOMBRE as carrera,
                                0 as 'area',
                                0 as 'finalizado',
                                0 as 'ministerio',
                                count(expediente.ID) as 'administrativa',
                                0 as 'devueltofacultad'
                         FROM expediente  INNER JOIN con_carreras on (con_carreras.`id` = expediente.`con_carreras_id`)
                                          INNER JOIN con_facultades ON (expediente.con_facultades_id=con_facultades.id)
                         WHERE   ".$facu_y_carr."
                                expediente.FECHA_PASE_SEC_ADM IS NOT NULL AND 
                                expediente.FECHA_RECIBIDO_SEC_ADM IS NULL AND 
                                expediente.RES_RECTORAL=0 AND 
                                expediente.FECHA_PASE_MINISTERIO IS NULL AND 
                                expediente.FECHA_RETIRO_FAC IS NULL 
                        GROUP BY con_carreras.NOMBRE
                        ORDER BY expediente.CON_FACULTADES_ID ASC,
                                 expediente.CON_CARRERAS_ID ASC                  
                  ) union 
                  (
                  SELECT con_facultades.nombre_largo as facultad,
                                con_carreras.NOMBRE as carrera,
                                0 as 'area',
                                0 as 'finalizado',
                                0 as 'ministerio',
                                0 as administrativa,
                                count(expediente.ID) as 'devueltofacultad'
                  FROM expediente  INNER JOIN con_carreras on (con_carreras.`id` = expediente.`con_carreras_id`)
                                          INNER JOIN con_facultades ON (expediente.con_facultades_id=con_facultades.id)
                                          INNER JOIN expediente_pasefacultad ON (expediente.id = expediente_pasefacultad.expediente_id)
                  WHERE     ".$facu_y_carr."
                           expediente_pasefacultad.FECHA_RETORNO IS NULL AND 
                           expediente.FECHA_PASE_SEC_ADM IS NULL AND 
                           expediente.FECHA_RECIBIDO_SEC_ADM IS NULL AND 
                           expediente.FECHA_PASE_MINISTERIO IS NULL AND 
                           expediente.FECHA_RETIRO_FAC IS NULL 
                  GROUP BY con_carreras.NOMBRE
                  ORDER BY expediente.CON_FACULTADES_ID ASC,
                           expediente.CON_CARRERAS_ID ASC                   
                  )
                  
                  ) Z
                  group by Z.facultad,
                           Z.carrera
                order by z.Z.facultad desc";
           $stmt = $con->createStatement();
           $rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_NUM); //return self::populateObjects($rs);
           return $rs;                                
        }

        static public function getExpedientesEntradaPeriodo($fecha_from, $fecha_to){
           $con = Propel::getConnection(self::DATABASE_NAME);
           $sql=" 
                        select  
                        DATE_FORMAT(expediente.`fecha_inicio`, '%d/%m/%Y'),
                        count(expediente.id)
                        from expediente
                        where expediente.`fecha_inicio` between '".$fecha_from."' and '".$fecha_to."'
                        group by expediente.`fecha_inicio`
           ";
           $stmt = $con->createStatement();
           $rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_NUM);
           return $rs;                                
        }


        static public function getExpPromedioDemora(){
           $con = Propel::getConnection(self::DATABASE_NAME);
           //$criteria->clearSelectColumns();
           $sql="       select year(`expediente`.`fecha_inicio`) as 'Ao', 
                        round(avg(DATEDIFF(`expediente`.`fecha_retiro_fac`,`expediente`.`fecha_inicio`))) AS 'Demora'
                        from  `expediente`
                        group by year(`expediente`.`fecha_inicio`)     
           ";
                   $stmt = $con->createStatement();
           $rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_NUM); //return self::populateObjects($rs);
           return $rs;                                
        }




        static public function getExpEmitidosporAnio($fac='',$carr=''){
           $con = Propel::getConnection(self::DATABASE_NAME);
                
           if (($fac != '')&&($carr!='')){
                        $facu_y_carr=" expediente.con_facultades_id = ".$fac." AND ";
                        $facu_y_carr.= "expediente.con_carreras_id = ".$carr." AND ";
           $sql=" SELECT  con_facultades.nombre_largo as facultad,
                          con_carreras.NOMBRE as carrera,
                          year(`expediente`.`res_rectoral_fecha`) as 'Ao', 
                          count(expediente.`res_rectoral_fecha`) AS 'Cantidad Emitidos'
                  FROM expediente  INNER JOIN con_carreras on (con_carreras.`id` = expediente.`con_carreras_id`)
                                 INNER JOIN con_facultades ON (expediente.con_facultades_id=con_facultades.id)
                  WHERE     ".$facu_y_carr."
                            expediente.`res_rectoral_fecha` is not null
                  GROUP BY  con_facultades.nombre_largo,
                            con_carreras.NOMBRE,
                          year(`expediente`.`res_rectoral_fecha`) ";
           } else {
                   $sql=" SELECT  '' as facultad,
                                  '' as carrera,
                                  year(`expediente`.`res_rectoral_fecha`) as 'Ao', 
                                  count(`expediente`.`res_rectoral_fecha`) AS 'Cantidad Emitidos'
                          FROM expediente  INNER JOIN con_carreras on (con_carreras.`id` = expediente.`con_carreras_id`)
                                           INNER JOIN con_facultades ON (expediente.con_facultades_id=con_facultades.id)
                          WHERE     expediente.`res_rectoral_fecha` is not null
                          GROUP BY  year(`expediente`.`res_rectoral_fecha`) ";
                   }       
           $stmt = $con->createStatement();
           $rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_NUM); //return self::populateObjects($rs);
           return $rs;                                
        }


        static public function getExpEmitidosporAnioxFacultad($fac=''){
           $con = Propel::getConnection(self::DATABASE_NAME);
           $sql="  SELECT  con_facultades.nombre_largo as facultad,
                           year(`expediente`.`res_rectoral_fecha`) as 'Ao', 
                           count(expediente.`res_rectoral_fecha`) AS 'Cantidad Emitidos'
                        FROM expediente  INNER JOIN con_carreras on (con_carreras.`id` = expediente.`con_carreras_id`)
                                         INNER JOIN con_facultades ON (expediente.con_facultades_id=con_facultades.id)
                        WHERE     expediente.`res_rectoral_fecha` is not null and expediente.con_facultades_id = $fac
                        GROUP BY       con_facultades.nombre_largo,
                                       year(`expediente`.`res_rectoral_fecha`) ";
           $stmt = $con->createStatement();
           $rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_NUM); //return self::populateObjects($rs);
           return $rs;                                
        }
 

        static public function getExpIngresadosyEmitidos($fac=''){
        $con = Propel::getConnection(self::DATABASE_NAME);
                $sql="SELECT  z.facultad,
                                z.anio, 
                                sum(z.entradas) as entradas,  
                                sum(z.salidas) as salidas
                        FROM (
                        (
                        select  `con_facultades`.`nombre_largo` as facultad,
                                year(`expediente`.`fecha_inicio`) as 'Anio',
                                count(expediente .id) as entradas,
                                0 as salidas
                        from  expediente inner join con_facultades on `expediente`.`con_facultades_id` = `con_facultades`.`id`
                        where expediente.`con_facultades_id` = $fac
                        group by  year(`expediente`.`fecha_inicio`)
                        )
                        union 
                        (
                        select  `con_facultades`.`nombre_largo`,
                                year(`expediente`.`fecha_inicio`),
                                0,
                                count(expediente .id)
                        from  expediente inner join con_facultades on `expediente`.`con_facultades_id` = `con_facultades`.`id`
                        where (year(`expediente`.`fecha_inicio`) = year(`expediente`.`res_rectoral_fecha`))
                              and expediente.`con_facultades_id` = $fac  
                        group by  year(`expediente`.`fecha_inicio`)
                        )
                        ) z
                        group by z.anio,
                                 z.facultad";
           $stmt = $con->createStatement();
           $rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_NUM); //return self::populateObjects($rs);
           return $rs;                                
        }


}


