<?php
/**
 * Subclass for performing query and update operations on the 'notificacion' table.
 * @package lib.model
*/ 
class NotificacionPeer extends BaseNotificacionPeer
{

 static public function getNotificaciones( Criteria $criteria,$id)   
 {  
     $criteria = clone $criteria;  // Clonamos el objeto para evitar modificar el original
     $criteria->clearSelectColumns(); // Eliminamos la columnas de seleccion en caso de que esten definidas

     // Agregamos las columnas de las tablas que queremos recuperar  
     $criteria->addSelectColumn(self::FECHA);   
     $criteria->addSelectColumn(self::REFERENCIA);
     $criteria->addSelectColumn(self::ENVIADA);
     $criteria->addSelectColumn(ConsejeroPeer::ID);                
     $criteria->addSelectColumn(ConsejeroPeer::NOMBRE);
     $criteria->addSelectColumn(self::CUERPO);  
     $criteria->addSelectColumn(ConsejeroPeer::DIRECCION);
     $criteria->addSelectColumn(ConsejeroPeer::APELLIDO);
     $criteria->addSelectColumn(self::ADJUNTOS);

     // Hacemos joins
     $criteria->addJoin(self::ID,NotificacionConsejeroPeer::NOTIFICACION_ID);  
     $criteria->addJoin(NotificacionConsejeroPeer::CONSEJERO_ID,ConsejeroPeer::ID);
     // Agregamos el filtro por el que queremos traer el listado de notificaciones.
     $criteria->add(self::ID,$id);
     $rs = self::doSelectRS($criteria);  
     return $rs;
  }      

 static public function getNotifComision( Criteria $criteria,$id)   
 {  
     $criteria = clone $criteria;  // Clonamos el objeto para evitar modificar el original
     $criteria->clearSelectColumns(); // Eliminamos la columnas de seleccion en caso de que esten definidas

     // Agregamos las columnas de las tablas que queremos recuperar  
     $criteria->addSelectColumn(self::FECHA);   
     $criteria->addSelectColumn(self::REFERENCIA);
     $criteria->addSelectColumn(self::ENVIADA);
     $criteria->addSelectColumn(ComisionPeer::ID);
     $criteria->addSelectColumn(ComisionPeer::NOMBRE);
     $criteria->addSelectColumn(self::CUERPO);
     $criteria->addSelectColumn(ConsejeroPeer::NOMBRE);
     $criteria->addSelectColumn(ConsejeroPeer::APELLIDO);
     $criteria->addSelectColumn(self::ADJUNTOS);

     // Hacemos joins
     $criteria->addJoin(self::ID,NotificacionComisionPeer::NOTIFICACION_ID);  
     $criteria->addJoin(NotificacionComisionPeer::COMISION_ID,ComisionPeer::ID);
     $criteria->addJoin(ComisionPeer::CONSEJERO_ID,ConsejeroPeer::ID);
          
     // Agregamos el filtro por el que queremos traer el listado de notificaciones.
     $criteria->add(self::ID,$id);
     $rs = self::doSelectRS($criteria);  
     return $rs;
  }      



}
