<?php

/**
 * Subclass for representing a row from the 'personal' table.
 *
 * 
 *
 * @package lib.model
 */ 
class Personal extends BasePersonal
{

        public function __toString()
        {
                return  strtoupper($this->getApellido().', '.$this->getNombre());
        }
        
        public function getNombreCompleto()
        {
                return  strtoupper($this->getApellido().', '.$this->getNombre());
        }
        
        public function getEdad(){
            if($this->getFechaNac())
              return round($this->dateDiff("/", date("d/m/Y"), $this->getFechaNac())/365, 0) . " aos";
        }
        
        public function dateDiff($dformat, $endDate, $beginDate)
        {
                $date_parts1=explode($dformat, $beginDate);
                $date_parts2=explode($dformat, $endDate);
                $start_date=gregoriantojd($date_parts1[0], $date_parts1[1], $date_parts1[2]);
                $end_date=gregoriantojd($date_parts2[0], $date_parts2[1], $date_parts2[2]);
                return $end_date - $start_date;
        }

}