<?php

/**
    * Subclass for performing query and update operations on the 'personal_licencias' table.
    *
    * 
    *
    * @package lib.model
*/ 
 
class PersonalLicenciasPeer extends BasePersonalLicenciasPeer
{
    static public function getLibre( Criteria $criteria,$personal_id, $fecha_inasistencia)   
    {  
        $criteria = clone $criteria;
        $criteria->clearSelectColumns(); 
        $fecha_inasistencia=date('Y-m-d', strtotime($fecha_inasistencia));
        $criteria->add(self::PERSONAL_ID,$personal_id);
        $criteria->add(self::FECHA_INICIO, "'{$fecha_inasistencia}' between ".self::FECHA_INICIO." and ".self::FECHA_FIN, Criteria::CUSTOM);
        $rs = self::doCount($criteria);//$rs = self::doSelectRS($criteria);
        return $rs;
    }
               
    static public function getLicencias( Criteria $criteria, $personal_id, $fecha_inicio, $fecha_fin)
    {             
        $criteria = clone $criteria;
        $criteria->clearSelectColumns();
        $criteria->addSelectColumn(self::ID);
        $fecha_inicio=date('Y-m-d', strtotime($fecha_inicio));
        $fecha_fin=date('Y-m-d', strtotime($fecha_fin));
        
        $criteria->add(self::PERSONAL_ID,$personal_id);
        $criteria->add(self::FECHA_INICIO, "'{$fecha_inicio}' between ".self::FECHA_INICIO." and ".self::FECHA_FIN, Criteria::CUSTOM);
        $criteria->addOr(self::FECHA_INICIO, "'{$fecha_fin}' between ".self::FECHA_INICIO." and ".self::FECHA_FIN, Criteria::CUSTOM);
        $rs = self::doCount($criteria);
        return $rs;
    }

    static public function getAnexoMedico( Criteria $criteria, $id)
    {  
     $criteria = clone $criteria;  // Clonamos el objeto para evitar modificar el original
     $criteria->clearSelectColumns(); // Eliminamos la columnas de seleccion en caso de que esten definidas

     // Agregamos las columnas de las tablas que queremos recuperar

     $criteria->addSelectColumn(PersonalPeer::ID);
     $criteria->addSelectColumn(PersonalPeer::APELLIDO);
     $criteria->addSelectColumn(PersonalPeer::NOMBRE);
     $criteria->addSelectColumn(PersonalPeer::DIRECCION);
     $criteria->addSelectColumn(self::FECHA_INICIO);
     $criteria->addSelectColumn(self::LICENCIA_TIPO_ID);

     $criteria->addSelectColumn(PersonalPeer::DIR_CALLE);
     $criteria->addSelectColumn(PersonalPeer::DIR_BARRIO);
     $criteria->addSelectColumn(PersonalPeer::DIR_MANZANA);
     $criteria->addSelectColumn(PersonalPeer::DIR_LOTE);
     $criteria->addSelectColumn(PersonalPeer::DIR_MONOBLOCK);
     $criteria->addSelectColumn(PersonalPeer::DIR_PISO);
     $criteria->addSelectColumn(PersonalPeer::DIR_DPTO);
     $criteria->addSelectColumn(PersonalPeer::DIR_PUNTODEREFERENCIA);
     $criteria->addSelectColumn(PersonalPeer::DIR_OTROSDATOS);
     $criteria->addSelectColumn(PersonalPeer::DIR_NRO);
     $criteria->addSelectColumn(self::FAMILIAR_ID);
     $criteria->addSelectColumn(PersonalPeer::LEGAJO);
     $criteria->addSelectColumn(PersonalPeer::DNI);
     $criteria->addSelectColumn(LicenciaTipoPeer::NOMBRE);
     
     
     $criteria->addSelectColumn(FamiliarPeer::APELLIDO);
     $criteria->addSelectColumn(FamiliarPeer::NOMBRE);
     $criteria->addSelectColumn(FamiliarPeer::FECHA_NAC);
     $criteria->addSelectColumn(ParentescoPeer::NOMBRE);
     
     // Hacemos joins
     $criteria->addJoin(self::PERSONAL_ID,PersonalPeer::ID);
     $criteria->addJoin(self::LICENCIA_TIPO_ID,LicenciaTipoPeer::ID);
     $criteria->addJoin(self::FAMILIAR_ID,FamiliarPeer::ID,Criteria::LEFT_JOIN);
     $criteria->addJoin(FamiliarPeer::PARENTESCO_ID,ParentescoPeer::ID,Criteria::LEFT_JOIN);

     if ($id != 0){
        $criteria->add(self::ID,$id);//$criteria->add(self::LICENCIA_TIPO_ID,4);
     }else{
             $fecha=date('Y-m-d');
             $criteria->add(LicenciaTipoPeer::ANEXO,'anexo2');//$criteria->add(self::LICENCIA_TIPO_ID,4);
             $criteria->add(self::FECHA_INICIO,$fecha);
           }
     $rs = self::doSelectRS($criteria);  
     return $rs;
  }          


    static public function getLicenciaslistado( Criteria $criteria) //, $fecha_inicio, $fecha_fin)
    {        $criteria->addSelectColumn(PersonalPeer::ID);
             $criteria->addSelectColumn(PersonalPeer::APELLIDO);
             $criteria->addSelectColumn(PersonalPeer::NOMBRE);
             $criteria->addSelectColumn(self::FECHA_INICIO);
             $criteria->addSelectColumn(self::FECHA_FIN);
             $criteria->addSelectColumn(self::LICENCIA_TIPO_ID);
             $criteria->addSelectColumn(self::OBSERVACIONES);
             $criteria->addSelectColumn(LicenciaTipoPeer::NOMBRE);
        $criteria->addJoin(self::PERSONAL_ID,PersonalPeer::ID,Criteria::LEFT_JOIN);
        $criteria->addJoin(self::LICENCIA_TIPO_ID,LicenciaTipoPeer::ID,Criteria::LEFT_JOIN);  //$criteria->add(self::PERSONAL_ID,$personal_id);
        
        $rs = self::doSelectRS($criteria);  
        return $rs;
   }


}
