<?php
/**
 * Subclass for performing query and update operations on the 'personal' table.
 *
 * 
 *
 * @package lib.model
 */ 
class PersonalPeer extends BasePersonalPeer
{

      public static function doSelectBirthdays(Criteria $criteria)
      {
          $con = Propel::getConnection(self::DATABASE_NAME);
          $criteria = clone $criteria;
          //$criteria->clearSelectColumns(); //expediente.con_facultades_id,
          
          $sql= " SELECT DATE_FORMAT(TIMESTAMP(personal.FECHA_NAC),'%e/%c') as fecha 
                  FROM personal 
                  WHERE DAYOFYEAR( curdate( )-7 ) <= dayofyear(`fecha_nac`) AND DAYOFYEAR( curdate( ) ) +15 >= dayofyear(`fecha_nac`)
                  ORDER BY month(personal.FECHA_NAC) asc,
                             day(personal.FECHA_NAC) asc ";
                  //DATE_FORMAT(TIMESTAMP(personal.FECHA_NAC),'%e/%c') asc ";
          $stmt = $con->createStatement();
          $rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_NUM);
          //return self::populateObjects($rs);
          return $rs;                  
      }
      
        static public function getListadelDia( Criteria $criteria)   
         {  

             $criteria = clone $criteria;  // Clonamos el objeto para evitar modificar el original
             $criteria->clearSelectColumns(); // Eliminamos la columnas de seleccion en caso de que esten definidas

             // Agregamos las columnas de las tablas que queremos recuperar  
                $criteria->addSelectColumn(self::NOMBRE);
                $criteria->addSelectColumn(self::APELLIDO);
                $criteria->addSelectColumn(PersonalTurnoPeer::HORA_ENTRADA);
                $criteria->addSelectColumn(PersonalTurnoPeer::HORA_SALIDA);
                $criteria->addSelectColumn(TurnoPeer::NOMBRE);

                $criteria->add(self::ACTIVO, true);
                $criteria->addAscendingOrderByColumn(self::APELLIDO);
                $criteria->addAscendingOrderByColumn(self::NOMBRE);
                $criteria->addAscendingOrderByColumn(TurnoPeer::NOMBRE);

                // Hacemos joins
                $criteria->addJoin(self::ID,PersonalTurnoPeer::PERSONAL_ID,Criteria::LEFT_JOIN);
                $criteria->addJoin(PersonalTurnoPeer::TURNO_ID, TurnoPeer::ID, Criteria::LEFT_JOIN);

                $rs = self::doSelectRS($criteria);  
             return $rs;
          }      
    
    public static function getLordenada($criteria = NULL) {
        if((!($criteria instanceof Criteria)) OR is_null($criteria))
            $criteria = new Criteria(); 
        $criteria->addAscendingOrderByColumn(PersonalPeer::APELLIDO);
        $agentes = PersonalPeer::doSelect($criteria);
        return $agentes;
    }

}
