<?php

/**
 * Subclass for performing query and update operations on the 'personal_turno' table.
 *
 * 
 *
 * @package lib.model
 */ 
class PersonalTurnoPeer extends BasePersonalTurnoPeer
{

         static public function getListadelDia( Criteria $criteria)   
         {  
             //$notificaciones = array();  
             $criteria = clone $criteria;  // Clonamos el objeto para evitar modificar el original
             $criteria->clearSelectColumns(); // Eliminamos la columnas de seleccion en caso de que esten definidas

             // Agregamos las columnas de las tablas que queremos recuperar  
                $criteria->addSelectColumn(PersonalPeer::NOMBRE);
                $criteria->addSelectColumn(PersonalPeer::APELLIDO);
                $criteria->addSelectColumn(self::HORA_ENTRADA);
                $criteria->addSelectColumn(self::HORA_SALIDA);
                $criteria->addSelectColumn(TurnoPeer::NOMBRE);

                $criteria->add(PersonalPeer::ACTIVO, true);
                $criteria->add(PersonalTurnoPeer::ACTIVO, true);
                
                $criteria->addAscendingOrderByColumn(PersonalPeer::APELLIDO);
                $criteria->addAscendingOrderByColumn(PersonalPeer::NOMBRE);
                $criteria->addAscendingOrderByColumn(TurnoPeer::NOMBRE);


                // Hacemos joins
                $criteria->addJoin(self::PERSONAL_ID,PersonalPeer::ID,Criteria::LEFT_JOIN);
                //$criteria->addJoin(NotificacionConsejeroPeer::CONSEJERO_ID,ConsejeroPeer::ID);
                $criteria->addJoin(self::TURNO_ID, TurnoPeer::ID,Criteria::LEFT_JOIN);

                $rs = self::doSelectRS($criteria);  
             return $rs;
          }      


}
