<?php



class ArtAlumnoMapBuilder {

	
	const CLASS_NAME = 'lib.model.map.ArtAlumnoMapBuilder';

	
	private $dbMap;

	
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap('propel');

		$tMap = $this->dbMap->addTable('art_alumno');
		$tMap->setPhpName('ArtAlumno');

		$tMap->setUseIdGenerator(true);

		$tMap->addPrimaryKey('ID', 'Id', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addColumn('NOMBRE', 'Nombre', 'string', CreoleTypes::VARCHAR, false, 100);

		$tMap->addColumn('APELLIDO', 'Apellido', 'string', CreoleTypes::VARCHAR, false, 100);

		$tMap->addColumn('FECHA_NAC', 'FechaNac', 'int', CreoleTypes::DATE, false, null);

		$tMap->addColumn('DOMICILIO', 'Domicilio', 'string', CreoleTypes::VARCHAR, false, 50);

		$tMap->addColumn('DNI', 'Dni', 'string', CreoleTypes::VARCHAR, false, 20);

		$tMap->addColumn('TELEFONO', 'Telefono', 'string', CreoleTypes::VARCHAR, false, 30);

		$tMap->addColumn('EMAIL', 'Email', 'string', CreoleTypes::VARCHAR, false, 50);

		$tMap->addForeignKey('CON_LOCALIDADES_ID', 'ConLocalidadesId', 'int', CreoleTypes::INTEGER, 'con_localidades', 'ID', false, null);

		$tMap->addForeignKey('ESCUELA_TURNO_ID', 'EscuelaTurnoId', 'int', CreoleTypes::INTEGER, 'turno', 'ID', true, null);

		$tMap->addColumn('ESCUELA_NOMBRE', 'EscuelaNombre', 'string', CreoleTypes::VARCHAR, false, 255);

		$tMap->addColumn('ESCUELA_DOMICILIO', 'EscuelaDomicilio', 'string', CreoleTypes::VARCHAR, false, 255);

		$tMap->addForeignKey('ESCUELA_CON_PROVINCIAS_ID', 'EscuelaConProvinciasId', 'int', CreoleTypes::INTEGER, 'con_provincias', 'ID', true, null);

		$tMap->addForeignKey('ESCUELA_CON_LOCALIDADES_ID', 'EscuelaConLocalidadesId', 'int', CreoleTypes::INTEGER, 'con_localidades', 'ID', true, null);

		$tMap->addColumn('ESCUELA_EGRESO', 'EscuelaEgreso', 'int', CreoleTypes::INTEGER, false, 50);

		$tMap->addColumn('ESCUELA_MODALIDAD', 'EscuelaModalidad', 'string', CreoleTypes::VARCHAR, false, 100);

		$tMap->addColumn('ESCUELA_PENDIENTES', 'EscuelaPendientes', 'string', CreoleTypes::VARCHAR, false, 255);

		$tMap->addColumn('OTROS_ORIENTACION', 'OtrosOrientacion', 'boolean', CreoleTypes::BOOLEAN, false, null);

		$tMap->addColumn('OTROS_INFORMATICA', 'OtrosInformatica', 'boolean', CreoleTypes::BOOLEAN, false, null);

		$tMap->addColumn('OTROS_TRABAJA', 'OtrosTrabaja', 'string', CreoleTypes::VARCHAR, false, 255);

		$tMap->addColumn('OTROS_INFORMATICA_CUALES', 'OtrosInformaticaCuales', 'string', CreoleTypes::VARCHAR, false, 255);

		$tMap->addColumn('CARRERA_INTERESADO', 'CarreraInteresado', 'string', CreoleTypes::VARCHAR, false, 255);

		$tMap->addColumn('SEDE_CURSADO', 'SedeCursado', 'string', CreoleTypes::VARCHAR, false, 100);

		$tMap->addForeignKey('CON_PROVINCIAS_ID', 'ConProvinciasId', 'int', CreoleTypes::INTEGER, 'con_provincias', 'ID', false, null);

		$tMap->addColumn('ANIO', 'Anio', 'int', CreoleTypes::INTEGER, false, 11);

	} 
} 