<?php



class ConsejeroMapBuilder {

	
	const CLASS_NAME = 'lib.model.map.ConsejeroMapBuilder';

	
	private $dbMap;

	
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap('propel');

		$tMap = $this->dbMap->addTable('consejero');
		$tMap->setPhpName('Consejero');

		$tMap->setUseIdGenerator(true);

		$tMap->addPrimaryKey('ID', 'Id', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addColumn('NOMBRE', 'Nombre', 'string', CreoleTypes::VARCHAR, false, 50);

		$tMap->addColumn('APELLIDO', 'Apellido', 'string', CreoleTypes::VARCHAR, false, 50);

		$tMap->addColumn('DIRECCION', 'Direccion', 'string', CreoleTypes::VARCHAR, false, 100);

		$tMap->addColumn('DNI', 'Dni', 'string', CreoleTypes::VARCHAR, false, 20);

		$tMap->addColumn('TELEFONO', 'Telefono', 'string', CreoleTypes::VARCHAR, false, 30);

		$tMap->addColumn('EMAIL', 'Email', 'string', CreoleTypes::VARCHAR, false, 50);

		$tMap->addColumn('LUGAR_NAC', 'LugarNac', 'string', CreoleTypes::VARCHAR, false, 50);

		$tMap->addColumn('FECHA_NAC', 'FechaNac', 'int', CreoleTypes::DATE, false, null);

		$tMap->addColumn('NACIONALIDAD', 'Nacionalidad', 'string', CreoleTypes::VARCHAR, false, 50);

		$tMap->addForeignKey('CON_ESTADO_CIVIL_ID', 'ConEstadoCivilId', 'int', CreoleTypes::INTEGER, 'con_estado_civil', 'ID', false, null);

		$tMap->addForeignKey('CON_LOCALIDADES_ID', 'ConLocalidadesId', 'int', CreoleTypes::INTEGER, 'con_localidades', 'ID', false, null);

		$tMap->addForeignKey('CON_PROVINCIAS_ID', 'ConProvinciasId', 'int', CreoleTypes::INTEGER, 'con_provincias', 'ID', false, null);

		$tMap->addForeignKey('FACULTAD_ID', 'FacultadId', 'int', CreoleTypes::INTEGER, 'con_facultades', 'ID', false, null);

	} 
} 