<?php



class ExpedienteMapBuilder {

	
	const CLASS_NAME = 'lib.model.map.ExpedienteMapBuilder';

	
	private $dbMap;

	
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap('propel');

		$tMap = $this->dbMap->addTable('expediente');
		$tMap->setPhpName('Expediente');

		$tMap->setUseIdGenerator(true);

		$tMap->addPrimaryKey('ID', 'Id', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addForeignKey('CON_FACULTADES_ID', 'ConFacultadesId', 'int', CreoleTypes::INTEGER, 'con_facultades', 'ID', false, null);

		$tMap->addForeignKey('CON_CARRERAS_ID', 'ConCarrerasId', 'int', CreoleTypes::INTEGER, 'con_carreras', 'ID', false, null);

		$tMap->addForeignKey('ALUMNO_ID', 'AlumnoId', 'int', CreoleTypes::INTEGER, 'alumno', 'ID', false, null);

		$tMap->addColumn('NRO_EXP_FAC', 'NroExpFac', 'string', CreoleTypes::VARCHAR, false, 45);

		$tMap->addColumn('FECHA_INICIO', 'FechaInicio', 'int', CreoleTypes::DATE, false, null);

		$tMap->addColumn('FECHA_PASE_MINISTERIO', 'FechaPaseMinisterio', 'int', CreoleTypes::DATE, false, null);

		$tMap->addColumn('FECHA_RECIBIDO_MINISTERIO', 'FechaRecibidoMinisterio', 'int', CreoleTypes::DATE, false, null);

		$tMap->addColumn('FECHA_PASE_SEC_ADM', 'FechaPaseSecAdm', 'int', CreoleTypes::DATE, false, null);

		$tMap->addColumn('FECHA_RECIBIDO_SEC_ADM', 'FechaRecibidoSecAdm', 'int', CreoleTypes::DATE, false, null);

		$tMap->addColumn('FECHA_RETIRO_FAC', 'FechaRetiroFac', 'int', CreoleTypes::DATE, false, null);

		$tMap->addColumn('CREATED_AT', 'CreatedAt', 'int', CreoleTypes::TIMESTAMP, false, null);

		$tMap->addColumn('OBSERVACIONES', 'Observaciones', 'string', CreoleTypes::LONGVARCHAR, false, null);

		$tMap->addColumn('RES_RECTORAL', 'ResRectoral', 'int', CreoleTypes::INTEGER, false, null);

		$tMap->addColumn('RES_RECTORAL_FECHA', 'ResRectoralFecha', 'int', CreoleTypes::DATE, false, null);

		$tMap->addColumn('FECHA_EGRESO_ALUMNO', 'FechaEgresoAlumno', 'int', CreoleTypes::DATE, false, null);

		$tMap->addColumn('REG_UNIVERSITARIO', 'RegUniversitario', 'string', CreoleTypes::VARCHAR, false, 45);

	} 
} 