<?php



class FamiliarMapBuilder {

	
	const CLASS_NAME = 'lib.model.map.FamiliarMapBuilder';

	
	private $dbMap;

	
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap('propel');

		$tMap = $this->dbMap->addTable('familiar');
		$tMap->setPhpName('Familiar');

		$tMap->setUseIdGenerator(true);

		$tMap->addPrimaryKey('ID', 'Id', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addColumn('DNI', 'Dni', 'int', CreoleTypes::INTEGER, false, null);

		$tMap->addForeignKey('PERSONAL_ID', 'PersonalId', 'int', CreoleTypes::INTEGER, 'personal', 'ID', false, null);

		$tMap->addColumn('APELLIDO', 'Apellido', 'string', CreoleTypes::VARCHAR, false, 50);

		$tMap->addColumn('NOMBRE', 'Nombre', 'string', CreoleTypes::VARCHAR, false, 50);

		$tMap->addForeignKey('SEXO_ID', 'SexoId', 'int', CreoleTypes::INTEGER, 'sexo', 'ID', false, null);

		$tMap->addColumn('FECHA_NAC', 'FechaNac', 'int', CreoleTypes::DATE, false, null);

		$tMap->addForeignKey('PARENTESCO_ID', 'ParentescoId', 'int', CreoleTypes::INTEGER, 'parentesco', 'ID', false, null);

		$tMap->addColumn('OBSERVACIONES', 'Observaciones', 'string', CreoleTypes::LONGVARCHAR, false, null);

	} 
} 