<?php



class PersonalInasistenciasMapBuilder {

	
	const CLASS_NAME = 'lib.model.map.PersonalInasistenciasMapBuilder';

	
	private $dbMap;

	
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap('propel');

		$tMap = $this->dbMap->addTable('personal_inasistencias');
		$tMap->setPhpName('PersonalInasistencias');

		$tMap->setUseIdGenerator(true);

		$tMap->addPrimaryKey('ID', 'Id', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addColumn('ID_ESTABLECIMIENTO', 'IdEstablecimiento', 'int', CreoleTypes::INTEGER, false, null);

		$tMap->addForeignKey('PERSONAL_ID', 'PersonalId', 'int', CreoleTypes::INTEGER, 'personal', 'ID', true, null);

		$tMap->addForeignKey('INASISTENCIA_TIPO_ID', 'InasistenciaTipoId', 'int', CreoleTypes::INTEGER, 'inasistencia_tipo', 'ID', false, null);

		$tMap->addColumn('HORA_ENTRADA', 'HoraEntrada', 'int', CreoleTypes::TIME, false, null);

		$tMap->addColumn('HORA_SALIDA', 'HoraSalida', 'int', CreoleTypes::TIME, false, null);

		$tMap->addColumn('FECHA', 'Fecha', 'int', CreoleTypes::DATE, true, null);

		$tMap->addColumn('OBSERVACIONES', 'Observaciones', 'string', CreoleTypes::LONGVARCHAR, false, 255);

		$tMap->addForeignKey('TURNO_ID', 'TurnoId', 'int', CreoleTypes::INTEGER, 'turno', 'ID', false, null);

		$tMap->addColumn('CARGO_ID', 'CargoId', 'int', CreoleTypes::INTEGER, false, null);

		$tMap->addColumn('CANTIDAD_DIAS', 'CantidadDias', 'int', CreoleTypes::INTEGER, true, null);

	} 
} 