<?php



class PersonalLicenciasMapBuilder {

	
	const CLASS_NAME = 'lib.model.map.PersonalLicenciasMapBuilder';

	
	private $dbMap;

	
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap('propel');

		$tMap = $this->dbMap->addTable('personal_licencias');
		$tMap->setPhpName('PersonalLicencias');

		$tMap->setUseIdGenerator(true);

		$tMap->addPrimaryKey('ID', 'Id', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addColumn('ID_ESTABLECIMIENTO', 'IdEstablecimiento', 'int', CreoleTypes::INTEGER, false, null);

		$tMap->addForeignKey('PERSONAL_ID', 'PersonalId', 'int', CreoleTypes::INTEGER, 'personal', 'ID', false, null);

		$tMap->addForeignKey('LICENCIA_TIPO_ID', 'LicenciaTipoId', 'int', CreoleTypes::INTEGER, 'licencia_tipo', 'ID', false, null);

		$tMap->addColumn('FECHA_INICIO', 'FechaInicio', 'int', CreoleTypes::DATE, false, null);

		$tMap->addColumn('FECHA_FIN', 'FechaFin', 'int', CreoleTypes::DATE, false, null);

		$tMap->addColumn('OBSERVACIONES', 'Observaciones', 'string', CreoleTypes::LONGVARCHAR, false, 255);

		$tMap->addForeignKey('FAMILIAR_ID', 'FamiliarId', 'int', CreoleTypes::INTEGER, 'familiar', 'ID', false, null);

		$tMap->addColumn('CARGO_ID', 'CargoId', 'int', CreoleTypes::INTEGER, false, null);

		$tMap->addColumn('CANTIDAD_DIAS', 'CantidadDias', 'int', CreoleTypes::INTEGER, true, null);

	} 
} 