<?php



class PersonalMapBuilder {

	
	const CLASS_NAME = 'lib.model.map.PersonalMapBuilder';

	
	private $dbMap;

	
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap('propel');

		$tMap = $this->dbMap->addTable('personal');
		$tMap->setPhpName('Personal');

		$tMap->setUseIdGenerator(true);

		$tMap->addPrimaryKey('ID', 'Id', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addColumn('DNI', 'Dni', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addColumn('CUIL', 'Cuil', 'string', CreoleTypes::VARCHAR, false, 20);

		$tMap->addColumn('REPARTICION', 'Reparticion', 'string', CreoleTypes::VARCHAR, false, 50);

		$tMap->addColumn('LEGAJO', 'Legajo', 'string', CreoleTypes::VARCHAR, false, 20);

		$tMap->addForeignKey('SEXO_ID', 'SexoId', 'int', CreoleTypes::INTEGER, 'sexo', 'ID', false, null);

		$tMap->addColumn('APELLIDO', 'Apellido', 'string', CreoleTypes::VARCHAR, true, 50);

		$tMap->addColumn('NOMBRE', 'Nombre', 'string', CreoleTypes::VARCHAR, true, 50);

		$tMap->addColumn('FECHA_NAC', 'FechaNac', 'int', CreoleTypes::DATE, false, null);

		$tMap->addColumn('DIRECCION', 'Direccion', 'string', CreoleTypes::VARCHAR, false, 50);

		$tMap->addColumn('DIR_BARRIO', 'DirBarrio', 'string', CreoleTypes::VARCHAR, false, 50);

		$tMap->addColumn('DIR_CALLE', 'DirCalle', 'string', CreoleTypes::VARCHAR, false, 50);

		$tMap->addColumn('DIR_NRO', 'DirNro', 'string', CreoleTypes::VARCHAR, false, 10);

		$tMap->addColumn('DIR_MANZANA', 'DirManzana', 'string', CreoleTypes::VARCHAR, false, 50);

		$tMap->addColumn('DIR_LOTE', 'DirLote', 'string', CreoleTypes::VARCHAR, false, 50);

		$tMap->addColumn('DIR_MONOBLOCK', 'DirMonoblock', 'string', CreoleTypes::VARCHAR, false, 50);

		$tMap->addColumn('DIR_PISO', 'DirPiso', 'string', CreoleTypes::VARCHAR, false, 50);

		$tMap->addColumn('DIR_DPTO', 'DirDpto', 'string', CreoleTypes::VARCHAR, false, 50);

		$tMap->addColumn('DIR_PUNTODEREFERENCIA', 'DirPuntodereferencia', 'string', CreoleTypes::VARCHAR, false, 50);

		$tMap->addColumn('DIR_OTROSDATOS', 'DirOtrosdatos', 'string', CreoleTypes::VARCHAR, false, 50);

		$tMap->addColumn('TELEFONO', 'Telefono', 'string', CreoleTypes::VARCHAR, false, 50);

		$tMap->addForeignKey('CON_PROVINCIAS_ID', 'ConProvinciasId', 'int', CreoleTypes::INTEGER, 'con_provincias', 'ID', false, null);

		$tMap->addForeignKey('CON_LOCALIDADES_ID', 'ConLocalidadesId', 'int', CreoleTypes::INTEGER, 'con_localidades', 'ID', false, null);

		$tMap->addColumn('EMAIL', 'Email', 'string', CreoleTypes::VARCHAR, false, 50);

		$tMap->addColumn('OBSERVACIONES', 'Observaciones', 'string', CreoleTypes::LONGVARCHAR, false, null);

		$tMap->addColumn('HS_CUMPLE', 'HsCumple', 'int', CreoleTypes::TIME, true, null);

		$tMap->addColumn('HS_ENTRADA', 'HsEntrada', 'int', CreoleTypes::TIME, true, null);

		$tMap->addColumn('HS_SALIDA', 'HsSalida', 'int', CreoleTypes::TIME, true, null);

		$tMap->addColumn('ACTIVO', 'Activo', 'boolean', CreoleTypes::BOOLEAN, false, null);

	} 
} 