<?php



class PersonalTurnoMapBuilder {

	
	const CLASS_NAME = 'lib.model.map.PersonalTurnoMapBuilder';

	
	private $dbMap;

	
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap('propel');

		$tMap = $this->dbMap->addTable('personal_turno');
		$tMap->setPhpName('PersonalTurno');

		$tMap->setUseIdGenerator(true);

		$tMap->addPrimaryKey('ID', 'Id', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addForeignKey('TURNO_ID', 'TurnoId', 'int', CreoleTypes::INTEGER, 'turno', 'ID', false, null);

		$tMap->addForeignKey('PERSONAL_ID', 'PersonalId', 'int', CreoleTypes::INTEGER, 'personal', 'ID', false, null);

		$tMap->addColumn('HORA_ENTRADA', 'HoraEntrada', 'int', CreoleTypes::TIME, true, null);

		$tMap->addColumn('HORA_SALIDA', 'HoraSalida', 'int', CreoleTypes::TIME, true, null);

		$tMap->addColumn('ACTIVO', 'Activo', 'boolean', CreoleTypes::BOOLEAN, false, null);

		$tMap->addColumn('OBSERVACIONES', 'Observaciones', 'string', CreoleTypes::LONGVARCHAR, false, null);

	} 
} 