<?php


abstract class BaseAlumno extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $nombre;


	
	protected $apellido;


	
	protected $dni;


	
	protected $nacionalidad;

	
	protected $collExpedientes;

	
	protected $lastExpedienteCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getNombre()
	{

		return $this->nombre;
	}

	
	public function getApellido()
	{

		return $this->apellido;
	}

	
	public function getDni()
	{

		return $this->dni;
	}

	
	public function getNacionalidad()
	{

		return $this->nacionalidad;
	}

	
	public function setId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = AlumnoPeer::ID;
		}

	} 
	
	public function setNombre($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->nombre !== $v) {
			$this->nombre = $v;
			$this->modifiedColumns[] = AlumnoPeer::NOMBRE;
		}

	} 
	
	public function setApellido($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->apellido !== $v) {
			$this->apellido = $v;
			$this->modifiedColumns[] = AlumnoPeer::APELLIDO;
		}

	} 
	
	public function setDni($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->dni !== $v) {
			$this->dni = $v;
			$this->modifiedColumns[] = AlumnoPeer::DNI;
		}

	} 
	
	public function setNacionalidad($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->nacionalidad !== $v) {
			$this->nacionalidad = $v;
			$this->modifiedColumns[] = AlumnoPeer::NACIONALIDAD;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->nombre = $rs->getString($startcol + 1);

			$this->apellido = $rs->getString($startcol + 2);

			$this->dni = $rs->getInt($startcol + 3);

			$this->nacionalidad = $rs->getString($startcol + 4);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 5; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Alumno object", $e);
		}
	}

	
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BaseAlumno:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(AlumnoPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			AlumnoPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseAlumno:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BaseAlumno:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(AlumnoPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseAlumno:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = AlumnoPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += AlumnoPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collExpedientes !== null) {
				foreach($this->collExpedientes as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = AlumnoPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collExpedientes !== null) {
					foreach($this->collExpedientes as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = AlumnoPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getNombre();
				break;
			case 2:
				return $this->getApellido();
				break;
			case 3:
				return $this->getDni();
				break;
			case 4:
				return $this->getNacionalidad();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = AlumnoPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getNombre(),
			$keys[2] => $this->getApellido(),
			$keys[3] => $this->getDni(),
			$keys[4] => $this->getNacionalidad(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = AlumnoPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setNombre($value);
				break;
			case 2:
				$this->setApellido($value);
				break;
			case 3:
				$this->setDni($value);
				break;
			case 4:
				$this->setNacionalidad($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = AlumnoPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setNombre($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setApellido($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setDni($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setNacionalidad($arr[$keys[4]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(AlumnoPeer::DATABASE_NAME);

		if ($this->isColumnModified(AlumnoPeer::ID)) $criteria->add(AlumnoPeer::ID, $this->id);
		if ($this->isColumnModified(AlumnoPeer::NOMBRE)) $criteria->add(AlumnoPeer::NOMBRE, $this->nombre);
		if ($this->isColumnModified(AlumnoPeer::APELLIDO)) $criteria->add(AlumnoPeer::APELLIDO, $this->apellido);
		if ($this->isColumnModified(AlumnoPeer::DNI)) $criteria->add(AlumnoPeer::DNI, $this->dni);
		if ($this->isColumnModified(AlumnoPeer::NACIONALIDAD)) $criteria->add(AlumnoPeer::NACIONALIDAD, $this->nacionalidad);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(AlumnoPeer::DATABASE_NAME);

		$criteria->add(AlumnoPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setNombre($this->nombre);

		$copyObj->setApellido($this->apellido);

		$copyObj->setDni($this->dni);

		$copyObj->setNacionalidad($this->nacionalidad);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getExpedientes() as $relObj) {
				$copyObj->addExpediente($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new AlumnoPeer();
		}
		return self::$peer;
	}

	
	public function initExpedientes()
	{
		if ($this->collExpedientes === null) {
			$this->collExpedientes = array();
		}
	}

	
	public function getExpedientes($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseExpedientePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collExpedientes === null) {
			if ($this->isNew()) {
			   $this->collExpedientes = array();
			} else {

				$criteria->add(ExpedientePeer::ALUMNO_ID, $this->getId());

				ExpedientePeer::addSelectColumns($criteria);
				$this->collExpedientes = ExpedientePeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(ExpedientePeer::ALUMNO_ID, $this->getId());

				ExpedientePeer::addSelectColumns($criteria);
				if (!isset($this->lastExpedienteCriteria) || !$this->lastExpedienteCriteria->equals($criteria)) {
					$this->collExpedientes = ExpedientePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastExpedienteCriteria = $criteria;
		return $this->collExpedientes;
	}

	
	public function countExpedientes($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseExpedientePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(ExpedientePeer::ALUMNO_ID, $this->getId());

		return ExpedientePeer::doCount($criteria, $distinct, $con);
	}

	
	public function addExpediente(Expediente $l)
	{
		$this->collExpedientes[] = $l;
		$l->setAlumno($this);
	}


	
	public function getExpedientesJoinFacultad($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseExpedientePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collExpedientes === null) {
			if ($this->isNew()) {
				$this->collExpedientes = array();
			} else {

				$criteria->add(ExpedientePeer::ALUMNO_ID, $this->getId());

				$this->collExpedientes = ExpedientePeer::doSelectJoinFacultad($criteria, $con);
			}
		} else {
									
			$criteria->add(ExpedientePeer::ALUMNO_ID, $this->getId());

			if (!isset($this->lastExpedienteCriteria) || !$this->lastExpedienteCriteria->equals($criteria)) {
				$this->collExpedientes = ExpedientePeer::doSelectJoinFacultad($criteria, $con);
			}
		}
		$this->lastExpedienteCriteria = $criteria;

		return $this->collExpedientes;
	}


	
	public function getExpedientesJoinCarrera($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseExpedientePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collExpedientes === null) {
			if ($this->isNew()) {
				$this->collExpedientes = array();
			} else {

				$criteria->add(ExpedientePeer::ALUMNO_ID, $this->getId());

				$this->collExpedientes = ExpedientePeer::doSelectJoinCarrera($criteria, $con);
			}
		} else {
									
			$criteria->add(ExpedientePeer::ALUMNO_ID, $this->getId());

			if (!isset($this->lastExpedienteCriteria) || !$this->lastExpedienteCriteria->equals($criteria)) {
				$this->collExpedientes = ExpedientePeer::doSelectJoinCarrera($criteria, $con);
			}
		}
		$this->lastExpedienteCriteria = $criteria;

		return $this->collExpedientes;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseAlumno:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseAlumno::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} 