<?php


abstract class BaseArtAlumno extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $nombre;


	
	protected $apellido;


	
	protected $fecha_nac;


	
	protected $domicilio;


	
	protected $dni;


	
	protected $telefono;


	
	protected $email;


	
	protected $con_localidades_id;


	
	protected $escuela_turno_id;


	
	protected $escuela_nombre;


	
	protected $escuela_domicilio;


	
	protected $escuela_con_provincias_id = 0;


	
	protected $escuela_con_localidades_id = 0;


	
	protected $escuela_egreso;


	
	protected $escuela_modalidad;


	
	protected $escuela_pendientes;


	
	protected $otros_orientacion = false;


	
	protected $otros_informatica = false;


	
	protected $otros_trabaja;


	
	protected $otros_informatica_cuales;


	
	protected $carrera_interesado;


	
	protected $sede_cursado;


	
	protected $con_provincias_id;


	
	protected $anio;

	
	protected $aLocalidadRelatedByConLocalidadesId;

	
	protected $aTurno;

	
	protected $aProvinciaRelatedByEscuelaConProvinciasId;

	
	protected $aLocalidadRelatedByEscuelaConLocalidadesId;

	
	protected $aProvinciaRelatedByConProvinciasId;

	
	protected $collArtAlumnoModulos;

	
	protected $lastArtAlumnoModuloCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getNombre()
	{

		return $this->nombre;
	}

	
	public function getApellido()
	{

		return $this->apellido;
	}

	
	public function getFechaNac($format = '%d/%m/%Y')
	{

		if ($this->fecha_nac === null || $this->fecha_nac === '') {
			return null;
		} elseif (!is_int($this->fecha_nac)) {
						$ts = strtotime($this->fecha_nac);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [fecha_nac] as date/time value: " . var_export($this->fecha_nac, true));
			}
		} else {
			$ts = $this->fecha_nac;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getDomicilio()
	{

		return $this->domicilio;
	}

	
	public function getDni()
	{

		return $this->dni;
	}

	
	public function getTelefono()
	{

		return $this->telefono;
	}

	
	public function getEmail()
	{

		return $this->email;
	}

	
	public function getConLocalidadesId()
	{

		return $this->con_localidades_id;
	}

	
	public function getEscuelaTurnoId()
	{

		return $this->escuela_turno_id;
	}

	
	public function getEscuelaNombre()
	{

		return $this->escuela_nombre;
	}

	
	public function getEscuelaDomicilio()
	{

		return $this->escuela_domicilio;
	}

	
	public function getEscuelaConProvinciasId()
	{

		return $this->escuela_con_provincias_id;
	}

	
	public function getEscuelaConLocalidadesId()
	{

		return $this->escuela_con_localidades_id;
	}

	
	public function getEscuelaEgreso()
	{

		return $this->escuela_egreso;
	}

	
	public function getEscuelaModalidad()
	{

		return $this->escuela_modalidad;
	}

	
	public function getEscuelaPendientes()
	{

		return $this->escuela_pendientes;
	}

	
	public function getOtrosOrientacion()
	{

		return $this->otros_orientacion;
	}

	
	public function getOtrosInformatica()
	{

		return $this->otros_informatica;
	}

	
	public function getOtrosTrabaja()
	{

		return $this->otros_trabaja;
	}

	
	public function getOtrosInformaticaCuales()
	{

		return $this->otros_informatica_cuales;
	}

	
	public function getCarreraInteresado()
	{

		return $this->carrera_interesado;
	}

	
	public function getSedeCursado()
	{

		return $this->sede_cursado;
	}

	
	public function getConProvinciasId()
	{

		return $this->con_provincias_id;
	}

	
	public function getAnio()
	{

		return $this->anio;
	}

	
	public function setId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = ArtAlumnoPeer::ID;
		}

	} 
	
	public function setNombre($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->nombre !== $v) {
			$this->nombre = $v;
			$this->modifiedColumns[] = ArtAlumnoPeer::NOMBRE;
		}

	} 
	
	public function setApellido($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->apellido !== $v) {
			$this->apellido = $v;
			$this->modifiedColumns[] = ArtAlumnoPeer::APELLIDO;
		}

	} 
	
	public function setFechaNac($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [fecha_nac] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->fecha_nac !== $ts) {
			$this->fecha_nac = $ts;
			$this->modifiedColumns[] = ArtAlumnoPeer::FECHA_NAC;
		}

	} 
	
	public function setDomicilio($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->domicilio !== $v) {
			$this->domicilio = $v;
			$this->modifiedColumns[] = ArtAlumnoPeer::DOMICILIO;
		}

	} 
	
	public function setDni($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->dni !== $v) {
			$this->dni = $v;
			$this->modifiedColumns[] = ArtAlumnoPeer::DNI;
		}

	} 
	
	public function setTelefono($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->telefono !== $v) {
			$this->telefono = $v;
			$this->modifiedColumns[] = ArtAlumnoPeer::TELEFONO;
		}

	} 
	
	public function setEmail($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->email !== $v) {
			$this->email = $v;
			$this->modifiedColumns[] = ArtAlumnoPeer::EMAIL;
		}

	} 
	
	public function setConLocalidadesId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->con_localidades_id !== $v) {
			$this->con_localidades_id = $v;
			$this->modifiedColumns[] = ArtAlumnoPeer::CON_LOCALIDADES_ID;
		}

		if ($this->aLocalidadRelatedByConLocalidadesId !== null && $this->aLocalidadRelatedByConLocalidadesId->getId() !== $v) {
			$this->aLocalidadRelatedByConLocalidadesId = null;
		}

	} 
	
	public function setEscuelaTurnoId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->escuela_turno_id !== $v) {
			$this->escuela_turno_id = $v;
			$this->modifiedColumns[] = ArtAlumnoPeer::ESCUELA_TURNO_ID;
		}

		if ($this->aTurno !== null && $this->aTurno->getId() !== $v) {
			$this->aTurno = null;
		}

	} 
	
	public function setEscuelaNombre($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->escuela_nombre !== $v) {
			$this->escuela_nombre = $v;
			$this->modifiedColumns[] = ArtAlumnoPeer::ESCUELA_NOMBRE;
		}

	} 
	
	public function setEscuelaDomicilio($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->escuela_domicilio !== $v) {
			$this->escuela_domicilio = $v;
			$this->modifiedColumns[] = ArtAlumnoPeer::ESCUELA_DOMICILIO;
		}

	} 
	
	public function setEscuelaConProvinciasId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->escuela_con_provincias_id !== $v || $v === 0) {
			$this->escuela_con_provincias_id = $v;
			$this->modifiedColumns[] = ArtAlumnoPeer::ESCUELA_CON_PROVINCIAS_ID;
		}

		if ($this->aProvinciaRelatedByEscuelaConProvinciasId !== null && $this->aProvinciaRelatedByEscuelaConProvinciasId->getId() !== $v) {
			$this->aProvinciaRelatedByEscuelaConProvinciasId = null;
		}

	} 
	
	public function setEscuelaConLocalidadesId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->escuela_con_localidades_id !== $v || $v === 0) {
			$this->escuela_con_localidades_id = $v;
			$this->modifiedColumns[] = ArtAlumnoPeer::ESCUELA_CON_LOCALIDADES_ID;
		}

		if ($this->aLocalidadRelatedByEscuelaConLocalidadesId !== null && $this->aLocalidadRelatedByEscuelaConLocalidadesId->getId() !== $v) {
			$this->aLocalidadRelatedByEscuelaConLocalidadesId = null;
		}

	} 
	
	public function setEscuelaEgreso($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->escuela_egreso !== $v) {
			$this->escuela_egreso = $v;
			$this->modifiedColumns[] = ArtAlumnoPeer::ESCUELA_EGRESO;
		}

	} 
	
	public function setEscuelaModalidad($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->escuela_modalidad !== $v) {
			$this->escuela_modalidad = $v;
			$this->modifiedColumns[] = ArtAlumnoPeer::ESCUELA_MODALIDAD;
		}

	} 
	
	public function setEscuelaPendientes($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->escuela_pendientes !== $v) {
			$this->escuela_pendientes = $v;
			$this->modifiedColumns[] = ArtAlumnoPeer::ESCUELA_PENDIENTES;
		}

	} 
	
	public function setOtrosOrientacion($v)
	{

		if ($this->otros_orientacion !== $v || $v === false) {
			$this->otros_orientacion = $v;
			$this->modifiedColumns[] = ArtAlumnoPeer::OTROS_ORIENTACION;
		}

	} 
	
	public function setOtrosInformatica($v)
	{

		if ($this->otros_informatica !== $v || $v === false) {
			$this->otros_informatica = $v;
			$this->modifiedColumns[] = ArtAlumnoPeer::OTROS_INFORMATICA;
		}

	} 
	
	public function setOtrosTrabaja($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->otros_trabaja !== $v) {
			$this->otros_trabaja = $v;
			$this->modifiedColumns[] = ArtAlumnoPeer::OTROS_TRABAJA;
		}

	} 
	
	public function setOtrosInformaticaCuales($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->otros_informatica_cuales !== $v) {
			$this->otros_informatica_cuales = $v;
			$this->modifiedColumns[] = ArtAlumnoPeer::OTROS_INFORMATICA_CUALES;
		}

	} 
	
	public function setCarreraInteresado($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->carrera_interesado !== $v) {
			$this->carrera_interesado = $v;
			$this->modifiedColumns[] = ArtAlumnoPeer::CARRERA_INTERESADO;
		}

	} 
	
	public function setSedeCursado($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->sede_cursado !== $v) {
			$this->sede_cursado = $v;
			$this->modifiedColumns[] = ArtAlumnoPeer::SEDE_CURSADO;
		}

	} 
	
	public function setConProvinciasId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->con_provincias_id !== $v) {
			$this->con_provincias_id = $v;
			$this->modifiedColumns[] = ArtAlumnoPeer::CON_PROVINCIAS_ID;
		}

		if ($this->aProvinciaRelatedByConProvinciasId !== null && $this->aProvinciaRelatedByConProvinciasId->getId() !== $v) {
			$this->aProvinciaRelatedByConProvinciasId = null;
		}

	} 
	
	public function setAnio($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->anio !== $v) {
			$this->anio = $v;
			$this->modifiedColumns[] = ArtAlumnoPeer::ANIO;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->nombre = $rs->getString($startcol + 1);

			$this->apellido = $rs->getString($startcol + 2);

			$this->fecha_nac = $rs->getDate($startcol + 3, null);

			$this->domicilio = $rs->getString($startcol + 4);

			$this->dni = $rs->getString($startcol + 5);

			$this->telefono = $rs->getString($startcol + 6);

			$this->email = $rs->getString($startcol + 7);

			$this->con_localidades_id = $rs->getInt($startcol + 8);

			$this->escuela_turno_id = $rs->getInt($startcol + 9);

			$this->escuela_nombre = $rs->getString($startcol + 10);

			$this->escuela_domicilio = $rs->getString($startcol + 11);

			$this->escuela_con_provincias_id = $rs->getInt($startcol + 12);

			$this->escuela_con_localidades_id = $rs->getInt($startcol + 13);

			$this->escuela_egreso = $rs->getInt($startcol + 14);

			$this->escuela_modalidad = $rs->getString($startcol + 15);

			$this->escuela_pendientes = $rs->getString($startcol + 16);

			$this->otros_orientacion = $rs->getBoolean($startcol + 17);

			$this->otros_informatica = $rs->getBoolean($startcol + 18);

			$this->otros_trabaja = $rs->getString($startcol + 19);

			$this->otros_informatica_cuales = $rs->getString($startcol + 20);

			$this->carrera_interesado = $rs->getString($startcol + 21);

			$this->sede_cursado = $rs->getString($startcol + 22);

			$this->con_provincias_id = $rs->getInt($startcol + 23);

			$this->anio = $rs->getInt($startcol + 24);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 25; 
		} catch (Exception $e) {
			throw new PropelException("Error populating ArtAlumno object", $e);
		}
	}

	
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BaseArtAlumno:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ArtAlumnoPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			ArtAlumnoPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseArtAlumno:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BaseArtAlumno:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ArtAlumnoPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseArtAlumno:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->aLocalidadRelatedByConLocalidadesId !== null) {
				if ($this->aLocalidadRelatedByConLocalidadesId->isModified()) {
					$affectedRows += $this->aLocalidadRelatedByConLocalidadesId->save($con);
				}
				$this->setLocalidadRelatedByConLocalidadesId($this->aLocalidadRelatedByConLocalidadesId);
			}

			if ($this->aTurno !== null) {
				if ($this->aTurno->isModified()) {
					$affectedRows += $this->aTurno->save($con);
				}
				$this->setTurno($this->aTurno);
			}

			if ($this->aProvinciaRelatedByEscuelaConProvinciasId !== null) {
				if ($this->aProvinciaRelatedByEscuelaConProvinciasId->isModified()) {
					$affectedRows += $this->aProvinciaRelatedByEscuelaConProvinciasId->save($con);
				}
				$this->setProvinciaRelatedByEscuelaConProvinciasId($this->aProvinciaRelatedByEscuelaConProvinciasId);
			}

			if ($this->aLocalidadRelatedByEscuelaConLocalidadesId !== null) {
				if ($this->aLocalidadRelatedByEscuelaConLocalidadesId->isModified()) {
					$affectedRows += $this->aLocalidadRelatedByEscuelaConLocalidadesId->save($con);
				}
				$this->setLocalidadRelatedByEscuelaConLocalidadesId($this->aLocalidadRelatedByEscuelaConLocalidadesId);
			}

			if ($this->aProvinciaRelatedByConProvinciasId !== null) {
				if ($this->aProvinciaRelatedByConProvinciasId->isModified()) {
					$affectedRows += $this->aProvinciaRelatedByConProvinciasId->save($con);
				}
				$this->setProvinciaRelatedByConProvinciasId($this->aProvinciaRelatedByConProvinciasId);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = ArtAlumnoPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += ArtAlumnoPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collArtAlumnoModulos !== null) {
				foreach($this->collArtAlumnoModulos as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aLocalidadRelatedByConLocalidadesId !== null) {
				if (!$this->aLocalidadRelatedByConLocalidadesId->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aLocalidadRelatedByConLocalidadesId->getValidationFailures());
				}
			}

			if ($this->aTurno !== null) {
				if (!$this->aTurno->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aTurno->getValidationFailures());
				}
			}

			if ($this->aProvinciaRelatedByEscuelaConProvinciasId !== null) {
				if (!$this->aProvinciaRelatedByEscuelaConProvinciasId->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aProvinciaRelatedByEscuelaConProvinciasId->getValidationFailures());
				}
			}

			if ($this->aLocalidadRelatedByEscuelaConLocalidadesId !== null) {
				if (!$this->aLocalidadRelatedByEscuelaConLocalidadesId->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aLocalidadRelatedByEscuelaConLocalidadesId->getValidationFailures());
				}
			}

			if ($this->aProvinciaRelatedByConProvinciasId !== null) {
				if (!$this->aProvinciaRelatedByConProvinciasId->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aProvinciaRelatedByConProvinciasId->getValidationFailures());
				}
			}


			if (($retval = ArtAlumnoPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collArtAlumnoModulos !== null) {
					foreach($this->collArtAlumnoModulos as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ArtAlumnoPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getNombre();
				break;
			case 2:
				return $this->getApellido();
				break;
			case 3:
				return $this->getFechaNac();
				break;
			case 4:
				return $this->getDomicilio();
				break;
			case 5:
				return $this->getDni();
				break;
			case 6:
				return $this->getTelefono();
				break;
			case 7:
				return $this->getEmail();
				break;
			case 8:
				return $this->getConLocalidadesId();
				break;
			case 9:
				return $this->getEscuelaTurnoId();
				break;
			case 10:
				return $this->getEscuelaNombre();
				break;
			case 11:
				return $this->getEscuelaDomicilio();
				break;
			case 12:
				return $this->getEscuelaConProvinciasId();
				break;
			case 13:
				return $this->getEscuelaConLocalidadesId();
				break;
			case 14:
				return $this->getEscuelaEgreso();
				break;
			case 15:
				return $this->getEscuelaModalidad();
				break;
			case 16:
				return $this->getEscuelaPendientes();
				break;
			case 17:
				return $this->getOtrosOrientacion();
				break;
			case 18:
				return $this->getOtrosInformatica();
				break;
			case 19:
				return $this->getOtrosTrabaja();
				break;
			case 20:
				return $this->getOtrosInformaticaCuales();
				break;
			case 21:
				return $this->getCarreraInteresado();
				break;
			case 22:
				return $this->getSedeCursado();
				break;
			case 23:
				return $this->getConProvinciasId();
				break;
			case 24:
				return $this->getAnio();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ArtAlumnoPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getNombre(),
			$keys[2] => $this->getApellido(),
			$keys[3] => $this->getFechaNac(),
			$keys[4] => $this->getDomicilio(),
			$keys[5] => $this->getDni(),
			$keys[6] => $this->getTelefono(),
			$keys[7] => $this->getEmail(),
			$keys[8] => $this->getConLocalidadesId(),
			$keys[9] => $this->getEscuelaTurnoId(),
			$keys[10] => $this->getEscuelaNombre(),
			$keys[11] => $this->getEscuelaDomicilio(),
			$keys[12] => $this->getEscuelaConProvinciasId(),
			$keys[13] => $this->getEscuelaConLocalidadesId(),
			$keys[14] => $this->getEscuelaEgreso(),
			$keys[15] => $this->getEscuelaModalidad(),
			$keys[16] => $this->getEscuelaPendientes(),
			$keys[17] => $this->getOtrosOrientacion(),
			$keys[18] => $this->getOtrosInformatica(),
			$keys[19] => $this->getOtrosTrabaja(),
			$keys[20] => $this->getOtrosInformaticaCuales(),
			$keys[21] => $this->getCarreraInteresado(),
			$keys[22] => $this->getSedeCursado(),
			$keys[23] => $this->getConProvinciasId(),
			$keys[24] => $this->getAnio(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ArtAlumnoPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setNombre($value);
				break;
			case 2:
				$this->setApellido($value);
				break;
			case 3:
				$this->setFechaNac($value);
				break;
			case 4:
				$this->setDomicilio($value);
				break;
			case 5:
				$this->setDni($value);
				break;
			case 6:
				$this->setTelefono($value);
				break;
			case 7:
				$this->setEmail($value);
				break;
			case 8:
				$this->setConLocalidadesId($value);
				break;
			case 9:
				$this->setEscuelaTurnoId($value);
				break;
			case 10:
				$this->setEscuelaNombre($value);
				break;
			case 11:
				$this->setEscuelaDomicilio($value);
				break;
			case 12:
				$this->setEscuelaConProvinciasId($value);
				break;
			case 13:
				$this->setEscuelaConLocalidadesId($value);
				break;
			case 14:
				$this->setEscuelaEgreso($value);
				break;
			case 15:
				$this->setEscuelaModalidad($value);
				break;
			case 16:
				$this->setEscuelaPendientes($value);
				break;
			case 17:
				$this->setOtrosOrientacion($value);
				break;
			case 18:
				$this->setOtrosInformatica($value);
				break;
			case 19:
				$this->setOtrosTrabaja($value);
				break;
			case 20:
				$this->setOtrosInformaticaCuales($value);
				break;
			case 21:
				$this->setCarreraInteresado($value);
				break;
			case 22:
				$this->setSedeCursado($value);
				break;
			case 23:
				$this->setConProvinciasId($value);
				break;
			case 24:
				$this->setAnio($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ArtAlumnoPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setNombre($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setApellido($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setFechaNac($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setDomicilio($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setDni($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setTelefono($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setEmail($arr[$keys[7]]);
		if (array_key_exists($keys[8], $arr)) $this->setConLocalidadesId($arr[$keys[8]]);
		if (array_key_exists($keys[9], $arr)) $this->setEscuelaTurnoId($arr[$keys[9]]);
		if (array_key_exists($keys[10], $arr)) $this->setEscuelaNombre($arr[$keys[10]]);
		if (array_key_exists($keys[11], $arr)) $this->setEscuelaDomicilio($arr[$keys[11]]);
		if (array_key_exists($keys[12], $arr)) $this->setEscuelaConProvinciasId($arr[$keys[12]]);
		if (array_key_exists($keys[13], $arr)) $this->setEscuelaConLocalidadesId($arr[$keys[13]]);
		if (array_key_exists($keys[14], $arr)) $this->setEscuelaEgreso($arr[$keys[14]]);
		if (array_key_exists($keys[15], $arr)) $this->setEscuelaModalidad($arr[$keys[15]]);
		if (array_key_exists($keys[16], $arr)) $this->setEscuelaPendientes($arr[$keys[16]]);
		if (array_key_exists($keys[17], $arr)) $this->setOtrosOrientacion($arr[$keys[17]]);
		if (array_key_exists($keys[18], $arr)) $this->setOtrosInformatica($arr[$keys[18]]);
		if (array_key_exists($keys[19], $arr)) $this->setOtrosTrabaja($arr[$keys[19]]);
		if (array_key_exists($keys[20], $arr)) $this->setOtrosInformaticaCuales($arr[$keys[20]]);
		if (array_key_exists($keys[21], $arr)) $this->setCarreraInteresado($arr[$keys[21]]);
		if (array_key_exists($keys[22], $arr)) $this->setSedeCursado($arr[$keys[22]]);
		if (array_key_exists($keys[23], $arr)) $this->setConProvinciasId($arr[$keys[23]]);
		if (array_key_exists($keys[24], $arr)) $this->setAnio($arr[$keys[24]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(ArtAlumnoPeer::DATABASE_NAME);

		if ($this->isColumnModified(ArtAlumnoPeer::ID)) $criteria->add(ArtAlumnoPeer::ID, $this->id);
		if ($this->isColumnModified(ArtAlumnoPeer::NOMBRE)) $criteria->add(ArtAlumnoPeer::NOMBRE, $this->nombre);
		if ($this->isColumnModified(ArtAlumnoPeer::APELLIDO)) $criteria->add(ArtAlumnoPeer::APELLIDO, $this->apellido);
		if ($this->isColumnModified(ArtAlumnoPeer::FECHA_NAC)) $criteria->add(ArtAlumnoPeer::FECHA_NAC, $this->fecha_nac);
		if ($this->isColumnModified(ArtAlumnoPeer::DOMICILIO)) $criteria->add(ArtAlumnoPeer::DOMICILIO, $this->domicilio);
		if ($this->isColumnModified(ArtAlumnoPeer::DNI)) $criteria->add(ArtAlumnoPeer::DNI, $this->dni);
		if ($this->isColumnModified(ArtAlumnoPeer::TELEFONO)) $criteria->add(ArtAlumnoPeer::TELEFONO, $this->telefono);
		if ($this->isColumnModified(ArtAlumnoPeer::EMAIL)) $criteria->add(ArtAlumnoPeer::EMAIL, $this->email);
		if ($this->isColumnModified(ArtAlumnoPeer::CON_LOCALIDADES_ID)) $criteria->add(ArtAlumnoPeer::CON_LOCALIDADES_ID, $this->con_localidades_id);
		if ($this->isColumnModified(ArtAlumnoPeer::ESCUELA_TURNO_ID)) $criteria->add(ArtAlumnoPeer::ESCUELA_TURNO_ID, $this->escuela_turno_id);
		if ($this->isColumnModified(ArtAlumnoPeer::ESCUELA_NOMBRE)) $criteria->add(ArtAlumnoPeer::ESCUELA_NOMBRE, $this->escuela_nombre);
		if ($this->isColumnModified(ArtAlumnoPeer::ESCUELA_DOMICILIO)) $criteria->add(ArtAlumnoPeer::ESCUELA_DOMICILIO, $this->escuela_domicilio);
		if ($this->isColumnModified(ArtAlumnoPeer::ESCUELA_CON_PROVINCIAS_ID)) $criteria->add(ArtAlumnoPeer::ESCUELA_CON_PROVINCIAS_ID, $this->escuela_con_provincias_id);
		if ($this->isColumnModified(ArtAlumnoPeer::ESCUELA_CON_LOCALIDADES_ID)) $criteria->add(ArtAlumnoPeer::ESCUELA_CON_LOCALIDADES_ID, $this->escuela_con_localidades_id);
		if ($this->isColumnModified(ArtAlumnoPeer::ESCUELA_EGRESO)) $criteria->add(ArtAlumnoPeer::ESCUELA_EGRESO, $this->escuela_egreso);
		if ($this->isColumnModified(ArtAlumnoPeer::ESCUELA_MODALIDAD)) $criteria->add(ArtAlumnoPeer::ESCUELA_MODALIDAD, $this->escuela_modalidad);
		if ($this->isColumnModified(ArtAlumnoPeer::ESCUELA_PENDIENTES)) $criteria->add(ArtAlumnoPeer::ESCUELA_PENDIENTES, $this->escuela_pendientes);
		if ($this->isColumnModified(ArtAlumnoPeer::OTROS_ORIENTACION)) $criteria->add(ArtAlumnoPeer::OTROS_ORIENTACION, $this->otros_orientacion);
		if ($this->isColumnModified(ArtAlumnoPeer::OTROS_INFORMATICA)) $criteria->add(ArtAlumnoPeer::OTROS_INFORMATICA, $this->otros_informatica);
		if ($this->isColumnModified(ArtAlumnoPeer::OTROS_TRABAJA)) $criteria->add(ArtAlumnoPeer::OTROS_TRABAJA, $this->otros_trabaja);
		if ($this->isColumnModified(ArtAlumnoPeer::OTROS_INFORMATICA_CUALES)) $criteria->add(ArtAlumnoPeer::OTROS_INFORMATICA_CUALES, $this->otros_informatica_cuales);
		if ($this->isColumnModified(ArtAlumnoPeer::CARRERA_INTERESADO)) $criteria->add(ArtAlumnoPeer::CARRERA_INTERESADO, $this->carrera_interesado);
		if ($this->isColumnModified(ArtAlumnoPeer::SEDE_CURSADO)) $criteria->add(ArtAlumnoPeer::SEDE_CURSADO, $this->sede_cursado);
		if ($this->isColumnModified(ArtAlumnoPeer::CON_PROVINCIAS_ID)) $criteria->add(ArtAlumnoPeer::CON_PROVINCIAS_ID, $this->con_provincias_id);
		if ($this->isColumnModified(ArtAlumnoPeer::ANIO)) $criteria->add(ArtAlumnoPeer::ANIO, $this->anio);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(ArtAlumnoPeer::DATABASE_NAME);

		$criteria->add(ArtAlumnoPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setNombre($this->nombre);

		$copyObj->setApellido($this->apellido);

		$copyObj->setFechaNac($this->fecha_nac);

		$copyObj->setDomicilio($this->domicilio);

		$copyObj->setDni($this->dni);

		$copyObj->setTelefono($this->telefono);

		$copyObj->setEmail($this->email);

		$copyObj->setConLocalidadesId($this->con_localidades_id);

		$copyObj->setEscuelaTurnoId($this->escuela_turno_id);

		$copyObj->setEscuelaNombre($this->escuela_nombre);

		$copyObj->setEscuelaDomicilio($this->escuela_domicilio);

		$copyObj->setEscuelaConProvinciasId($this->escuela_con_provincias_id);

		$copyObj->setEscuelaConLocalidadesId($this->escuela_con_localidades_id);

		$copyObj->setEscuelaEgreso($this->escuela_egreso);

		$copyObj->setEscuelaModalidad($this->escuela_modalidad);

		$copyObj->setEscuelaPendientes($this->escuela_pendientes);

		$copyObj->setOtrosOrientacion($this->otros_orientacion);

		$copyObj->setOtrosInformatica($this->otros_informatica);

		$copyObj->setOtrosTrabaja($this->otros_trabaja);

		$copyObj->setOtrosInformaticaCuales($this->otros_informatica_cuales);

		$copyObj->setCarreraInteresado($this->carrera_interesado);

		$copyObj->setSedeCursado($this->sede_cursado);

		$copyObj->setConProvinciasId($this->con_provincias_id);

		$copyObj->setAnio($this->anio);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getArtAlumnoModulos() as $relObj) {
				$copyObj->addArtAlumnoModulo($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new ArtAlumnoPeer();
		}
		return self::$peer;
	}

	
	public function setLocalidadRelatedByConLocalidadesId($v)
	{


		if ($v === null) {
			$this->setConLocalidadesId(NULL);
		} else {
			$this->setConLocalidadesId($v->getId());
		}


		$this->aLocalidadRelatedByConLocalidadesId = $v;
	}


	
	public function getLocalidadRelatedByConLocalidadesId($con = null)
	{
		if ($this->aLocalidadRelatedByConLocalidadesId === null && ($this->con_localidades_id !== null)) {
						include_once 'lib/model/om/BaseLocalidadPeer.php';

			$this->aLocalidadRelatedByConLocalidadesId = LocalidadPeer::retrieveByPK($this->con_localidades_id, $con);

			
		}
		return $this->aLocalidadRelatedByConLocalidadesId;
	}

	
	public function setTurno($v)
	{


		if ($v === null) {
			$this->setEscuelaTurnoId(NULL);
		} else {
			$this->setEscuelaTurnoId($v->getId());
		}


		$this->aTurno = $v;
	}


	
	public function getTurno($con = null)
	{
		if ($this->aTurno === null && ($this->escuela_turno_id !== null)) {
						include_once 'lib/model/om/BaseTurnoPeer.php';

			$this->aTurno = TurnoPeer::retrieveByPK($this->escuela_turno_id, $con);

			
		}
		return $this->aTurno;
	}

	
	public function setProvinciaRelatedByEscuelaConProvinciasId($v)
	{


		if ($v === null) {
			$this->setEscuelaConProvinciasId('null');
		} else {
			$this->setEscuelaConProvinciasId($v->getId());
		}


		$this->aProvinciaRelatedByEscuelaConProvinciasId = $v;
	}


	
	public function getProvinciaRelatedByEscuelaConProvinciasId($con = null)
	{
		if ($this->aProvinciaRelatedByEscuelaConProvinciasId === null && ($this->escuela_con_provincias_id !== null)) {
						include_once 'lib/model/om/BaseProvinciaPeer.php';

			$this->aProvinciaRelatedByEscuelaConProvinciasId = ProvinciaPeer::retrieveByPK($this->escuela_con_provincias_id, $con);

			
		}
		return $this->aProvinciaRelatedByEscuelaConProvinciasId;
	}

	
	public function setLocalidadRelatedByEscuelaConLocalidadesId($v)
	{


		if ($v === null) {
			$this->setEscuelaConLocalidadesId('null');
		} else {
			$this->setEscuelaConLocalidadesId($v->getId());
		}


		$this->aLocalidadRelatedByEscuelaConLocalidadesId = $v;
	}


	
	public function getLocalidadRelatedByEscuelaConLocalidadesId($con = null)
	{
		if ($this->aLocalidadRelatedByEscuelaConLocalidadesId === null && ($this->escuela_con_localidades_id !== null)) {
						include_once 'lib/model/om/BaseLocalidadPeer.php';

			$this->aLocalidadRelatedByEscuelaConLocalidadesId = LocalidadPeer::retrieveByPK($this->escuela_con_localidades_id, $con);

			
		}
		return $this->aLocalidadRelatedByEscuelaConLocalidadesId;
	}

	
	public function setProvinciaRelatedByConProvinciasId($v)
	{


		if ($v === null) {
			$this->setConProvinciasId(NULL);
		} else {
			$this->setConProvinciasId($v->getId());
		}


		$this->aProvinciaRelatedByConProvinciasId = $v;
	}


	
	public function getProvinciaRelatedByConProvinciasId($con = null)
	{
		if ($this->aProvinciaRelatedByConProvinciasId === null && ($this->con_provincias_id !== null)) {
						include_once 'lib/model/om/BaseProvinciaPeer.php';

			$this->aProvinciaRelatedByConProvinciasId = ProvinciaPeer::retrieveByPK($this->con_provincias_id, $con);

			
		}
		return $this->aProvinciaRelatedByConProvinciasId;
	}

	
	public function initArtAlumnoModulos()
	{
		if ($this->collArtAlumnoModulos === null) {
			$this->collArtAlumnoModulos = array();
		}
	}

	
	public function getArtAlumnoModulos($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseArtAlumnoModuloPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collArtAlumnoModulos === null) {
			if ($this->isNew()) {
			   $this->collArtAlumnoModulos = array();
			} else {

				$criteria->add(ArtAlumnoModuloPeer::ART_ALUMNO_ID, $this->getId());

				ArtAlumnoModuloPeer::addSelectColumns($criteria);
				$this->collArtAlumnoModulos = ArtAlumnoModuloPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(ArtAlumnoModuloPeer::ART_ALUMNO_ID, $this->getId());

				ArtAlumnoModuloPeer::addSelectColumns($criteria);
				if (!isset($this->lastArtAlumnoModuloCriteria) || !$this->lastArtAlumnoModuloCriteria->equals($criteria)) {
					$this->collArtAlumnoModulos = ArtAlumnoModuloPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastArtAlumnoModuloCriteria = $criteria;
		return $this->collArtAlumnoModulos;
	}

	
	public function countArtAlumnoModulos($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseArtAlumnoModuloPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(ArtAlumnoModuloPeer::ART_ALUMNO_ID, $this->getId());

		return ArtAlumnoModuloPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addArtAlumnoModulo(ArtAlumnoModulo $l)
	{
		$this->collArtAlumnoModulos[] = $l;
		$l->setArtAlumno($this);
	}


	
	public function getArtAlumnoModulosJoinArtModulo($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseArtAlumnoModuloPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collArtAlumnoModulos === null) {
			if ($this->isNew()) {
				$this->collArtAlumnoModulos = array();
			} else {

				$criteria->add(ArtAlumnoModuloPeer::ART_ALUMNO_ID, $this->getId());

				$this->collArtAlumnoModulos = ArtAlumnoModuloPeer::doSelectJoinArtModulo($criteria, $con);
			}
		} else {
									
			$criteria->add(ArtAlumnoModuloPeer::ART_ALUMNO_ID, $this->getId());

			if (!isset($this->lastArtAlumnoModuloCriteria) || !$this->lastArtAlumnoModuloCriteria->equals($criteria)) {
				$this->collArtAlumnoModulos = ArtAlumnoModuloPeer::doSelectJoinArtModulo($criteria, $con);
			}
		}
		$this->lastArtAlumnoModuloCriteria = $criteria;

		return $this->collArtAlumnoModulos;
	}


	
	public function getArtAlumnoModulosJoinArtComision($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseArtAlumnoModuloPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collArtAlumnoModulos === null) {
			if ($this->isNew()) {
				$this->collArtAlumnoModulos = array();
			} else {

				$criteria->add(ArtAlumnoModuloPeer::ART_ALUMNO_ID, $this->getId());

				$this->collArtAlumnoModulos = ArtAlumnoModuloPeer::doSelectJoinArtComision($criteria, $con);
			}
		} else {
									
			$criteria->add(ArtAlumnoModuloPeer::ART_ALUMNO_ID, $this->getId());

			if (!isset($this->lastArtAlumnoModuloCriteria) || !$this->lastArtAlumnoModuloCriteria->equals($criteria)) {
				$this->collArtAlumnoModulos = ArtAlumnoModuloPeer::doSelectJoinArtComision($criteria, $con);
			}
		}
		$this->lastArtAlumnoModuloCriteria = $criteria;

		return $this->collArtAlumnoModulos;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseArtAlumno:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseArtAlumno::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} 