<?php


abstract class BaseArtModulo extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $nombre;


	
	protected $observaciones;

	
	protected $collArtAlumnoModulos;

	
	protected $lastArtAlumnoModuloCriteria = null;

	
	protected $collArtComisions;

	
	protected $lastArtComisionCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getNombre()
	{

		return $this->nombre;
	}

	
	public function getObservaciones()
	{

		return $this->observaciones;
	}

	
	public function setId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = ArtModuloPeer::ID;
		}

	} 
	
	public function setNombre($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->nombre !== $v) {
			$this->nombre = $v;
			$this->modifiedColumns[] = ArtModuloPeer::NOMBRE;
		}

	} 
	
	public function setObservaciones($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->observaciones !== $v) {
			$this->observaciones = $v;
			$this->modifiedColumns[] = ArtModuloPeer::OBSERVACIONES;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->nombre = $rs->getString($startcol + 1);

			$this->observaciones = $rs->getString($startcol + 2);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 3; 
		} catch (Exception $e) {
			throw new PropelException("Error populating ArtModulo object", $e);
		}
	}

	
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BaseArtModulo:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ArtModuloPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			ArtModuloPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseArtModulo:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BaseArtModulo:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ArtModuloPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseArtModulo:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = ArtModuloPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += ArtModuloPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collArtAlumnoModulos !== null) {
				foreach($this->collArtAlumnoModulos as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collArtComisions !== null) {
				foreach($this->collArtComisions as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = ArtModuloPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collArtAlumnoModulos !== null) {
					foreach($this->collArtAlumnoModulos as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collArtComisions !== null) {
					foreach($this->collArtComisions as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ArtModuloPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getNombre();
				break;
			case 2:
				return $this->getObservaciones();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ArtModuloPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getNombre(),
			$keys[2] => $this->getObservaciones(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ArtModuloPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setNombre($value);
				break;
			case 2:
				$this->setObservaciones($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ArtModuloPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setNombre($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setObservaciones($arr[$keys[2]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(ArtModuloPeer::DATABASE_NAME);

		if ($this->isColumnModified(ArtModuloPeer::ID)) $criteria->add(ArtModuloPeer::ID, $this->id);
		if ($this->isColumnModified(ArtModuloPeer::NOMBRE)) $criteria->add(ArtModuloPeer::NOMBRE, $this->nombre);
		if ($this->isColumnModified(ArtModuloPeer::OBSERVACIONES)) $criteria->add(ArtModuloPeer::OBSERVACIONES, $this->observaciones);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(ArtModuloPeer::DATABASE_NAME);

		$criteria->add(ArtModuloPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setNombre($this->nombre);

		$copyObj->setObservaciones($this->observaciones);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getArtAlumnoModulos() as $relObj) {
				$copyObj->addArtAlumnoModulo($relObj->copy($deepCopy));
			}

			foreach($this->getArtComisions() as $relObj) {
				$copyObj->addArtComision($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new ArtModuloPeer();
		}
		return self::$peer;
	}

	
	public function initArtAlumnoModulos()
	{
		if ($this->collArtAlumnoModulos === null) {
			$this->collArtAlumnoModulos = array();
		}
	}

	
	public function getArtAlumnoModulos($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseArtAlumnoModuloPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collArtAlumnoModulos === null) {
			if ($this->isNew()) {
			   $this->collArtAlumnoModulos = array();
			} else {

				$criteria->add(ArtAlumnoModuloPeer::ART_MODULO_ID, $this->getId());

				ArtAlumnoModuloPeer::addSelectColumns($criteria);
				$this->collArtAlumnoModulos = ArtAlumnoModuloPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(ArtAlumnoModuloPeer::ART_MODULO_ID, $this->getId());

				ArtAlumnoModuloPeer::addSelectColumns($criteria);
				if (!isset($this->lastArtAlumnoModuloCriteria) || !$this->lastArtAlumnoModuloCriteria->equals($criteria)) {
					$this->collArtAlumnoModulos = ArtAlumnoModuloPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastArtAlumnoModuloCriteria = $criteria;
		return $this->collArtAlumnoModulos;
	}

	
	public function countArtAlumnoModulos($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseArtAlumnoModuloPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(ArtAlumnoModuloPeer::ART_MODULO_ID, $this->getId());

		return ArtAlumnoModuloPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addArtAlumnoModulo(ArtAlumnoModulo $l)
	{
		$this->collArtAlumnoModulos[] = $l;
		$l->setArtModulo($this);
	}


	
	public function getArtAlumnoModulosJoinArtAlumno($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseArtAlumnoModuloPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collArtAlumnoModulos === null) {
			if ($this->isNew()) {
				$this->collArtAlumnoModulos = array();
			} else {

				$criteria->add(ArtAlumnoModuloPeer::ART_MODULO_ID, $this->getId());

				$this->collArtAlumnoModulos = ArtAlumnoModuloPeer::doSelectJoinArtAlumno($criteria, $con);
			}
		} else {
									
			$criteria->add(ArtAlumnoModuloPeer::ART_MODULO_ID, $this->getId());

			if (!isset($this->lastArtAlumnoModuloCriteria) || !$this->lastArtAlumnoModuloCriteria->equals($criteria)) {
				$this->collArtAlumnoModulos = ArtAlumnoModuloPeer::doSelectJoinArtAlumno($criteria, $con);
			}
		}
		$this->lastArtAlumnoModuloCriteria = $criteria;

		return $this->collArtAlumnoModulos;
	}


	
	public function getArtAlumnoModulosJoinArtComision($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseArtAlumnoModuloPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collArtAlumnoModulos === null) {
			if ($this->isNew()) {
				$this->collArtAlumnoModulos = array();
			} else {

				$criteria->add(ArtAlumnoModuloPeer::ART_MODULO_ID, $this->getId());

				$this->collArtAlumnoModulos = ArtAlumnoModuloPeer::doSelectJoinArtComision($criteria, $con);
			}
		} else {
									
			$criteria->add(ArtAlumnoModuloPeer::ART_MODULO_ID, $this->getId());

			if (!isset($this->lastArtAlumnoModuloCriteria) || !$this->lastArtAlumnoModuloCriteria->equals($criteria)) {
				$this->collArtAlumnoModulos = ArtAlumnoModuloPeer::doSelectJoinArtComision($criteria, $con);
			}
		}
		$this->lastArtAlumnoModuloCriteria = $criteria;

		return $this->collArtAlumnoModulos;
	}

	
	public function initArtComisions()
	{
		if ($this->collArtComisions === null) {
			$this->collArtComisions = array();
		}
	}

	
	public function getArtComisions($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseArtComisionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collArtComisions === null) {
			if ($this->isNew()) {
			   $this->collArtComisions = array();
			} else {

				$criteria->add(ArtComisionPeer::ART_MODULO_ID, $this->getId());

				ArtComisionPeer::addSelectColumns($criteria);
				$this->collArtComisions = ArtComisionPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(ArtComisionPeer::ART_MODULO_ID, $this->getId());

				ArtComisionPeer::addSelectColumns($criteria);
				if (!isset($this->lastArtComisionCriteria) || !$this->lastArtComisionCriteria->equals($criteria)) {
					$this->collArtComisions = ArtComisionPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastArtComisionCriteria = $criteria;
		return $this->collArtComisions;
	}

	
	public function countArtComisions($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseArtComisionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(ArtComisionPeer::ART_MODULO_ID, $this->getId());

		return ArtComisionPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addArtComision(ArtComision $l)
	{
		$this->collArtComisions[] = $l;
		$l->setArtModulo($this);
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseArtModulo:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseArtModulo::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} 