<?php


abstract class BaseArtModuloComision extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $art_modulo_id;


	
	protected $lugar;


	
	protected $horario;

	
	protected $aArtModulo;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getArtModuloId()
	{

		return $this->art_modulo_id;
	}

	
	public function getLugar()
	{

		return $this->lugar;
	}

	
	public function getHorario()
	{

		return $this->horario;
	}

	
	public function setId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = ArtModuloComisionPeer::ID;
		}

	} 
	
	public function setArtModuloId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->art_modulo_id !== $v) {
			$this->art_modulo_id = $v;
			$this->modifiedColumns[] = ArtModuloComisionPeer::ART_MODULO_ID;
		}

		if ($this->aArtModulo !== null && $this->aArtModulo->getId() !== $v) {
			$this->aArtModulo = null;
		}

	} 
	
	public function setLugar($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->lugar !== $v) {
			$this->lugar = $v;
			$this->modifiedColumns[] = ArtModuloComisionPeer::LUGAR;
		}

	} 
	
	public function setHorario($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->horario !== $v) {
			$this->horario = $v;
			$this->modifiedColumns[] = ArtModuloComisionPeer::HORARIO;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->art_modulo_id = $rs->getInt($startcol + 1);

			$this->lugar = $rs->getString($startcol + 2);

			$this->horario = $rs->getString($startcol + 3);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 4; 
		} catch (Exception $e) {
			throw new PropelException("Error populating ArtModuloComision object", $e);
		}
	}

	
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BaseArtModuloComision:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ArtModuloComisionPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			ArtModuloComisionPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseArtModuloComision:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BaseArtModuloComision:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ArtModuloComisionPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseArtModuloComision:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->aArtModulo !== null) {
				if ($this->aArtModulo->isModified()) {
					$affectedRows += $this->aArtModulo->save($con);
				}
				$this->setArtModulo($this->aArtModulo);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = ArtModuloComisionPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += ArtModuloComisionPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aArtModulo !== null) {
				if (!$this->aArtModulo->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aArtModulo->getValidationFailures());
				}
			}


			if (($retval = ArtModuloComisionPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ArtModuloComisionPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getArtModuloId();
				break;
			case 2:
				return $this->getLugar();
				break;
			case 3:
				return $this->getHorario();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ArtModuloComisionPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getArtModuloId(),
			$keys[2] => $this->getLugar(),
			$keys[3] => $this->getHorario(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ArtModuloComisionPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setArtModuloId($value);
				break;
			case 2:
				$this->setLugar($value);
				break;
			case 3:
				$this->setHorario($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ArtModuloComisionPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setArtModuloId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setLugar($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setHorario($arr[$keys[3]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(ArtModuloComisionPeer::DATABASE_NAME);

		if ($this->isColumnModified(ArtModuloComisionPeer::ID)) $criteria->add(ArtModuloComisionPeer::ID, $this->id);
		if ($this->isColumnModified(ArtModuloComisionPeer::ART_MODULO_ID)) $criteria->add(ArtModuloComisionPeer::ART_MODULO_ID, $this->art_modulo_id);
		if ($this->isColumnModified(ArtModuloComisionPeer::LUGAR)) $criteria->add(ArtModuloComisionPeer::LUGAR, $this->lugar);
		if ($this->isColumnModified(ArtModuloComisionPeer::HORARIO)) $criteria->add(ArtModuloComisionPeer::HORARIO, $this->horario);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(ArtModuloComisionPeer::DATABASE_NAME);

		$criteria->add(ArtModuloComisionPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setArtModuloId($this->art_modulo_id);

		$copyObj->setLugar($this->lugar);

		$copyObj->setHorario($this->horario);


		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new ArtModuloComisionPeer();
		}
		return self::$peer;
	}

	
	public function setArtModulo($v)
	{


		if ($v === null) {
			$this->setArtModuloId(NULL);
		} else {
			$this->setArtModuloId($v->getId());
		}


		$this->aArtModulo = $v;
	}


	
	public function getArtModulo($con = null)
	{
		if ($this->aArtModulo === null && ($this->art_modulo_id !== null)) {
						include_once 'lib/model/om/BaseArtModuloPeer.php';

			$this->aArtModulo = ArtModuloPeer::retrieveByPK($this->art_modulo_id, $con);

			
		}
		return $this->aArtModulo;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseArtModuloComision:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseArtModuloComision::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} 