<?php


abstract class BaseCarrera extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $con_facultades_id;


	
	protected $nombre;

	
	protected $collExpedientes;

	
	protected $lastExpedienteCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getConFacultadesId()
	{

		return $this->con_facultades_id;
	}

	
	public function getNombre()
	{

		return $this->nombre;
	}

	
	public function setId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = CarreraPeer::ID;
		}

	} 
	
	public function setConFacultadesId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->con_facultades_id !== $v) {
			$this->con_facultades_id = $v;
			$this->modifiedColumns[] = CarreraPeer::CON_FACULTADES_ID;
		}

	} 
	
	public function setNombre($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->nombre !== $v) {
			$this->nombre = $v;
			$this->modifiedColumns[] = CarreraPeer::NOMBRE;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->con_facultades_id = $rs->getInt($startcol + 1);

			$this->nombre = $rs->getString($startcol + 2);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 3; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Carrera object", $e);
		}
	}

	
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BaseCarrera:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(CarreraPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			CarreraPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseCarrera:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BaseCarrera:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(CarreraPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseCarrera:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = CarreraPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += CarreraPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collExpedientes !== null) {
				foreach($this->collExpedientes as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = CarreraPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collExpedientes !== null) {
					foreach($this->collExpedientes as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = CarreraPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getConFacultadesId();
				break;
			case 2:
				return $this->getNombre();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = CarreraPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getConFacultadesId(),
			$keys[2] => $this->getNombre(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = CarreraPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setConFacultadesId($value);
				break;
			case 2:
				$this->setNombre($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = CarreraPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setConFacultadesId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setNombre($arr[$keys[2]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(CarreraPeer::DATABASE_NAME);

		if ($this->isColumnModified(CarreraPeer::ID)) $criteria->add(CarreraPeer::ID, $this->id);
		if ($this->isColumnModified(CarreraPeer::CON_FACULTADES_ID)) $criteria->add(CarreraPeer::CON_FACULTADES_ID, $this->con_facultades_id);
		if ($this->isColumnModified(CarreraPeer::NOMBRE)) $criteria->add(CarreraPeer::NOMBRE, $this->nombre);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(CarreraPeer::DATABASE_NAME);

		$criteria->add(CarreraPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setConFacultadesId($this->con_facultades_id);

		$copyObj->setNombre($this->nombre);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getExpedientes() as $relObj) {
				$copyObj->addExpediente($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new CarreraPeer();
		}
		return self::$peer;
	}

	
	public function initExpedientes()
	{
		if ($this->collExpedientes === null) {
			$this->collExpedientes = array();
		}
	}

	
	public function getExpedientes($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseExpedientePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collExpedientes === null) {
			if ($this->isNew()) {
			   $this->collExpedientes = array();
			} else {

				$criteria->add(ExpedientePeer::CON_CARRERAS_ID, $this->getId());

				ExpedientePeer::addSelectColumns($criteria);
				$this->collExpedientes = ExpedientePeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(ExpedientePeer::CON_CARRERAS_ID, $this->getId());

				ExpedientePeer::addSelectColumns($criteria);
				if (!isset($this->lastExpedienteCriteria) || !$this->lastExpedienteCriteria->equals($criteria)) {
					$this->collExpedientes = ExpedientePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastExpedienteCriteria = $criteria;
		return $this->collExpedientes;
	}

	
	public function countExpedientes($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseExpedientePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(ExpedientePeer::CON_CARRERAS_ID, $this->getId());

		return ExpedientePeer::doCount($criteria, $distinct, $con);
	}

	
	public function addExpediente(Expediente $l)
	{
		$this->collExpedientes[] = $l;
		$l->setCarrera($this);
	}


	
	public function getExpedientesJoinFacultad($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseExpedientePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collExpedientes === null) {
			if ($this->isNew()) {
				$this->collExpedientes = array();
			} else {

				$criteria->add(ExpedientePeer::CON_CARRERAS_ID, $this->getId());

				$this->collExpedientes = ExpedientePeer::doSelectJoinFacultad($criteria, $con);
			}
		} else {
									
			$criteria->add(ExpedientePeer::CON_CARRERAS_ID, $this->getId());

			if (!isset($this->lastExpedienteCriteria) || !$this->lastExpedienteCriteria->equals($criteria)) {
				$this->collExpedientes = ExpedientePeer::doSelectJoinFacultad($criteria, $con);
			}
		}
		$this->lastExpedienteCriteria = $criteria;

		return $this->collExpedientes;
	}


	
	public function getExpedientesJoinAlumno($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseExpedientePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collExpedientes === null) {
			if ($this->isNew()) {
				$this->collExpedientes = array();
			} else {

				$criteria->add(ExpedientePeer::CON_CARRERAS_ID, $this->getId());

				$this->collExpedientes = ExpedientePeer::doSelectJoinAlumno($criteria, $con);
			}
		} else {
									
			$criteria->add(ExpedientePeer::CON_CARRERAS_ID, $this->getId());

			if (!isset($this->lastExpedienteCriteria) || !$this->lastExpedienteCriteria->equals($criteria)) {
				$this->collExpedientes = ExpedientePeer::doSelectJoinAlumno($criteria, $con);
			}
		}
		$this->lastExpedienteCriteria = $criteria;

		return $this->collExpedientes;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseCarrera:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseCarrera::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} 