<?php


abstract class BaseClaustro extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $nombre;


	
	protected $cantidad;

	
	protected $collNotificacionConsejeros;

	
	protected $lastNotificacionConsejeroCriteria = null;

	
	protected $collClaustroConsejeros;

	
	protected $lastClaustroConsejeroCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getNombre()
	{

		return $this->nombre;
	}

	
	public function getCantidad()
	{

		return $this->cantidad;
	}

	
	public function setId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = ClaustroPeer::ID;
		}

	} 
	
	public function setNombre($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->nombre !== $v) {
			$this->nombre = $v;
			$this->modifiedColumns[] = ClaustroPeer::NOMBRE;
		}

	} 
	
	public function setCantidad($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->cantidad !== $v) {
			$this->cantidad = $v;
			$this->modifiedColumns[] = ClaustroPeer::CANTIDAD;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->nombre = $rs->getString($startcol + 1);

			$this->cantidad = $rs->getInt($startcol + 2);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 3; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Claustro object", $e);
		}
	}

	
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BaseClaustro:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ClaustroPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			ClaustroPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseClaustro:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BaseClaustro:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ClaustroPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseClaustro:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = ClaustroPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += ClaustroPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collNotificacionConsejeros !== null) {
				foreach($this->collNotificacionConsejeros as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collClaustroConsejeros !== null) {
				foreach($this->collClaustroConsejeros as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = ClaustroPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collNotificacionConsejeros !== null) {
					foreach($this->collNotificacionConsejeros as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collClaustroConsejeros !== null) {
					foreach($this->collClaustroConsejeros as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ClaustroPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getNombre();
				break;
			case 2:
				return $this->getCantidad();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ClaustroPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getNombre(),
			$keys[2] => $this->getCantidad(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ClaustroPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setNombre($value);
				break;
			case 2:
				$this->setCantidad($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ClaustroPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setNombre($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setCantidad($arr[$keys[2]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(ClaustroPeer::DATABASE_NAME);

		if ($this->isColumnModified(ClaustroPeer::ID)) $criteria->add(ClaustroPeer::ID, $this->id);
		if ($this->isColumnModified(ClaustroPeer::NOMBRE)) $criteria->add(ClaustroPeer::NOMBRE, $this->nombre);
		if ($this->isColumnModified(ClaustroPeer::CANTIDAD)) $criteria->add(ClaustroPeer::CANTIDAD, $this->cantidad);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(ClaustroPeer::DATABASE_NAME);

		$criteria->add(ClaustroPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setNombre($this->nombre);

		$copyObj->setCantidad($this->cantidad);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getNotificacionConsejeros() as $relObj) {
				$copyObj->addNotificacionConsejero($relObj->copy($deepCopy));
			}

			foreach($this->getClaustroConsejeros() as $relObj) {
				$copyObj->addClaustroConsejero($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new ClaustroPeer();
		}
		return self::$peer;
	}

	
	public function initNotificacionConsejeros()
	{
		if ($this->collNotificacionConsejeros === null) {
			$this->collNotificacionConsejeros = array();
		}
	}

	
	public function getNotificacionConsejeros($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseNotificacionConsejeroPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collNotificacionConsejeros === null) {
			if ($this->isNew()) {
			   $this->collNotificacionConsejeros = array();
			} else {

				$criteria->add(NotificacionConsejeroPeer::CLAUSTRO_ID, $this->getId());

				NotificacionConsejeroPeer::addSelectColumns($criteria);
				$this->collNotificacionConsejeros = NotificacionConsejeroPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(NotificacionConsejeroPeer::CLAUSTRO_ID, $this->getId());

				NotificacionConsejeroPeer::addSelectColumns($criteria);
				if (!isset($this->lastNotificacionConsejeroCriteria) || !$this->lastNotificacionConsejeroCriteria->equals($criteria)) {
					$this->collNotificacionConsejeros = NotificacionConsejeroPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastNotificacionConsejeroCriteria = $criteria;
		return $this->collNotificacionConsejeros;
	}

	
	public function countNotificacionConsejeros($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseNotificacionConsejeroPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(NotificacionConsejeroPeer::CLAUSTRO_ID, $this->getId());

		return NotificacionConsejeroPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addNotificacionConsejero(NotificacionConsejero $l)
	{
		$this->collNotificacionConsejeros[] = $l;
		$l->setClaustro($this);
	}


	
	public function getNotificacionConsejerosJoinNotificacion($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseNotificacionConsejeroPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collNotificacionConsejeros === null) {
			if ($this->isNew()) {
				$this->collNotificacionConsejeros = array();
			} else {

				$criteria->add(NotificacionConsejeroPeer::CLAUSTRO_ID, $this->getId());

				$this->collNotificacionConsejeros = NotificacionConsejeroPeer::doSelectJoinNotificacion($criteria, $con);
			}
		} else {
									
			$criteria->add(NotificacionConsejeroPeer::CLAUSTRO_ID, $this->getId());

			if (!isset($this->lastNotificacionConsejeroCriteria) || !$this->lastNotificacionConsejeroCriteria->equals($criteria)) {
				$this->collNotificacionConsejeros = NotificacionConsejeroPeer::doSelectJoinNotificacion($criteria, $con);
			}
		}
		$this->lastNotificacionConsejeroCriteria = $criteria;

		return $this->collNotificacionConsejeros;
	}


	
	public function getNotificacionConsejerosJoinConsejero($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseNotificacionConsejeroPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collNotificacionConsejeros === null) {
			if ($this->isNew()) {
				$this->collNotificacionConsejeros = array();
			} else {

				$criteria->add(NotificacionConsejeroPeer::CLAUSTRO_ID, $this->getId());

				$this->collNotificacionConsejeros = NotificacionConsejeroPeer::doSelectJoinConsejero($criteria, $con);
			}
		} else {
									
			$criteria->add(NotificacionConsejeroPeer::CLAUSTRO_ID, $this->getId());

			if (!isset($this->lastNotificacionConsejeroCriteria) || !$this->lastNotificacionConsejeroCriteria->equals($criteria)) {
				$this->collNotificacionConsejeros = NotificacionConsejeroPeer::doSelectJoinConsejero($criteria, $con);
			}
		}
		$this->lastNotificacionConsejeroCriteria = $criteria;

		return $this->collNotificacionConsejeros;
	}

	
	public function initClaustroConsejeros()
	{
		if ($this->collClaustroConsejeros === null) {
			$this->collClaustroConsejeros = array();
		}
	}

	
	public function getClaustroConsejeros($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseClaustroConsejeroPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collClaustroConsejeros === null) {
			if ($this->isNew()) {
			   $this->collClaustroConsejeros = array();
			} else {

				$criteria->add(ClaustroConsejeroPeer::CLAUSTRO_ID, $this->getId());

				ClaustroConsejeroPeer::addSelectColumns($criteria);
				$this->collClaustroConsejeros = ClaustroConsejeroPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(ClaustroConsejeroPeer::CLAUSTRO_ID, $this->getId());

				ClaustroConsejeroPeer::addSelectColumns($criteria);
				if (!isset($this->lastClaustroConsejeroCriteria) || !$this->lastClaustroConsejeroCriteria->equals($criteria)) {
					$this->collClaustroConsejeros = ClaustroConsejeroPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastClaustroConsejeroCriteria = $criteria;
		return $this->collClaustroConsejeros;
	}

	
	public function countClaustroConsejeros($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseClaustroConsejeroPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(ClaustroConsejeroPeer::CLAUSTRO_ID, $this->getId());

		return ClaustroConsejeroPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addClaustroConsejero(ClaustroConsejero $l)
	{
		$this->collClaustroConsejeros[] = $l;
		$l->setClaustro($this);
	}


	
	public function getClaustroConsejerosJoinConsejero($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseClaustroConsejeroPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collClaustroConsejeros === null) {
			if ($this->isNew()) {
				$this->collClaustroConsejeros = array();
			} else {

				$criteria->add(ClaustroConsejeroPeer::CLAUSTRO_ID, $this->getId());

				$this->collClaustroConsejeros = ClaustroConsejeroPeer::doSelectJoinConsejero($criteria, $con);
			}
		} else {
									
			$criteria->add(ClaustroConsejeroPeer::CLAUSTRO_ID, $this->getId());

			if (!isset($this->lastClaustroConsejeroCriteria) || !$this->lastClaustroConsejeroCriteria->equals($criteria)) {
				$this->collClaustroConsejeros = ClaustroConsejeroPeer::doSelectJoinConsejero($criteria, $con);
			}
		}
		$this->lastClaustroConsejeroCriteria = $criteria;

		return $this->collClaustroConsejeros;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseClaustro:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseClaustro::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} 