<?php


abstract class BaseComision extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $consejero_id;


	
	protected $nombre;


	
	protected $titular;


	
	protected $direccion;


	
	protected $referencia;

	
	protected $aConsejero;

	
	protected $collNotificacionComisions;

	
	protected $lastNotificacionComisionCriteria = null;

	
	protected $collComisionConsejeros;

	
	protected $lastComisionConsejeroCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getConsejeroId()
	{

		return $this->consejero_id;
	}

	
	public function getNombre()
	{

		return $this->nombre;
	}

	
	public function getTitular()
	{

		return $this->titular;
	}

	
	public function getDireccion()
	{

		return $this->direccion;
	}

	
	public function getReferencia()
	{

		return $this->referencia;
	}

	
	public function setId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = ComisionPeer::ID;
		}

	} 
	
	public function setConsejeroId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->consejero_id !== $v) {
			$this->consejero_id = $v;
			$this->modifiedColumns[] = ComisionPeer::CONSEJERO_ID;
		}

		if ($this->aConsejero !== null && $this->aConsejero->getId() !== $v) {
			$this->aConsejero = null;
		}

	} 
	
	public function setNombre($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->nombre !== $v) {
			$this->nombre = $v;
			$this->modifiedColumns[] = ComisionPeer::NOMBRE;
		}

	} 
	
	public function setTitular($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->titular !== $v) {
			$this->titular = $v;
			$this->modifiedColumns[] = ComisionPeer::TITULAR;
		}

	} 
	
	public function setDireccion($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->direccion !== $v) {
			$this->direccion = $v;
			$this->modifiedColumns[] = ComisionPeer::DIRECCION;
		}

	} 
	
	public function setReferencia($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->referencia !== $v) {
			$this->referencia = $v;
			$this->modifiedColumns[] = ComisionPeer::REFERENCIA;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->consejero_id = $rs->getInt($startcol + 1);

			$this->nombre = $rs->getString($startcol + 2);

			$this->titular = $rs->getString($startcol + 3);

			$this->direccion = $rs->getString($startcol + 4);

			$this->referencia = $rs->getString($startcol + 5);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 6; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Comision object", $e);
		}
	}

	
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BaseComision:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ComisionPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			ComisionPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseComision:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BaseComision:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ComisionPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseComision:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->aConsejero !== null) {
				if ($this->aConsejero->isModified()) {
					$affectedRows += $this->aConsejero->save($con);
				}
				$this->setConsejero($this->aConsejero);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = ComisionPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += ComisionPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collNotificacionComisions !== null) {
				foreach($this->collNotificacionComisions as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collComisionConsejeros !== null) {
				foreach($this->collComisionConsejeros as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aConsejero !== null) {
				if (!$this->aConsejero->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aConsejero->getValidationFailures());
				}
			}


			if (($retval = ComisionPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collNotificacionComisions !== null) {
					foreach($this->collNotificacionComisions as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collComisionConsejeros !== null) {
					foreach($this->collComisionConsejeros as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ComisionPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getConsejeroId();
				break;
			case 2:
				return $this->getNombre();
				break;
			case 3:
				return $this->getTitular();
				break;
			case 4:
				return $this->getDireccion();
				break;
			case 5:
				return $this->getReferencia();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ComisionPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getConsejeroId(),
			$keys[2] => $this->getNombre(),
			$keys[3] => $this->getTitular(),
			$keys[4] => $this->getDireccion(),
			$keys[5] => $this->getReferencia(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ComisionPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setConsejeroId($value);
				break;
			case 2:
				$this->setNombre($value);
				break;
			case 3:
				$this->setTitular($value);
				break;
			case 4:
				$this->setDireccion($value);
				break;
			case 5:
				$this->setReferencia($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ComisionPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setConsejeroId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setNombre($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setTitular($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setDireccion($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setReferencia($arr[$keys[5]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(ComisionPeer::DATABASE_NAME);

		if ($this->isColumnModified(ComisionPeer::ID)) $criteria->add(ComisionPeer::ID, $this->id);
		if ($this->isColumnModified(ComisionPeer::CONSEJERO_ID)) $criteria->add(ComisionPeer::CONSEJERO_ID, $this->consejero_id);
		if ($this->isColumnModified(ComisionPeer::NOMBRE)) $criteria->add(ComisionPeer::NOMBRE, $this->nombre);
		if ($this->isColumnModified(ComisionPeer::TITULAR)) $criteria->add(ComisionPeer::TITULAR, $this->titular);
		if ($this->isColumnModified(ComisionPeer::DIRECCION)) $criteria->add(ComisionPeer::DIRECCION, $this->direccion);
		if ($this->isColumnModified(ComisionPeer::REFERENCIA)) $criteria->add(ComisionPeer::REFERENCIA, $this->referencia);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(ComisionPeer::DATABASE_NAME);

		$criteria->add(ComisionPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setConsejeroId($this->consejero_id);

		$copyObj->setNombre($this->nombre);

		$copyObj->setTitular($this->titular);

		$copyObj->setDireccion($this->direccion);

		$copyObj->setReferencia($this->referencia);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getNotificacionComisions() as $relObj) {
				$copyObj->addNotificacionComision($relObj->copy($deepCopy));
			}

			foreach($this->getComisionConsejeros() as $relObj) {
				$copyObj->addComisionConsejero($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new ComisionPeer();
		}
		return self::$peer;
	}

	
	public function setConsejero($v)
	{


		if ($v === null) {
			$this->setConsejeroId(NULL);
		} else {
			$this->setConsejeroId($v->getId());
		}


		$this->aConsejero = $v;
	}


	
	public function getConsejero($con = null)
	{
		if ($this->aConsejero === null && ($this->consejero_id !== null)) {
						include_once 'lib/model/om/BaseConsejeroPeer.php';

			$this->aConsejero = ConsejeroPeer::retrieveByPK($this->consejero_id, $con);

			
		}
		return $this->aConsejero;
	}

	
	public function initNotificacionComisions()
	{
		if ($this->collNotificacionComisions === null) {
			$this->collNotificacionComisions = array();
		}
	}

	
	public function getNotificacionComisions($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseNotificacionComisionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collNotificacionComisions === null) {
			if ($this->isNew()) {
			   $this->collNotificacionComisions = array();
			} else {

				$criteria->add(NotificacionComisionPeer::COMISION_ID, $this->getId());

				NotificacionComisionPeer::addSelectColumns($criteria);
				$this->collNotificacionComisions = NotificacionComisionPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(NotificacionComisionPeer::COMISION_ID, $this->getId());

				NotificacionComisionPeer::addSelectColumns($criteria);
				if (!isset($this->lastNotificacionComisionCriteria) || !$this->lastNotificacionComisionCriteria->equals($criteria)) {
					$this->collNotificacionComisions = NotificacionComisionPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastNotificacionComisionCriteria = $criteria;
		return $this->collNotificacionComisions;
	}

	
	public function countNotificacionComisions($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseNotificacionComisionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(NotificacionComisionPeer::COMISION_ID, $this->getId());

		return NotificacionComisionPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addNotificacionComision(NotificacionComision $l)
	{
		$this->collNotificacionComisions[] = $l;
		$l->setComision($this);
	}


	
	public function getNotificacionComisionsJoinNotificacion($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseNotificacionComisionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collNotificacionComisions === null) {
			if ($this->isNew()) {
				$this->collNotificacionComisions = array();
			} else {

				$criteria->add(NotificacionComisionPeer::COMISION_ID, $this->getId());

				$this->collNotificacionComisions = NotificacionComisionPeer::doSelectJoinNotificacion($criteria, $con);
			}
		} else {
									
			$criteria->add(NotificacionComisionPeer::COMISION_ID, $this->getId());

			if (!isset($this->lastNotificacionComisionCriteria) || !$this->lastNotificacionComisionCriteria->equals($criteria)) {
				$this->collNotificacionComisions = NotificacionComisionPeer::doSelectJoinNotificacion($criteria, $con);
			}
		}
		$this->lastNotificacionComisionCriteria = $criteria;

		return $this->collNotificacionComisions;
	}

	
	public function initComisionConsejeros()
	{
		if ($this->collComisionConsejeros === null) {
			$this->collComisionConsejeros = array();
		}
	}

	
	public function getComisionConsejeros($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseComisionConsejeroPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collComisionConsejeros === null) {
			if ($this->isNew()) {
			   $this->collComisionConsejeros = array();
			} else {

				$criteria->add(ComisionConsejeroPeer::COMISION_ID, $this->getId());

				ComisionConsejeroPeer::addSelectColumns($criteria);
				$this->collComisionConsejeros = ComisionConsejeroPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(ComisionConsejeroPeer::COMISION_ID, $this->getId());

				ComisionConsejeroPeer::addSelectColumns($criteria);
				if (!isset($this->lastComisionConsejeroCriteria) || !$this->lastComisionConsejeroCriteria->equals($criteria)) {
					$this->collComisionConsejeros = ComisionConsejeroPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastComisionConsejeroCriteria = $criteria;
		return $this->collComisionConsejeros;
	}

	
	public function countComisionConsejeros($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseComisionConsejeroPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(ComisionConsejeroPeer::COMISION_ID, $this->getId());

		return ComisionConsejeroPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addComisionConsejero(ComisionConsejero $l)
	{
		$this->collComisionConsejeros[] = $l;
		$l->setComision($this);
	}


	
	public function getComisionConsejerosJoinConsejero($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseComisionConsejeroPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collComisionConsejeros === null) {
			if ($this->isNew()) {
				$this->collComisionConsejeros = array();
			} else {

				$criteria->add(ComisionConsejeroPeer::COMISION_ID, $this->getId());

				$this->collComisionConsejeros = ComisionConsejeroPeer::doSelectJoinConsejero($criteria, $con);
			}
		} else {
									
			$criteria->add(ComisionConsejeroPeer::COMISION_ID, $this->getId());

			if (!isset($this->lastComisionConsejeroCriteria) || !$this->lastComisionConsejeroCriteria->equals($criteria)) {
				$this->collComisionConsejeros = ComisionConsejeroPeer::doSelectJoinConsejero($criteria, $con);
			}
		}
		$this->lastComisionConsejeroCriteria = $criteria;

		return $this->collComisionConsejeros;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseComision:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseComision::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} 