<?php


abstract class BaseComisionConsejero extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $consejero_id;


	
	protected $comision_id;


	
	protected $created_at;

	
	protected $aConsejero;

	
	protected $aComision;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getConsejeroId()
	{

		return $this->consejero_id;
	}

	
	public function getComisionId()
	{

		return $this->comision_id;
	}

	
	public function getCreatedAt($format = 'd/m/Y H:i:s')
	{

		if ($this->created_at === null || $this->created_at === '') {
			return null;
		} elseif (!is_int($this->created_at)) {
						$ts = strtotime($this->created_at);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [created_at] as date/time value: " . var_export($this->created_at, true));
			}
		} else {
			$ts = $this->created_at;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function setId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = ComisionConsejeroPeer::ID;
		}

	} 
	
	public function setConsejeroId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->consejero_id !== $v) {
			$this->consejero_id = $v;
			$this->modifiedColumns[] = ComisionConsejeroPeer::CONSEJERO_ID;
		}

		if ($this->aConsejero !== null && $this->aConsejero->getId() !== $v) {
			$this->aConsejero = null;
		}

	} 
	
	public function setComisionId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->comision_id !== $v) {
			$this->comision_id = $v;
			$this->modifiedColumns[] = ComisionConsejeroPeer::COMISION_ID;
		}

		if ($this->aComision !== null && $this->aComision->getId() !== $v) {
			$this->aComision = null;
		}

	} 
	
	public function setCreatedAt($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [created_at] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->created_at !== $ts) {
			$this->created_at = $ts;
			$this->modifiedColumns[] = ComisionConsejeroPeer::CREATED_AT;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->consejero_id = $rs->getInt($startcol + 1);

			$this->comision_id = $rs->getInt($startcol + 2);

			$this->created_at = $rs->getTimestamp($startcol + 3, null);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 4; 
		} catch (Exception $e) {
			throw new PropelException("Error populating ComisionConsejero object", $e);
		}
	}

	
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BaseComisionConsejero:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ComisionConsejeroPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			ComisionConsejeroPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseComisionConsejero:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BaseComisionConsejero:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


    if ($this->isNew() && !$this->isColumnModified(ComisionConsejeroPeer::CREATED_AT))
    {
      $this->setCreatedAt(time());
    }

		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ComisionConsejeroPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseComisionConsejero:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->aConsejero !== null) {
				if ($this->aConsejero->isModified()) {
					$affectedRows += $this->aConsejero->save($con);
				}
				$this->setConsejero($this->aConsejero);
			}

			if ($this->aComision !== null) {
				if ($this->aComision->isModified()) {
					$affectedRows += $this->aComision->save($con);
				}
				$this->setComision($this->aComision);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = ComisionConsejeroPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += ComisionConsejeroPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aConsejero !== null) {
				if (!$this->aConsejero->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aConsejero->getValidationFailures());
				}
			}

			if ($this->aComision !== null) {
				if (!$this->aComision->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aComision->getValidationFailures());
				}
			}


			if (($retval = ComisionConsejeroPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ComisionConsejeroPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getConsejeroId();
				break;
			case 2:
				return $this->getComisionId();
				break;
			case 3:
				return $this->getCreatedAt();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ComisionConsejeroPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getConsejeroId(),
			$keys[2] => $this->getComisionId(),
			$keys[3] => $this->getCreatedAt(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ComisionConsejeroPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setConsejeroId($value);
				break;
			case 2:
				$this->setComisionId($value);
				break;
			case 3:
				$this->setCreatedAt($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ComisionConsejeroPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setConsejeroId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setComisionId($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setCreatedAt($arr[$keys[3]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(ComisionConsejeroPeer::DATABASE_NAME);

		if ($this->isColumnModified(ComisionConsejeroPeer::ID)) $criteria->add(ComisionConsejeroPeer::ID, $this->id);
		if ($this->isColumnModified(ComisionConsejeroPeer::CONSEJERO_ID)) $criteria->add(ComisionConsejeroPeer::CONSEJERO_ID, $this->consejero_id);
		if ($this->isColumnModified(ComisionConsejeroPeer::COMISION_ID)) $criteria->add(ComisionConsejeroPeer::COMISION_ID, $this->comision_id);
		if ($this->isColumnModified(ComisionConsejeroPeer::CREATED_AT)) $criteria->add(ComisionConsejeroPeer::CREATED_AT, $this->created_at);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(ComisionConsejeroPeer::DATABASE_NAME);

		$criteria->add(ComisionConsejeroPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setConsejeroId($this->consejero_id);

		$copyObj->setComisionId($this->comision_id);

		$copyObj->setCreatedAt($this->created_at);


		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new ComisionConsejeroPeer();
		}
		return self::$peer;
	}

	
	public function setConsejero($v)
	{


		if ($v === null) {
			$this->setConsejeroId(NULL);
		} else {
			$this->setConsejeroId($v->getId());
		}


		$this->aConsejero = $v;
	}


	
	public function getConsejero($con = null)
	{
		if ($this->aConsejero === null && ($this->consejero_id !== null)) {
						include_once 'lib/model/om/BaseConsejeroPeer.php';

			$this->aConsejero = ConsejeroPeer::retrieveByPK($this->consejero_id, $con);

			
		}
		return $this->aConsejero;
	}

	
	public function setComision($v)
	{


		if ($v === null) {
			$this->setComisionId(NULL);
		} else {
			$this->setComisionId($v->getId());
		}


		$this->aComision = $v;
	}


	
	public function getComision($con = null)
	{
		if ($this->aComision === null && ($this->comision_id !== null)) {
						include_once 'lib/model/om/BaseComisionPeer.php';

			$this->aComision = ComisionPeer::retrieveByPK($this->comision_id, $con);

			
		}
		return $this->aComision;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseComisionConsejero:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseComisionConsejero::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} 