<?php


abstract class BaseExpediente extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $con_facultades_id;


	
	protected $con_carreras_id;


	
	protected $alumno_id;


	
	protected $nro_exp_fac;


	
	protected $fecha_inicio;


	
	protected $fecha_pase_ministerio;


	
	protected $fecha_recibido_ministerio;


	
	protected $fecha_pase_sec_adm;


	
	protected $fecha_recibido_sec_adm;


	
	protected $fecha_retiro_fac;


	
	protected $created_at;


	
	protected $observaciones;


	
	protected $res_rectoral;


	
	protected $res_rectoral_fecha;


	
	protected $fecha_egreso_alumno;


	
	protected $reg_universitario;

	
	protected $aFacultad;

	
	protected $aCarrera;

	
	protected $aAlumno;

	
	protected $collExpedientePasefacultads;

	
	protected $lastExpedientePasefacultadCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getConFacultadesId()
	{

		return $this->con_facultades_id;
	}

	
	public function getConCarrerasId()
	{

		return $this->con_carreras_id;
	}

	
	public function getAlumnoId()
	{

		return $this->alumno_id;
	}

	
	public function getNroExpFac()
	{

		return $this->nro_exp_fac;
	}

	
	public function getFechaInicio($format = '%d/%m/%Y')
	{

		if ($this->fecha_inicio === null || $this->fecha_inicio === '') {
			return null;
		} elseif (!is_int($this->fecha_inicio)) {
						$ts = strtotime($this->fecha_inicio);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [fecha_inicio] as date/time value: " . var_export($this->fecha_inicio, true));
			}
		} else {
			$ts = $this->fecha_inicio;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getFechaPaseMinisterio($format = '%d/%m/%Y')
	{

		if ($this->fecha_pase_ministerio === null || $this->fecha_pase_ministerio === '') {
			return null;
		} elseif (!is_int($this->fecha_pase_ministerio)) {
						$ts = strtotime($this->fecha_pase_ministerio);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [fecha_pase_ministerio] as date/time value: " . var_export($this->fecha_pase_ministerio, true));
			}
		} else {
			$ts = $this->fecha_pase_ministerio;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getFechaRecibidoMinisterio($format = '%d/%m/%Y')
	{

		if ($this->fecha_recibido_ministerio === null || $this->fecha_recibido_ministerio === '') {
			return null;
		} elseif (!is_int($this->fecha_recibido_ministerio)) {
						$ts = strtotime($this->fecha_recibido_ministerio);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [fecha_recibido_ministerio] as date/time value: " . var_export($this->fecha_recibido_ministerio, true));
			}
		} else {
			$ts = $this->fecha_recibido_ministerio;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getFechaPaseSecAdm($format = '%d/%m/%Y')
	{

		if ($this->fecha_pase_sec_adm === null || $this->fecha_pase_sec_adm === '') {
			return null;
		} elseif (!is_int($this->fecha_pase_sec_adm)) {
						$ts = strtotime($this->fecha_pase_sec_adm);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [fecha_pase_sec_adm] as date/time value: " . var_export($this->fecha_pase_sec_adm, true));
			}
		} else {
			$ts = $this->fecha_pase_sec_adm;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getFechaRecibidoSecAdm($format = '%d/%m/%Y')
	{

		if ($this->fecha_recibido_sec_adm === null || $this->fecha_recibido_sec_adm === '') {
			return null;
		} elseif (!is_int($this->fecha_recibido_sec_adm)) {
						$ts = strtotime($this->fecha_recibido_sec_adm);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [fecha_recibido_sec_adm] as date/time value: " . var_export($this->fecha_recibido_sec_adm, true));
			}
		} else {
			$ts = $this->fecha_recibido_sec_adm;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getFechaRetiroFac($format = '%d/%m/%Y')
	{

		if ($this->fecha_retiro_fac === null || $this->fecha_retiro_fac === '') {
			return null;
		} elseif (!is_int($this->fecha_retiro_fac)) {
						$ts = strtotime($this->fecha_retiro_fac);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [fecha_retiro_fac] as date/time value: " . var_export($this->fecha_retiro_fac, true));
			}
		} else {
			$ts = $this->fecha_retiro_fac;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getCreatedAt($format = 'd/m/Y H:i:s')
	{

		if ($this->created_at === null || $this->created_at === '') {
			return null;
		} elseif (!is_int($this->created_at)) {
						$ts = strtotime($this->created_at);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [created_at] as date/time value: " . var_export($this->created_at, true));
			}
		} else {
			$ts = $this->created_at;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getObservaciones()
	{

		return $this->observaciones;
	}

	
	public function getResRectoral()
	{

		return $this->res_rectoral;
	}

	
	public function getResRectoralFecha($format = '%d/%m/%Y')
	{

		if ($this->res_rectoral_fecha === null || $this->res_rectoral_fecha === '') {
			return null;
		} elseif (!is_int($this->res_rectoral_fecha)) {
						$ts = strtotime($this->res_rectoral_fecha);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [res_rectoral_fecha] as date/time value: " . var_export($this->res_rectoral_fecha, true));
			}
		} else {
			$ts = $this->res_rectoral_fecha;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getFechaEgresoAlumno($format = '%d/%m/%Y')
	{

		if ($this->fecha_egreso_alumno === null || $this->fecha_egreso_alumno === '') {
			return null;
		} elseif (!is_int($this->fecha_egreso_alumno)) {
						$ts = strtotime($this->fecha_egreso_alumno);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [fecha_egreso_alumno] as date/time value: " . var_export($this->fecha_egreso_alumno, true));
			}
		} else {
			$ts = $this->fecha_egreso_alumno;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getRegUniversitario()
	{

		return $this->reg_universitario;
	}

	
	public function setId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = ExpedientePeer::ID;
		}

	} 
	
	public function setConFacultadesId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->con_facultades_id !== $v) {
			$this->con_facultades_id = $v;
			$this->modifiedColumns[] = ExpedientePeer::CON_FACULTADES_ID;
		}

		if ($this->aFacultad !== null && $this->aFacultad->getId() !== $v) {
			$this->aFacultad = null;
		}

	} 
	
	public function setConCarrerasId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->con_carreras_id !== $v) {
			$this->con_carreras_id = $v;
			$this->modifiedColumns[] = ExpedientePeer::CON_CARRERAS_ID;
		}

		if ($this->aCarrera !== null && $this->aCarrera->getId() !== $v) {
			$this->aCarrera = null;
		}

	} 
	
	public function setAlumnoId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->alumno_id !== $v) {
			$this->alumno_id = $v;
			$this->modifiedColumns[] = ExpedientePeer::ALUMNO_ID;
		}

		if ($this->aAlumno !== null && $this->aAlumno->getId() !== $v) {
			$this->aAlumno = null;
		}

	} 
	
	public function setNroExpFac($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->nro_exp_fac !== $v) {
			$this->nro_exp_fac = $v;
			$this->modifiedColumns[] = ExpedientePeer::NRO_EXP_FAC;
		}

	} 
	
	public function setFechaInicio($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [fecha_inicio] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->fecha_inicio !== $ts) {
			$this->fecha_inicio = $ts;
			$this->modifiedColumns[] = ExpedientePeer::FECHA_INICIO;
		}

	} 
	
	public function setFechaPaseMinisterio($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [fecha_pase_ministerio] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->fecha_pase_ministerio !== $ts) {
			$this->fecha_pase_ministerio = $ts;
			$this->modifiedColumns[] = ExpedientePeer::FECHA_PASE_MINISTERIO;
		}

	} 
	
	public function setFechaRecibidoMinisterio($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [fecha_recibido_ministerio] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->fecha_recibido_ministerio !== $ts) {
			$this->fecha_recibido_ministerio = $ts;
			$this->modifiedColumns[] = ExpedientePeer::FECHA_RECIBIDO_MINISTERIO;
		}

	} 
	
	public function setFechaPaseSecAdm($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [fecha_pase_sec_adm] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->fecha_pase_sec_adm !== $ts) {
			$this->fecha_pase_sec_adm = $ts;
			$this->modifiedColumns[] = ExpedientePeer::FECHA_PASE_SEC_ADM;
		}

	} 
	
	public function setFechaRecibidoSecAdm($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [fecha_recibido_sec_adm] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->fecha_recibido_sec_adm !== $ts) {
			$this->fecha_recibido_sec_adm = $ts;
			$this->modifiedColumns[] = ExpedientePeer::FECHA_RECIBIDO_SEC_ADM;
		}

	} 
	
	public function setFechaRetiroFac($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [fecha_retiro_fac] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->fecha_retiro_fac !== $ts) {
			$this->fecha_retiro_fac = $ts;
			$this->modifiedColumns[] = ExpedientePeer::FECHA_RETIRO_FAC;
		}

	} 
	
	public function setCreatedAt($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [created_at] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->created_at !== $ts) {
			$this->created_at = $ts;
			$this->modifiedColumns[] = ExpedientePeer::CREATED_AT;
		}

	} 
	
	public function setObservaciones($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->observaciones !== $v) {
			$this->observaciones = $v;
			$this->modifiedColumns[] = ExpedientePeer::OBSERVACIONES;
		}

	} 
	
	public function setResRectoral($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->res_rectoral !== $v) {
			$this->res_rectoral = $v;
			$this->modifiedColumns[] = ExpedientePeer::RES_RECTORAL;
		}

	} 
	
	public function setResRectoralFecha($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [res_rectoral_fecha] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->res_rectoral_fecha !== $ts) {
			$this->res_rectoral_fecha = $ts;
			$this->modifiedColumns[] = ExpedientePeer::RES_RECTORAL_FECHA;
		}

	} 
	
	public function setFechaEgresoAlumno($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [fecha_egreso_alumno] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->fecha_egreso_alumno !== $ts) {
			$this->fecha_egreso_alumno = $ts;
			$this->modifiedColumns[] = ExpedientePeer::FECHA_EGRESO_ALUMNO;
		}

	} 
	
	public function setRegUniversitario($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->reg_universitario !== $v) {
			$this->reg_universitario = $v;
			$this->modifiedColumns[] = ExpedientePeer::REG_UNIVERSITARIO;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->con_facultades_id = $rs->getInt($startcol + 1);

			$this->con_carreras_id = $rs->getInt($startcol + 2);

			$this->alumno_id = $rs->getInt($startcol + 3);

			$this->nro_exp_fac = $rs->getString($startcol + 4);

			$this->fecha_inicio = $rs->getDate($startcol + 5, null);

			$this->fecha_pase_ministerio = $rs->getDate($startcol + 6, null);

			$this->fecha_recibido_ministerio = $rs->getDate($startcol + 7, null);

			$this->fecha_pase_sec_adm = $rs->getDate($startcol + 8, null);

			$this->fecha_recibido_sec_adm = $rs->getDate($startcol + 9, null);

			$this->fecha_retiro_fac = $rs->getDate($startcol + 10, null);

			$this->created_at = $rs->getTimestamp($startcol + 11, null);

			$this->observaciones = $rs->getString($startcol + 12);

			$this->res_rectoral = $rs->getInt($startcol + 13);

			$this->res_rectoral_fecha = $rs->getDate($startcol + 14, null);

			$this->fecha_egreso_alumno = $rs->getDate($startcol + 15, null);

			$this->reg_universitario = $rs->getString($startcol + 16);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 17; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Expediente object", $e);
		}
	}

	
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BaseExpediente:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ExpedientePeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			ExpedientePeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseExpediente:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BaseExpediente:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


    if ($this->isNew() && !$this->isColumnModified(ExpedientePeer::CREATED_AT))
    {
      $this->setCreatedAt(time());
    }

		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ExpedientePeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseExpediente:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->aFacultad !== null) {
				if ($this->aFacultad->isModified()) {
					$affectedRows += $this->aFacultad->save($con);
				}
				$this->setFacultad($this->aFacultad);
			}

			if ($this->aCarrera !== null) {
				if ($this->aCarrera->isModified()) {
					$affectedRows += $this->aCarrera->save($con);
				}
				$this->setCarrera($this->aCarrera);
			}

			if ($this->aAlumno !== null) {
				if ($this->aAlumno->isModified()) {
					$affectedRows += $this->aAlumno->save($con);
				}
				$this->setAlumno($this->aAlumno);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = ExpedientePeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += ExpedientePeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collExpedientePasefacultads !== null) {
				foreach($this->collExpedientePasefacultads as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aFacultad !== null) {
				if (!$this->aFacultad->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aFacultad->getValidationFailures());
				}
			}

			if ($this->aCarrera !== null) {
				if (!$this->aCarrera->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aCarrera->getValidationFailures());
				}
			}

			if ($this->aAlumno !== null) {
				if (!$this->aAlumno->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aAlumno->getValidationFailures());
				}
			}


			if (($retval = ExpedientePeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collExpedientePasefacultads !== null) {
					foreach($this->collExpedientePasefacultads as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ExpedientePeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getConFacultadesId();
				break;
			case 2:
				return $this->getConCarrerasId();
				break;
			case 3:
				return $this->getAlumnoId();
				break;
			case 4:
				return $this->getNroExpFac();
				break;
			case 5:
				return $this->getFechaInicio();
				break;
			case 6:
				return $this->getFechaPaseMinisterio();
				break;
			case 7:
				return $this->getFechaRecibidoMinisterio();
				break;
			case 8:
				return $this->getFechaPaseSecAdm();
				break;
			case 9:
				return $this->getFechaRecibidoSecAdm();
				break;
			case 10:
				return $this->getFechaRetiroFac();
				break;
			case 11:
				return $this->getCreatedAt();
				break;
			case 12:
				return $this->getObservaciones();
				break;
			case 13:
				return $this->getResRectoral();
				break;
			case 14:
				return $this->getResRectoralFecha();
				break;
			case 15:
				return $this->getFechaEgresoAlumno();
				break;
			case 16:
				return $this->getRegUniversitario();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ExpedientePeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getConFacultadesId(),
			$keys[2] => $this->getConCarrerasId(),
			$keys[3] => $this->getAlumnoId(),
			$keys[4] => $this->getNroExpFac(),
			$keys[5] => $this->getFechaInicio(),
			$keys[6] => $this->getFechaPaseMinisterio(),
			$keys[7] => $this->getFechaRecibidoMinisterio(),
			$keys[8] => $this->getFechaPaseSecAdm(),
			$keys[9] => $this->getFechaRecibidoSecAdm(),
			$keys[10] => $this->getFechaRetiroFac(),
			$keys[11] => $this->getCreatedAt(),
			$keys[12] => $this->getObservaciones(),
			$keys[13] => $this->getResRectoral(),
			$keys[14] => $this->getResRectoralFecha(),
			$keys[15] => $this->getFechaEgresoAlumno(),
			$keys[16] => $this->getRegUniversitario(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ExpedientePeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setConFacultadesId($value);
				break;
			case 2:
				$this->setConCarrerasId($value);
				break;
			case 3:
				$this->setAlumnoId($value);
				break;
			case 4:
				$this->setNroExpFac($value);
				break;
			case 5:
				$this->setFechaInicio($value);
				break;
			case 6:
				$this->setFechaPaseMinisterio($value);
				break;
			case 7:
				$this->setFechaRecibidoMinisterio($value);
				break;
			case 8:
				$this->setFechaPaseSecAdm($value);
				break;
			case 9:
				$this->setFechaRecibidoSecAdm($value);
				break;
			case 10:
				$this->setFechaRetiroFac($value);
				break;
			case 11:
				$this->setCreatedAt($value);
				break;
			case 12:
				$this->setObservaciones($value);
				break;
			case 13:
				$this->setResRectoral($value);
				break;
			case 14:
				$this->setResRectoralFecha($value);
				break;
			case 15:
				$this->setFechaEgresoAlumno($value);
				break;
			case 16:
				$this->setRegUniversitario($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ExpedientePeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setConFacultadesId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setConCarrerasId($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setAlumnoId($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setNroExpFac($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setFechaInicio($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setFechaPaseMinisterio($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setFechaRecibidoMinisterio($arr[$keys[7]]);
		if (array_key_exists($keys[8], $arr)) $this->setFechaPaseSecAdm($arr[$keys[8]]);
		if (array_key_exists($keys[9], $arr)) $this->setFechaRecibidoSecAdm($arr[$keys[9]]);
		if (array_key_exists($keys[10], $arr)) $this->setFechaRetiroFac($arr[$keys[10]]);
		if (array_key_exists($keys[11], $arr)) $this->setCreatedAt($arr[$keys[11]]);
		if (array_key_exists($keys[12], $arr)) $this->setObservaciones($arr[$keys[12]]);
		if (array_key_exists($keys[13], $arr)) $this->setResRectoral($arr[$keys[13]]);
		if (array_key_exists($keys[14], $arr)) $this->setResRectoralFecha($arr[$keys[14]]);
		if (array_key_exists($keys[15], $arr)) $this->setFechaEgresoAlumno($arr[$keys[15]]);
		if (array_key_exists($keys[16], $arr)) $this->setRegUniversitario($arr[$keys[16]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(ExpedientePeer::DATABASE_NAME);

		if ($this->isColumnModified(ExpedientePeer::ID)) $criteria->add(ExpedientePeer::ID, $this->id);
		if ($this->isColumnModified(ExpedientePeer::CON_FACULTADES_ID)) $criteria->add(ExpedientePeer::CON_FACULTADES_ID, $this->con_facultades_id);
		if ($this->isColumnModified(ExpedientePeer::CON_CARRERAS_ID)) $criteria->add(ExpedientePeer::CON_CARRERAS_ID, $this->con_carreras_id);
		if ($this->isColumnModified(ExpedientePeer::ALUMNO_ID)) $criteria->add(ExpedientePeer::ALUMNO_ID, $this->alumno_id);
		if ($this->isColumnModified(ExpedientePeer::NRO_EXP_FAC)) $criteria->add(ExpedientePeer::NRO_EXP_FAC, $this->nro_exp_fac);
		if ($this->isColumnModified(ExpedientePeer::FECHA_INICIO)) $criteria->add(ExpedientePeer::FECHA_INICIO, $this->fecha_inicio);
		if ($this->isColumnModified(ExpedientePeer::FECHA_PASE_MINISTERIO)) $criteria->add(ExpedientePeer::FECHA_PASE_MINISTERIO, $this->fecha_pase_ministerio);
		if ($this->isColumnModified(ExpedientePeer::FECHA_RECIBIDO_MINISTERIO)) $criteria->add(ExpedientePeer::FECHA_RECIBIDO_MINISTERIO, $this->fecha_recibido_ministerio);
		if ($this->isColumnModified(ExpedientePeer::FECHA_PASE_SEC_ADM)) $criteria->add(ExpedientePeer::FECHA_PASE_SEC_ADM, $this->fecha_pase_sec_adm);
		if ($this->isColumnModified(ExpedientePeer::FECHA_RECIBIDO_SEC_ADM)) $criteria->add(ExpedientePeer::FECHA_RECIBIDO_SEC_ADM, $this->fecha_recibido_sec_adm);
		if ($this->isColumnModified(ExpedientePeer::FECHA_RETIRO_FAC)) $criteria->add(ExpedientePeer::FECHA_RETIRO_FAC, $this->fecha_retiro_fac);
		if ($this->isColumnModified(ExpedientePeer::CREATED_AT)) $criteria->add(ExpedientePeer::CREATED_AT, $this->created_at);
		if ($this->isColumnModified(ExpedientePeer::OBSERVACIONES)) $criteria->add(ExpedientePeer::OBSERVACIONES, $this->observaciones);
		if ($this->isColumnModified(ExpedientePeer::RES_RECTORAL)) $criteria->add(ExpedientePeer::RES_RECTORAL, $this->res_rectoral);
		if ($this->isColumnModified(ExpedientePeer::RES_RECTORAL_FECHA)) $criteria->add(ExpedientePeer::RES_RECTORAL_FECHA, $this->res_rectoral_fecha);
		if ($this->isColumnModified(ExpedientePeer::FECHA_EGRESO_ALUMNO)) $criteria->add(ExpedientePeer::FECHA_EGRESO_ALUMNO, $this->fecha_egreso_alumno);
		if ($this->isColumnModified(ExpedientePeer::REG_UNIVERSITARIO)) $criteria->add(ExpedientePeer::REG_UNIVERSITARIO, $this->reg_universitario);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(ExpedientePeer::DATABASE_NAME);

		$criteria->add(ExpedientePeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setConFacultadesId($this->con_facultades_id);

		$copyObj->setConCarrerasId($this->con_carreras_id);

		$copyObj->setAlumnoId($this->alumno_id);

		$copyObj->setNroExpFac($this->nro_exp_fac);

		$copyObj->setFechaInicio($this->fecha_inicio);

		$copyObj->setFechaPaseMinisterio($this->fecha_pase_ministerio);

		$copyObj->setFechaRecibidoMinisterio($this->fecha_recibido_ministerio);

		$copyObj->setFechaPaseSecAdm($this->fecha_pase_sec_adm);

		$copyObj->setFechaRecibidoSecAdm($this->fecha_recibido_sec_adm);

		$copyObj->setFechaRetiroFac($this->fecha_retiro_fac);

		$copyObj->setCreatedAt($this->created_at);

		$copyObj->setObservaciones($this->observaciones);

		$copyObj->setResRectoral($this->res_rectoral);

		$copyObj->setResRectoralFecha($this->res_rectoral_fecha);

		$copyObj->setFechaEgresoAlumno($this->fecha_egreso_alumno);

		$copyObj->setRegUniversitario($this->reg_universitario);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getExpedientePasefacultads() as $relObj) {
				$copyObj->addExpedientePasefacultad($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new ExpedientePeer();
		}
		return self::$peer;
	}

	
	public function setFacultad($v)
	{


		if ($v === null) {
			$this->setConFacultadesId(NULL);
		} else {
			$this->setConFacultadesId($v->getId());
		}


		$this->aFacultad = $v;
	}


	
	public function getFacultad($con = null)
	{
		if ($this->aFacultad === null && ($this->con_facultades_id !== null)) {
						include_once 'lib/model/om/BaseFacultadPeer.php';

			$this->aFacultad = FacultadPeer::retrieveByPK($this->con_facultades_id, $con);

			
		}
		return $this->aFacultad;
	}

	
	public function setCarrera($v)
	{


		if ($v === null) {
			$this->setConCarrerasId(NULL);
		} else {
			$this->setConCarrerasId($v->getId());
		}


		$this->aCarrera = $v;
	}


	
	public function getCarrera($con = null)
	{
		if ($this->aCarrera === null && ($this->con_carreras_id !== null)) {
						include_once 'lib/model/om/BaseCarreraPeer.php';

			$this->aCarrera = CarreraPeer::retrieveByPK($this->con_carreras_id, $con);

			
		}
		return $this->aCarrera;
	}

	
	public function setAlumno($v)
	{


		if ($v === null) {
			$this->setAlumnoId(NULL);
		} else {
			$this->setAlumnoId($v->getId());
		}


		$this->aAlumno = $v;
	}


	
	public function getAlumno($con = null)
	{
		if ($this->aAlumno === null && ($this->alumno_id !== null)) {
						include_once 'lib/model/om/BaseAlumnoPeer.php';

			$this->aAlumno = AlumnoPeer::retrieveByPK($this->alumno_id, $con);

			
		}
		return $this->aAlumno;
	}

	
	public function initExpedientePasefacultads()
	{
		if ($this->collExpedientePasefacultads === null) {
			$this->collExpedientePasefacultads = array();
		}
	}

	
	public function getExpedientePasefacultads($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseExpedientePasefacultadPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collExpedientePasefacultads === null) {
			if ($this->isNew()) {
			   $this->collExpedientePasefacultads = array();
			} else {

				$criteria->add(ExpedientePasefacultadPeer::EXPEDIENTE_ID, $this->getId());

				ExpedientePasefacultadPeer::addSelectColumns($criteria);
				$this->collExpedientePasefacultads = ExpedientePasefacultadPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(ExpedientePasefacultadPeer::EXPEDIENTE_ID, $this->getId());

				ExpedientePasefacultadPeer::addSelectColumns($criteria);
				if (!isset($this->lastExpedientePasefacultadCriteria) || !$this->lastExpedientePasefacultadCriteria->equals($criteria)) {
					$this->collExpedientePasefacultads = ExpedientePasefacultadPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastExpedientePasefacultadCriteria = $criteria;
		return $this->collExpedientePasefacultads;
	}

	
	public function countExpedientePasefacultads($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseExpedientePasefacultadPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(ExpedientePasefacultadPeer::EXPEDIENTE_ID, $this->getId());

		return ExpedientePasefacultadPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addExpedientePasefacultad(ExpedientePasefacultad $l)
	{
		$this->collExpedientePasefacultads[] = $l;
		$l->setExpediente($this);
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseExpediente:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseExpediente::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} 