<?php


abstract class BaseExpedientePasefacultad extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $expediente_id;


	
	protected $fecha_pase;


	
	protected $fecha_retorno;


	
	protected $observaciones;

	
	protected $aExpediente;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getExpedienteId()
	{

		return $this->expediente_id;
	}

	
	public function getFechaPase($format = '%d/%m/%Y')
	{

		if ($this->fecha_pase === null || $this->fecha_pase === '') {
			return null;
		} elseif (!is_int($this->fecha_pase)) {
						$ts = strtotime($this->fecha_pase);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [fecha_pase] as date/time value: " . var_export($this->fecha_pase, true));
			}
		} else {
			$ts = $this->fecha_pase;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getFechaRetorno($format = '%d/%m/%Y')
	{

		if ($this->fecha_retorno === null || $this->fecha_retorno === '') {
			return null;
		} elseif (!is_int($this->fecha_retorno)) {
						$ts = strtotime($this->fecha_retorno);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [fecha_retorno] as date/time value: " . var_export($this->fecha_retorno, true));
			}
		} else {
			$ts = $this->fecha_retorno;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getObservaciones()
	{

		return $this->observaciones;
	}

	
	public function setId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = ExpedientePasefacultadPeer::ID;
		}

	} 
	
	public function setExpedienteId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->expediente_id !== $v) {
			$this->expediente_id = $v;
			$this->modifiedColumns[] = ExpedientePasefacultadPeer::EXPEDIENTE_ID;
		}

		if ($this->aExpediente !== null && $this->aExpediente->getId() !== $v) {
			$this->aExpediente = null;
		}

	} 
	
	public function setFechaPase($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [fecha_pase] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->fecha_pase !== $ts) {
			$this->fecha_pase = $ts;
			$this->modifiedColumns[] = ExpedientePasefacultadPeer::FECHA_PASE;
		}

	} 
	
	public function setFechaRetorno($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [fecha_retorno] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->fecha_retorno !== $ts) {
			$this->fecha_retorno = $ts;
			$this->modifiedColumns[] = ExpedientePasefacultadPeer::FECHA_RETORNO;
		}

	} 
	
	public function setObservaciones($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->observaciones !== $v) {
			$this->observaciones = $v;
			$this->modifiedColumns[] = ExpedientePasefacultadPeer::OBSERVACIONES;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->expediente_id = $rs->getInt($startcol + 1);

			$this->fecha_pase = $rs->getDate($startcol + 2, null);

			$this->fecha_retorno = $rs->getDate($startcol + 3, null);

			$this->observaciones = $rs->getString($startcol + 4);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 5; 
		} catch (Exception $e) {
			throw new PropelException("Error populating ExpedientePasefacultad object", $e);
		}
	}

	
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BaseExpedientePasefacultad:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ExpedientePasefacultadPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			ExpedientePasefacultadPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseExpedientePasefacultad:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BaseExpedientePasefacultad:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ExpedientePasefacultadPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseExpedientePasefacultad:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->aExpediente !== null) {
				if ($this->aExpediente->isModified()) {
					$affectedRows += $this->aExpediente->save($con);
				}
				$this->setExpediente($this->aExpediente);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = ExpedientePasefacultadPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += ExpedientePasefacultadPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aExpediente !== null) {
				if (!$this->aExpediente->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aExpediente->getValidationFailures());
				}
			}


			if (($retval = ExpedientePasefacultadPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ExpedientePasefacultadPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getExpedienteId();
				break;
			case 2:
				return $this->getFechaPase();
				break;
			case 3:
				return $this->getFechaRetorno();
				break;
			case 4:
				return $this->getObservaciones();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ExpedientePasefacultadPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getExpedienteId(),
			$keys[2] => $this->getFechaPase(),
			$keys[3] => $this->getFechaRetorno(),
			$keys[4] => $this->getObservaciones(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ExpedientePasefacultadPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setExpedienteId($value);
				break;
			case 2:
				$this->setFechaPase($value);
				break;
			case 3:
				$this->setFechaRetorno($value);
				break;
			case 4:
				$this->setObservaciones($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ExpedientePasefacultadPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setExpedienteId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setFechaPase($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setFechaRetorno($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setObservaciones($arr[$keys[4]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(ExpedientePasefacultadPeer::DATABASE_NAME);

		if ($this->isColumnModified(ExpedientePasefacultadPeer::ID)) $criteria->add(ExpedientePasefacultadPeer::ID, $this->id);
		if ($this->isColumnModified(ExpedientePasefacultadPeer::EXPEDIENTE_ID)) $criteria->add(ExpedientePasefacultadPeer::EXPEDIENTE_ID, $this->expediente_id);
		if ($this->isColumnModified(ExpedientePasefacultadPeer::FECHA_PASE)) $criteria->add(ExpedientePasefacultadPeer::FECHA_PASE, $this->fecha_pase);
		if ($this->isColumnModified(ExpedientePasefacultadPeer::FECHA_RETORNO)) $criteria->add(ExpedientePasefacultadPeer::FECHA_RETORNO, $this->fecha_retorno);
		if ($this->isColumnModified(ExpedientePasefacultadPeer::OBSERVACIONES)) $criteria->add(ExpedientePasefacultadPeer::OBSERVACIONES, $this->observaciones);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(ExpedientePasefacultadPeer::DATABASE_NAME);

		$criteria->add(ExpedientePasefacultadPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setExpedienteId($this->expediente_id);

		$copyObj->setFechaPase($this->fecha_pase);

		$copyObj->setFechaRetorno($this->fecha_retorno);

		$copyObj->setObservaciones($this->observaciones);


		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new ExpedientePasefacultadPeer();
		}
		return self::$peer;
	}

	
	public function setExpediente($v)
	{


		if ($v === null) {
			$this->setExpedienteId(NULL);
		} else {
			$this->setExpedienteId($v->getId());
		}


		$this->aExpediente = $v;
	}


	
	public function getExpediente($con = null)
	{
		if ($this->aExpediente === null && ($this->expediente_id !== null)) {
						include_once 'lib/model/om/BaseExpedientePeer.php';

			$this->aExpediente = ExpedientePeer::retrieveByPK($this->expediente_id, $con);

			
		}
		return $this->aExpediente;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseExpedientePasefacultad:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseExpedientePasefacultad::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} 