<?php


abstract class BaseFacultad extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $nombre;


	
	protected $establecimiento_id;


	
	protected $activa = true;


	
	protected $nombre_largo;

	
	protected $collConsejeros;

	
	protected $lastConsejeroCriteria = null;

	
	protected $collExpedientes;

	
	protected $lastExpedienteCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getNombre()
	{

		return $this->nombre;
	}

	
	public function getEstablecimientoId()
	{

		return $this->establecimiento_id;
	}

	
	public function getActiva()
	{

		return $this->activa;
	}

	
	public function getNombreLargo()
	{

		return $this->nombre_largo;
	}

	
	public function setId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = FacultadPeer::ID;
		}

	} 
	
	public function setNombre($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->nombre !== $v) {
			$this->nombre = $v;
			$this->modifiedColumns[] = FacultadPeer::NOMBRE;
		}

	} 
	
	public function setEstablecimientoId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->establecimiento_id !== $v) {
			$this->establecimiento_id = $v;
			$this->modifiedColumns[] = FacultadPeer::ESTABLECIMIENTO_ID;
		}

	} 
	
	public function setActiva($v)
	{

		if ($this->activa !== $v || $v === true) {
			$this->activa = $v;
			$this->modifiedColumns[] = FacultadPeer::ACTIVA;
		}

	} 
	
	public function setNombreLargo($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->nombre_largo !== $v) {
			$this->nombre_largo = $v;
			$this->modifiedColumns[] = FacultadPeer::NOMBRE_LARGO;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->nombre = $rs->getString($startcol + 1);

			$this->establecimiento_id = $rs->getInt($startcol + 2);

			$this->activa = $rs->getBoolean($startcol + 3);

			$this->nombre_largo = $rs->getString($startcol + 4);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 5; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Facultad object", $e);
		}
	}

	
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BaseFacultad:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(FacultadPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			FacultadPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseFacultad:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BaseFacultad:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(FacultadPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseFacultad:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = FacultadPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += FacultadPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collConsejeros !== null) {
				foreach($this->collConsejeros as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collExpedientes !== null) {
				foreach($this->collExpedientes as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = FacultadPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collConsejeros !== null) {
					foreach($this->collConsejeros as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collExpedientes !== null) {
					foreach($this->collExpedientes as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = FacultadPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getNombre();
				break;
			case 2:
				return $this->getEstablecimientoId();
				break;
			case 3:
				return $this->getActiva();
				break;
			case 4:
				return $this->getNombreLargo();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = FacultadPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getNombre(),
			$keys[2] => $this->getEstablecimientoId(),
			$keys[3] => $this->getActiva(),
			$keys[4] => $this->getNombreLargo(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = FacultadPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setNombre($value);
				break;
			case 2:
				$this->setEstablecimientoId($value);
				break;
			case 3:
				$this->setActiva($value);
				break;
			case 4:
				$this->setNombreLargo($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = FacultadPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setNombre($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setEstablecimientoId($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setActiva($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setNombreLargo($arr[$keys[4]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(FacultadPeer::DATABASE_NAME);

		if ($this->isColumnModified(FacultadPeer::ID)) $criteria->add(FacultadPeer::ID, $this->id);
		if ($this->isColumnModified(FacultadPeer::NOMBRE)) $criteria->add(FacultadPeer::NOMBRE, $this->nombre);
		if ($this->isColumnModified(FacultadPeer::ESTABLECIMIENTO_ID)) $criteria->add(FacultadPeer::ESTABLECIMIENTO_ID, $this->establecimiento_id);
		if ($this->isColumnModified(FacultadPeer::ACTIVA)) $criteria->add(FacultadPeer::ACTIVA, $this->activa);
		if ($this->isColumnModified(FacultadPeer::NOMBRE_LARGO)) $criteria->add(FacultadPeer::NOMBRE_LARGO, $this->nombre_largo);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(FacultadPeer::DATABASE_NAME);

		$criteria->add(FacultadPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setNombre($this->nombre);

		$copyObj->setEstablecimientoId($this->establecimiento_id);

		$copyObj->setActiva($this->activa);

		$copyObj->setNombreLargo($this->nombre_largo);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getConsejeros() as $relObj) {
				$copyObj->addConsejero($relObj->copy($deepCopy));
			}

			foreach($this->getExpedientes() as $relObj) {
				$copyObj->addExpediente($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new FacultadPeer();
		}
		return self::$peer;
	}

	
	public function initConsejeros()
	{
		if ($this->collConsejeros === null) {
			$this->collConsejeros = array();
		}
	}

	
	public function getConsejeros($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConsejeroPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConsejeros === null) {
			if ($this->isNew()) {
			   $this->collConsejeros = array();
			} else {

				$criteria->add(ConsejeroPeer::FACULTAD_ID, $this->getId());

				ConsejeroPeer::addSelectColumns($criteria);
				$this->collConsejeros = ConsejeroPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(ConsejeroPeer::FACULTAD_ID, $this->getId());

				ConsejeroPeer::addSelectColumns($criteria);
				if (!isset($this->lastConsejeroCriteria) || !$this->lastConsejeroCriteria->equals($criteria)) {
					$this->collConsejeros = ConsejeroPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastConsejeroCriteria = $criteria;
		return $this->collConsejeros;
	}

	
	public function countConsejeros($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseConsejeroPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(ConsejeroPeer::FACULTAD_ID, $this->getId());

		return ConsejeroPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addConsejero(Consejero $l)
	{
		$this->collConsejeros[] = $l;
		$l->setFacultad($this);
	}


	
	public function getConsejerosJoinConEstadoCivil($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConsejeroPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConsejeros === null) {
			if ($this->isNew()) {
				$this->collConsejeros = array();
			} else {

				$criteria->add(ConsejeroPeer::FACULTAD_ID, $this->getId());

				$this->collConsejeros = ConsejeroPeer::doSelectJoinConEstadoCivil($criteria, $con);
			}
		} else {
									
			$criteria->add(ConsejeroPeer::FACULTAD_ID, $this->getId());

			if (!isset($this->lastConsejeroCriteria) || !$this->lastConsejeroCriteria->equals($criteria)) {
				$this->collConsejeros = ConsejeroPeer::doSelectJoinConEstadoCivil($criteria, $con);
			}
		}
		$this->lastConsejeroCriteria = $criteria;

		return $this->collConsejeros;
	}


	
	public function getConsejerosJoinLocalidad($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConsejeroPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConsejeros === null) {
			if ($this->isNew()) {
				$this->collConsejeros = array();
			} else {

				$criteria->add(ConsejeroPeer::FACULTAD_ID, $this->getId());

				$this->collConsejeros = ConsejeroPeer::doSelectJoinLocalidad($criteria, $con);
			}
		} else {
									
			$criteria->add(ConsejeroPeer::FACULTAD_ID, $this->getId());

			if (!isset($this->lastConsejeroCriteria) || !$this->lastConsejeroCriteria->equals($criteria)) {
				$this->collConsejeros = ConsejeroPeer::doSelectJoinLocalidad($criteria, $con);
			}
		}
		$this->lastConsejeroCriteria = $criteria;

		return $this->collConsejeros;
	}


	
	public function getConsejerosJoinProvincia($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConsejeroPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConsejeros === null) {
			if ($this->isNew()) {
				$this->collConsejeros = array();
			} else {

				$criteria->add(ConsejeroPeer::FACULTAD_ID, $this->getId());

				$this->collConsejeros = ConsejeroPeer::doSelectJoinProvincia($criteria, $con);
			}
		} else {
									
			$criteria->add(ConsejeroPeer::FACULTAD_ID, $this->getId());

			if (!isset($this->lastConsejeroCriteria) || !$this->lastConsejeroCriteria->equals($criteria)) {
				$this->collConsejeros = ConsejeroPeer::doSelectJoinProvincia($criteria, $con);
			}
		}
		$this->lastConsejeroCriteria = $criteria;

		return $this->collConsejeros;
	}

	
	public function initExpedientes()
	{
		if ($this->collExpedientes === null) {
			$this->collExpedientes = array();
		}
	}

	
	public function getExpedientes($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseExpedientePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collExpedientes === null) {
			if ($this->isNew()) {
			   $this->collExpedientes = array();
			} else {

				$criteria->add(ExpedientePeer::CON_FACULTADES_ID, $this->getId());

				ExpedientePeer::addSelectColumns($criteria);
				$this->collExpedientes = ExpedientePeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(ExpedientePeer::CON_FACULTADES_ID, $this->getId());

				ExpedientePeer::addSelectColumns($criteria);
				if (!isset($this->lastExpedienteCriteria) || !$this->lastExpedienteCriteria->equals($criteria)) {
					$this->collExpedientes = ExpedientePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastExpedienteCriteria = $criteria;
		return $this->collExpedientes;
	}

	
	public function countExpedientes($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseExpedientePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(ExpedientePeer::CON_FACULTADES_ID, $this->getId());

		return ExpedientePeer::doCount($criteria, $distinct, $con);
	}

	
	public function addExpediente(Expediente $l)
	{
		$this->collExpedientes[] = $l;
		$l->setFacultad($this);
	}


	
	public function getExpedientesJoinCarrera($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseExpedientePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collExpedientes === null) {
			if ($this->isNew()) {
				$this->collExpedientes = array();
			} else {

				$criteria->add(ExpedientePeer::CON_FACULTADES_ID, $this->getId());

				$this->collExpedientes = ExpedientePeer::doSelectJoinCarrera($criteria, $con);
			}
		} else {
									
			$criteria->add(ExpedientePeer::CON_FACULTADES_ID, $this->getId());

			if (!isset($this->lastExpedienteCriteria) || !$this->lastExpedienteCriteria->equals($criteria)) {
				$this->collExpedientes = ExpedientePeer::doSelectJoinCarrera($criteria, $con);
			}
		}
		$this->lastExpedienteCriteria = $criteria;

		return $this->collExpedientes;
	}


	
	public function getExpedientesJoinAlumno($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseExpedientePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collExpedientes === null) {
			if ($this->isNew()) {
				$this->collExpedientes = array();
			} else {

				$criteria->add(ExpedientePeer::CON_FACULTADES_ID, $this->getId());

				$this->collExpedientes = ExpedientePeer::doSelectJoinAlumno($criteria, $con);
			}
		} else {
									
			$criteria->add(ExpedientePeer::CON_FACULTADES_ID, $this->getId());

			if (!isset($this->lastExpedienteCriteria) || !$this->lastExpedienteCriteria->equals($criteria)) {
				$this->collExpedientes = ExpedientePeer::doSelectJoinAlumno($criteria, $con);
			}
		}
		$this->lastExpedienteCriteria = $criteria;

		return $this->collExpedientes;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseFacultad:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseFacultad::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} 