<?php


abstract class BaseFamiliar extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $dni;


	
	protected $personal_id;


	
	protected $apellido;


	
	protected $nombre;


	
	protected $sexo_id;


	
	protected $fecha_nac;


	
	protected $parentesco_id;


	
	protected $observaciones;

	
	protected $aPersonal;

	
	protected $aSexo;

	
	protected $aParentesco;

	
	protected $collPersonalLicenciass;

	
	protected $lastPersonalLicenciasCriteria = null;

	
	protected $collPersonalFamiliars;

	
	protected $lastPersonalFamiliarCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getDni()
	{

		return $this->dni;
	}

	
	public function getPersonalId()
	{

		return $this->personal_id;
	}

	
	public function getApellido()
	{

		return $this->apellido;
	}

	
	public function getNombre()
	{

		return $this->nombre;
	}

	
	public function getSexoId()
	{

		return $this->sexo_id;
	}

	
	public function getFechaNac($format = '%d/%m/%Y')
	{

		if ($this->fecha_nac === null || $this->fecha_nac === '') {
			return null;
		} elseif (!is_int($this->fecha_nac)) {
						$ts = strtotime($this->fecha_nac);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [fecha_nac] as date/time value: " . var_export($this->fecha_nac, true));
			}
		} else {
			$ts = $this->fecha_nac;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getParentescoId()
	{

		return $this->parentesco_id;
	}

	
	public function getObservaciones()
	{

		return $this->observaciones;
	}

	
	public function setId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = FamiliarPeer::ID;
		}

	} 
	
	public function setDni($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->dni !== $v) {
			$this->dni = $v;
			$this->modifiedColumns[] = FamiliarPeer::DNI;
		}

	} 
	
	public function setPersonalId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->personal_id !== $v) {
			$this->personal_id = $v;
			$this->modifiedColumns[] = FamiliarPeer::PERSONAL_ID;
		}

		if ($this->aPersonal !== null && $this->aPersonal->getId() !== $v) {
			$this->aPersonal = null;
		}

	} 
	
	public function setApellido($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->apellido !== $v) {
			$this->apellido = $v;
			$this->modifiedColumns[] = FamiliarPeer::APELLIDO;
		}

	} 
	
	public function setNombre($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->nombre !== $v) {
			$this->nombre = $v;
			$this->modifiedColumns[] = FamiliarPeer::NOMBRE;
		}

	} 
	
	public function setSexoId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->sexo_id !== $v) {
			$this->sexo_id = $v;
			$this->modifiedColumns[] = FamiliarPeer::SEXO_ID;
		}

		if ($this->aSexo !== null && $this->aSexo->getId() !== $v) {
			$this->aSexo = null;
		}

	} 
	
	public function setFechaNac($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [fecha_nac] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->fecha_nac !== $ts) {
			$this->fecha_nac = $ts;
			$this->modifiedColumns[] = FamiliarPeer::FECHA_NAC;
		}

	} 
	
	public function setParentescoId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->parentesco_id !== $v) {
			$this->parentesco_id = $v;
			$this->modifiedColumns[] = FamiliarPeer::PARENTESCO_ID;
		}

		if ($this->aParentesco !== null && $this->aParentesco->getId() !== $v) {
			$this->aParentesco = null;
		}

	} 
	
	public function setObservaciones($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->observaciones !== $v) {
			$this->observaciones = $v;
			$this->modifiedColumns[] = FamiliarPeer::OBSERVACIONES;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->dni = $rs->getInt($startcol + 1);

			$this->personal_id = $rs->getInt($startcol + 2);

			$this->apellido = $rs->getString($startcol + 3);

			$this->nombre = $rs->getString($startcol + 4);

			$this->sexo_id = $rs->getInt($startcol + 5);

			$this->fecha_nac = $rs->getDate($startcol + 6, null);

			$this->parentesco_id = $rs->getInt($startcol + 7);

			$this->observaciones = $rs->getString($startcol + 8);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 9; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Familiar object", $e);
		}
	}

	
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BaseFamiliar:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(FamiliarPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			FamiliarPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseFamiliar:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BaseFamiliar:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(FamiliarPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseFamiliar:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->aPersonal !== null) {
				if ($this->aPersonal->isModified()) {
					$affectedRows += $this->aPersonal->save($con);
				}
				$this->setPersonal($this->aPersonal);
			}

			if ($this->aSexo !== null) {
				if ($this->aSexo->isModified()) {
					$affectedRows += $this->aSexo->save($con);
				}
				$this->setSexo($this->aSexo);
			}

			if ($this->aParentesco !== null) {
				if ($this->aParentesco->isModified()) {
					$affectedRows += $this->aParentesco->save($con);
				}
				$this->setParentesco($this->aParentesco);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = FamiliarPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += FamiliarPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collPersonalLicenciass !== null) {
				foreach($this->collPersonalLicenciass as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collPersonalFamiliars !== null) {
				foreach($this->collPersonalFamiliars as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aPersonal !== null) {
				if (!$this->aPersonal->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aPersonal->getValidationFailures());
				}
			}

			if ($this->aSexo !== null) {
				if (!$this->aSexo->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aSexo->getValidationFailures());
				}
			}

			if ($this->aParentesco !== null) {
				if (!$this->aParentesco->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aParentesco->getValidationFailures());
				}
			}


			if (($retval = FamiliarPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collPersonalLicenciass !== null) {
					foreach($this->collPersonalLicenciass as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collPersonalFamiliars !== null) {
					foreach($this->collPersonalFamiliars as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = FamiliarPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getDni();
				break;
			case 2:
				return $this->getPersonalId();
				break;
			case 3:
				return $this->getApellido();
				break;
			case 4:
				return $this->getNombre();
				break;
			case 5:
				return $this->getSexoId();
				break;
			case 6:
				return $this->getFechaNac();
				break;
			case 7:
				return $this->getParentescoId();
				break;
			case 8:
				return $this->getObservaciones();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = FamiliarPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getDni(),
			$keys[2] => $this->getPersonalId(),
			$keys[3] => $this->getApellido(),
			$keys[4] => $this->getNombre(),
			$keys[5] => $this->getSexoId(),
			$keys[6] => $this->getFechaNac(),
			$keys[7] => $this->getParentescoId(),
			$keys[8] => $this->getObservaciones(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = FamiliarPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setDni($value);
				break;
			case 2:
				$this->setPersonalId($value);
				break;
			case 3:
				$this->setApellido($value);
				break;
			case 4:
				$this->setNombre($value);
				break;
			case 5:
				$this->setSexoId($value);
				break;
			case 6:
				$this->setFechaNac($value);
				break;
			case 7:
				$this->setParentescoId($value);
				break;
			case 8:
				$this->setObservaciones($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = FamiliarPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setDni($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setPersonalId($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setApellido($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setNombre($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setSexoId($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setFechaNac($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setParentescoId($arr[$keys[7]]);
		if (array_key_exists($keys[8], $arr)) $this->setObservaciones($arr[$keys[8]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(FamiliarPeer::DATABASE_NAME);

		if ($this->isColumnModified(FamiliarPeer::ID)) $criteria->add(FamiliarPeer::ID, $this->id);
		if ($this->isColumnModified(FamiliarPeer::DNI)) $criteria->add(FamiliarPeer::DNI, $this->dni);
		if ($this->isColumnModified(FamiliarPeer::PERSONAL_ID)) $criteria->add(FamiliarPeer::PERSONAL_ID, $this->personal_id);
		if ($this->isColumnModified(FamiliarPeer::APELLIDO)) $criteria->add(FamiliarPeer::APELLIDO, $this->apellido);
		if ($this->isColumnModified(FamiliarPeer::NOMBRE)) $criteria->add(FamiliarPeer::NOMBRE, $this->nombre);
		if ($this->isColumnModified(FamiliarPeer::SEXO_ID)) $criteria->add(FamiliarPeer::SEXO_ID, $this->sexo_id);
		if ($this->isColumnModified(FamiliarPeer::FECHA_NAC)) $criteria->add(FamiliarPeer::FECHA_NAC, $this->fecha_nac);
		if ($this->isColumnModified(FamiliarPeer::PARENTESCO_ID)) $criteria->add(FamiliarPeer::PARENTESCO_ID, $this->parentesco_id);
		if ($this->isColumnModified(FamiliarPeer::OBSERVACIONES)) $criteria->add(FamiliarPeer::OBSERVACIONES, $this->observaciones);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(FamiliarPeer::DATABASE_NAME);

		$criteria->add(FamiliarPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setDni($this->dni);

		$copyObj->setPersonalId($this->personal_id);

		$copyObj->setApellido($this->apellido);

		$copyObj->setNombre($this->nombre);

		$copyObj->setSexoId($this->sexo_id);

		$copyObj->setFechaNac($this->fecha_nac);

		$copyObj->setParentescoId($this->parentesco_id);

		$copyObj->setObservaciones($this->observaciones);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getPersonalLicenciass() as $relObj) {
				$copyObj->addPersonalLicencias($relObj->copy($deepCopy));
			}

			foreach($this->getPersonalFamiliars() as $relObj) {
				$copyObj->addPersonalFamiliar($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new FamiliarPeer();
		}
		return self::$peer;
	}

	
	public function setPersonal($v)
	{


		if ($v === null) {
			$this->setPersonalId(NULL);
		} else {
			$this->setPersonalId($v->getId());
		}


		$this->aPersonal = $v;
	}


	
	public function getPersonal($con = null)
	{
		if ($this->aPersonal === null && ($this->personal_id !== null)) {
						include_once 'lib/model/om/BasePersonalPeer.php';

			$this->aPersonal = PersonalPeer::retrieveByPK($this->personal_id, $con);

			
		}
		return $this->aPersonal;
	}

	
	public function setSexo($v)
	{


		if ($v === null) {
			$this->setSexoId(NULL);
		} else {
			$this->setSexoId($v->getId());
		}


		$this->aSexo = $v;
	}


	
	public function getSexo($con = null)
	{
		if ($this->aSexo === null && ($this->sexo_id !== null)) {
						include_once 'lib/model/om/BaseSexoPeer.php';

			$this->aSexo = SexoPeer::retrieveByPK($this->sexo_id, $con);

			
		}
		return $this->aSexo;
	}

	
	public function setParentesco($v)
	{


		if ($v === null) {
			$this->setParentescoId(NULL);
		} else {
			$this->setParentescoId($v->getId());
		}


		$this->aParentesco = $v;
	}


	
	public function getParentesco($con = null)
	{
		if ($this->aParentesco === null && ($this->parentesco_id !== null)) {
						include_once 'lib/model/om/BaseParentescoPeer.php';

			$this->aParentesco = ParentescoPeer::retrieveByPK($this->parentesco_id, $con);

			
		}
		return $this->aParentesco;
	}

	
	public function initPersonalLicenciass()
	{
		if ($this->collPersonalLicenciass === null) {
			$this->collPersonalLicenciass = array();
		}
	}

	
	public function getPersonalLicenciass($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BasePersonalLicenciasPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collPersonalLicenciass === null) {
			if ($this->isNew()) {
			   $this->collPersonalLicenciass = array();
			} else {

				$criteria->add(PersonalLicenciasPeer::FAMILIAR_ID, $this->getId());

				PersonalLicenciasPeer::addSelectColumns($criteria);
				$this->collPersonalLicenciass = PersonalLicenciasPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(PersonalLicenciasPeer::FAMILIAR_ID, $this->getId());

				PersonalLicenciasPeer::addSelectColumns($criteria);
				if (!isset($this->lastPersonalLicenciasCriteria) || !$this->lastPersonalLicenciasCriteria->equals($criteria)) {
					$this->collPersonalLicenciass = PersonalLicenciasPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastPersonalLicenciasCriteria = $criteria;
		return $this->collPersonalLicenciass;
	}

	
	public function countPersonalLicenciass($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BasePersonalLicenciasPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(PersonalLicenciasPeer::FAMILIAR_ID, $this->getId());

		return PersonalLicenciasPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addPersonalLicencias(PersonalLicencias $l)
	{
		$this->collPersonalLicenciass[] = $l;
		$l->setFamiliar($this);
	}


	
	public function getPersonalLicenciassJoinPersonal($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BasePersonalLicenciasPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collPersonalLicenciass === null) {
			if ($this->isNew()) {
				$this->collPersonalLicenciass = array();
			} else {

				$criteria->add(PersonalLicenciasPeer::FAMILIAR_ID, $this->getId());

				$this->collPersonalLicenciass = PersonalLicenciasPeer::doSelectJoinPersonal($criteria, $con);
			}
		} else {
									
			$criteria->add(PersonalLicenciasPeer::FAMILIAR_ID, $this->getId());

			if (!isset($this->lastPersonalLicenciasCriteria) || !$this->lastPersonalLicenciasCriteria->equals($criteria)) {
				$this->collPersonalLicenciass = PersonalLicenciasPeer::doSelectJoinPersonal($criteria, $con);
			}
		}
		$this->lastPersonalLicenciasCriteria = $criteria;

		return $this->collPersonalLicenciass;
	}


	
	public function getPersonalLicenciassJoinLicenciaTipo($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BasePersonalLicenciasPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collPersonalLicenciass === null) {
			if ($this->isNew()) {
				$this->collPersonalLicenciass = array();
			} else {

				$criteria->add(PersonalLicenciasPeer::FAMILIAR_ID, $this->getId());

				$this->collPersonalLicenciass = PersonalLicenciasPeer::doSelectJoinLicenciaTipo($criteria, $con);
			}
		} else {
									
			$criteria->add(PersonalLicenciasPeer::FAMILIAR_ID, $this->getId());

			if (!isset($this->lastPersonalLicenciasCriteria) || !$this->lastPersonalLicenciasCriteria->equals($criteria)) {
				$this->collPersonalLicenciass = PersonalLicenciasPeer::doSelectJoinLicenciaTipo($criteria, $con);
			}
		}
		$this->lastPersonalLicenciasCriteria = $criteria;

		return $this->collPersonalLicenciass;
	}

	
	public function initPersonalFamiliars()
	{
		if ($this->collPersonalFamiliars === null) {
			$this->collPersonalFamiliars = array();
		}
	}

	
	public function getPersonalFamiliars($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BasePersonalFamiliarPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collPersonalFamiliars === null) {
			if ($this->isNew()) {
			   $this->collPersonalFamiliars = array();
			} else {

				$criteria->add(PersonalFamiliarPeer::FAMILIAR_ID, $this->getId());

				PersonalFamiliarPeer::addSelectColumns($criteria);
				$this->collPersonalFamiliars = PersonalFamiliarPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(PersonalFamiliarPeer::FAMILIAR_ID, $this->getId());

				PersonalFamiliarPeer::addSelectColumns($criteria);
				if (!isset($this->lastPersonalFamiliarCriteria) || !$this->lastPersonalFamiliarCriteria->equals($criteria)) {
					$this->collPersonalFamiliars = PersonalFamiliarPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastPersonalFamiliarCriteria = $criteria;
		return $this->collPersonalFamiliars;
	}

	
	public function countPersonalFamiliars($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BasePersonalFamiliarPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(PersonalFamiliarPeer::FAMILIAR_ID, $this->getId());

		return PersonalFamiliarPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addPersonalFamiliar(PersonalFamiliar $l)
	{
		$this->collPersonalFamiliars[] = $l;
		$l->setFamiliar($this);
	}


	
	public function getPersonalFamiliarsJoinPersonal($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BasePersonalFamiliarPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collPersonalFamiliars === null) {
			if ($this->isNew()) {
				$this->collPersonalFamiliars = array();
			} else {

				$criteria->add(PersonalFamiliarPeer::FAMILIAR_ID, $this->getId());

				$this->collPersonalFamiliars = PersonalFamiliarPeer::doSelectJoinPersonal($criteria, $con);
			}
		} else {
									
			$criteria->add(PersonalFamiliarPeer::FAMILIAR_ID, $this->getId());

			if (!isset($this->lastPersonalFamiliarCriteria) || !$this->lastPersonalFamiliarCriteria->equals($criteria)) {
				$this->collPersonalFamiliars = PersonalFamiliarPeer::doSelectJoinPersonal($criteria, $con);
			}
		}
		$this->lastPersonalFamiliarCriteria = $criteria;

		return $this->collPersonalFamiliars;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseFamiliar:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseFamiliar::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} 