<?php


abstract class BaseFamiliarPeer {

	
	const DATABASE_NAME = 'propel';

	
	const TABLE_NAME = 'familiar';

	
	const CLASS_DEFAULT = 'lib.model.Familiar';

	
	const NUM_COLUMNS = 9;

	
	const NUM_LAZY_LOAD_COLUMNS = 0;


	
	const ID = 'familiar.ID';

	
	const DNI = 'familiar.DNI';

	
	const PERSONAL_ID = 'familiar.PERSONAL_ID';

	
	const APELLIDO = 'familiar.APELLIDO';

	
	const NOMBRE = 'familiar.NOMBRE';

	
	const SEXO_ID = 'familiar.SEXO_ID';

	
	const FECHA_NAC = 'familiar.FECHA_NAC';

	
	const PARENTESCO_ID = 'familiar.PARENTESCO_ID';

	
	const OBSERVACIONES = 'familiar.OBSERVACIONES';

	
	private static $phpNameMap = null;


	
	private static $fieldNames = array (
		BasePeer::TYPE_PHPNAME => array ('Id', 'Dni', 'PersonalId', 'Apellido', 'Nombre', 'SexoId', 'FechaNac', 'ParentescoId', 'Observaciones', ),
		BasePeer::TYPE_COLNAME => array (FamiliarPeer::ID, FamiliarPeer::DNI, FamiliarPeer::PERSONAL_ID, FamiliarPeer::APELLIDO, FamiliarPeer::NOMBRE, FamiliarPeer::SEXO_ID, FamiliarPeer::FECHA_NAC, FamiliarPeer::PARENTESCO_ID, FamiliarPeer::OBSERVACIONES, ),
		BasePeer::TYPE_FIELDNAME => array ('id', 'DNI', 'personal_id', 'apellido', 'nombre', 'sexo_id', 'fecha_nac', 'parentesco_id', 'observaciones', ),
		BasePeer::TYPE_NUM => array (0, 1, 2, 3, 4, 5, 6, 7, 8, )
	);

	
	private static $fieldKeys = array (
		BasePeer::TYPE_PHPNAME => array ('Id' => 0, 'Dni' => 1, 'PersonalId' => 2, 'Apellido' => 3, 'Nombre' => 4, 'SexoId' => 5, 'FechaNac' => 6, 'ParentescoId' => 7, 'Observaciones' => 8, ),
		BasePeer::TYPE_COLNAME => array (FamiliarPeer::ID => 0, FamiliarPeer::DNI => 1, FamiliarPeer::PERSONAL_ID => 2, FamiliarPeer::APELLIDO => 3, FamiliarPeer::NOMBRE => 4, FamiliarPeer::SEXO_ID => 5, FamiliarPeer::FECHA_NAC => 6, FamiliarPeer::PARENTESCO_ID => 7, FamiliarPeer::OBSERVACIONES => 8, ),
		BasePeer::TYPE_FIELDNAME => array ('id' => 0, 'DNI' => 1, 'personal_id' => 2, 'apellido' => 3, 'nombre' => 4, 'sexo_id' => 5, 'fecha_nac' => 6, 'parentesco_id' => 7, 'observaciones' => 8, ),
		BasePeer::TYPE_NUM => array (0, 1, 2, 3, 4, 5, 6, 7, 8, )
	);

	
	public static function getMapBuilder()
	{
		include_once 'lib/model/map/FamiliarMapBuilder.php';
		return BasePeer::getMapBuilder('lib.model.map.FamiliarMapBuilder');
	}
	
	public static function getPhpNameMap()
	{
		if (self::$phpNameMap === null) {
			$map = FamiliarPeer::getTableMap();
			$columns = $map->getColumns();
			$nameMap = array();
			foreach ($columns as $column) {
				$nameMap[$column->getPhpName()] = $column->getColumnName();
			}
			self::$phpNameMap = $nameMap;
		}
		return self::$phpNameMap;
	}
	
	static public function translateFieldName($name, $fromType, $toType)
	{
		$toNames = self::getFieldNames($toType);
		$key = isset(self::$fieldKeys[$fromType][$name]) ? self::$fieldKeys[$fromType][$name] : null;
		if ($key === null) {
			throw new PropelException("'$name' could not be found in the field names of type '$fromType'. These are: " . print_r(self::$fieldKeys[$fromType], true));
		}
		return $toNames[$key];
	}

	

	static public function getFieldNames($type = BasePeer::TYPE_PHPNAME)
	{
		if (!array_key_exists($type, self::$fieldNames)) {
			throw new PropelException('Method getFieldNames() expects the parameter $type to be one of the class constants TYPE_PHPNAME, TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM. ' . $type . ' was given.');
		}
		return self::$fieldNames[$type];
	}

	
	public static function alias($alias, $column)
	{
		return str_replace(FamiliarPeer::TABLE_NAME.'.', $alias.'.', $column);
	}

	
	public static function addSelectColumns(Criteria $criteria)
	{

		$criteria->addSelectColumn(FamiliarPeer::ID);

		$criteria->addSelectColumn(FamiliarPeer::DNI);

		$criteria->addSelectColumn(FamiliarPeer::PERSONAL_ID);

		$criteria->addSelectColumn(FamiliarPeer::APELLIDO);

		$criteria->addSelectColumn(FamiliarPeer::NOMBRE);

		$criteria->addSelectColumn(FamiliarPeer::SEXO_ID);

		$criteria->addSelectColumn(FamiliarPeer::FECHA_NAC);

		$criteria->addSelectColumn(FamiliarPeer::PARENTESCO_ID);

		$criteria->addSelectColumn(FamiliarPeer::OBSERVACIONES);

	}

	const COUNT = 'COUNT(familiar.ID)';
	const COUNT_DISTINCT = 'COUNT(DISTINCT familiar.ID)';

	
	public static function doCount(Criteria $criteria, $distinct = false, $con = null)
	{
				$criteria = clone $criteria;

				$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(FamiliarPeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(FamiliarPeer::COUNT);
		}

				foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$rs = FamiliarPeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
						return 0;
		}
	}
	
	public static function doSelectOne(Criteria $criteria, $con = null)
	{
		$critcopy = clone $criteria;
		$critcopy->setLimit(1);
		$objects = FamiliarPeer::doSelect($critcopy, $con);
		if ($objects) {
			return $objects[0];
		}
		return null;
	}
	
	public static function doSelect(Criteria $criteria, $con = null)
	{
		return FamiliarPeer::populateObjects(FamiliarPeer::doSelectRS($criteria, $con));
	}
	
	public static function doSelectRS(Criteria $criteria, $con = null)
	{

    foreach (sfMixer::getCallables('BaseFamiliarPeer:addDoSelectRS:addDoSelectRS') as $callable)
    {
      call_user_func($callable, 'BaseFamiliarPeer', $criteria, $con);
    }


		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		if (!$criteria->getSelectColumns()) {
			$criteria = clone $criteria;
			FamiliarPeer::addSelectColumns($criteria);
		}

				$criteria->setDbName(self::DATABASE_NAME);

						return BasePeer::doSelect($criteria, $con);
	}
	
	public static function populateObjects(ResultSet $rs)
	{
		$results = array();
	
				$cls = FamiliarPeer::getOMClass();
		$cls = Propel::import($cls);
				while($rs->next()) {
		
			$obj = new $cls();
			$obj->hydrate($rs);
			$results[] = $obj;
			
		}
		return $results;
	}

	
	public static function doCountJoinPersonal(Criteria $criteria, $distinct = false, $con = null)
	{
				$criteria = clone $criteria;

				$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(FamiliarPeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(FamiliarPeer::COUNT);
		}

				foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$criteria->addJoin(FamiliarPeer::PERSONAL_ID, PersonalPeer::ID);

		$rs = FamiliarPeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
						return 0;
		}
	}


	
	public static function doCountJoinSexo(Criteria $criteria, $distinct = false, $con = null)
	{
				$criteria = clone $criteria;

				$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(FamiliarPeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(FamiliarPeer::COUNT);
		}

				foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$criteria->addJoin(FamiliarPeer::SEXO_ID, SexoPeer::ID);

		$rs = FamiliarPeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
						return 0;
		}
	}


	
	public static function doCountJoinParentesco(Criteria $criteria, $distinct = false, $con = null)
	{
				$criteria = clone $criteria;

				$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(FamiliarPeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(FamiliarPeer::COUNT);
		}

				foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$criteria->addJoin(FamiliarPeer::PARENTESCO_ID, ParentescoPeer::ID);

		$rs = FamiliarPeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
						return 0;
		}
	}


	
	public static function doSelectJoinPersonal(Criteria $c, $con = null)
	{
		$c = clone $c;

				if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		FamiliarPeer::addSelectColumns($c);
		$startcol = (FamiliarPeer::NUM_COLUMNS - FamiliarPeer::NUM_LAZY_LOAD_COLUMNS) + 1;
		PersonalPeer::addSelectColumns($c);

		$c->addJoin(FamiliarPeer::PERSONAL_ID, PersonalPeer::ID);
		$rs = BasePeer::doSelect($c, $con);
		$results = array();

		while($rs->next()) {

			$omClass = FamiliarPeer::getOMClass();

			$cls = Propel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);

			$omClass = PersonalPeer::getOMClass();

			$cls = Propel::import($omClass);
			$obj2 = new $cls();
			$obj2->hydrate($rs, $startcol);

			$newObject = true;
			foreach($results as $temp_obj1) {
				$temp_obj2 = $temp_obj1->getPersonal(); 				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
										$temp_obj2->addFamiliar($obj1); 					break;
				}
			}
			if ($newObject) {
				$obj2->initFamiliars();
				$obj2->addFamiliar($obj1); 			}
			$results[] = $obj1;
		}
		return $results;
	}


	
	public static function doSelectJoinSexo(Criteria $c, $con = null)
	{
		$c = clone $c;

				if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		FamiliarPeer::addSelectColumns($c);
		$startcol = (FamiliarPeer::NUM_COLUMNS - FamiliarPeer::NUM_LAZY_LOAD_COLUMNS) + 1;
		SexoPeer::addSelectColumns($c);

		$c->addJoin(FamiliarPeer::SEXO_ID, SexoPeer::ID);
		$rs = BasePeer::doSelect($c, $con);
		$results = array();

		while($rs->next()) {

			$omClass = FamiliarPeer::getOMClass();

			$cls = Propel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);

			$omClass = SexoPeer::getOMClass();

			$cls = Propel::import($omClass);
			$obj2 = new $cls();
			$obj2->hydrate($rs, $startcol);

			$newObject = true;
			foreach($results as $temp_obj1) {
				$temp_obj2 = $temp_obj1->getSexo(); 				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
										$temp_obj2->addFamiliar($obj1); 					break;
				}
			}
			if ($newObject) {
				$obj2->initFamiliars();
				$obj2->addFamiliar($obj1); 			}
			$results[] = $obj1;
		}
		return $results;
	}


	
	public static function doSelectJoinParentesco(Criteria $c, $con = null)
	{
		$c = clone $c;

				if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		FamiliarPeer::addSelectColumns($c);
		$startcol = (FamiliarPeer::NUM_COLUMNS - FamiliarPeer::NUM_LAZY_LOAD_COLUMNS) + 1;
		ParentescoPeer::addSelectColumns($c);

		$c->addJoin(FamiliarPeer::PARENTESCO_ID, ParentescoPeer::ID);
		$rs = BasePeer::doSelect($c, $con);
		$results = array();

		while($rs->next()) {

			$omClass = FamiliarPeer::getOMClass();

			$cls = Propel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);

			$omClass = ParentescoPeer::getOMClass();

			$cls = Propel::import($omClass);
			$obj2 = new $cls();
			$obj2->hydrate($rs, $startcol);

			$newObject = true;
			foreach($results as $temp_obj1) {
				$temp_obj2 = $temp_obj1->getParentesco(); 				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
										$temp_obj2->addFamiliar($obj1); 					break;
				}
			}
			if ($newObject) {
				$obj2->initFamiliars();
				$obj2->addFamiliar($obj1); 			}
			$results[] = $obj1;
		}
		return $results;
	}


	
	public static function doCountJoinAll(Criteria $criteria, $distinct = false, $con = null)
	{
		$criteria = clone $criteria;

				$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(FamiliarPeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(FamiliarPeer::COUNT);
		}

				foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$criteria->addJoin(FamiliarPeer::PERSONAL_ID, PersonalPeer::ID);

		$criteria->addJoin(FamiliarPeer::SEXO_ID, SexoPeer::ID);

		$criteria->addJoin(FamiliarPeer::PARENTESCO_ID, ParentescoPeer::ID);

		$rs = FamiliarPeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
						return 0;
		}
	}


	
	public static function doSelectJoinAll(Criteria $c, $con = null)
	{
		$c = clone $c;

				if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		FamiliarPeer::addSelectColumns($c);
		$startcol2 = (FamiliarPeer::NUM_COLUMNS - FamiliarPeer::NUM_LAZY_LOAD_COLUMNS) + 1;

		PersonalPeer::addSelectColumns($c);
		$startcol3 = $startcol2 + PersonalPeer::NUM_COLUMNS;

		SexoPeer::addSelectColumns($c);
		$startcol4 = $startcol3 + SexoPeer::NUM_COLUMNS;

		ParentescoPeer::addSelectColumns($c);
		$startcol5 = $startcol4 + ParentescoPeer::NUM_COLUMNS;

		$c->addJoin(FamiliarPeer::PERSONAL_ID, PersonalPeer::ID);

		$c->addJoin(FamiliarPeer::SEXO_ID, SexoPeer::ID);

		$c->addJoin(FamiliarPeer::PARENTESCO_ID, ParentescoPeer::ID);

		$rs = BasePeer::doSelect($c, $con);
		$results = array();

		while($rs->next()) {

			$omClass = FamiliarPeer::getOMClass();


			$cls = Propel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);


					
			$omClass = PersonalPeer::getOMClass();


			$cls = Propel::import($omClass);
			$obj2 = new $cls();
			$obj2->hydrate($rs, $startcol2);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj2 = $temp_obj1->getPersonal(); 				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
					$temp_obj2->addFamiliar($obj1); 					break;
				}
			}

			if ($newObject) {
				$obj2->initFamiliars();
				$obj2->addFamiliar($obj1);
			}


					
			$omClass = SexoPeer::getOMClass();


			$cls = Propel::import($omClass);
			$obj3 = new $cls();
			$obj3->hydrate($rs, $startcol3);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj3 = $temp_obj1->getSexo(); 				if ($temp_obj3->getPrimaryKey() === $obj3->getPrimaryKey()) {
					$newObject = false;
					$temp_obj3->addFamiliar($obj1); 					break;
				}
			}

			if ($newObject) {
				$obj3->initFamiliars();
				$obj3->addFamiliar($obj1);
			}


					
			$omClass = ParentescoPeer::getOMClass();


			$cls = Propel::import($omClass);
			$obj4 = new $cls();
			$obj4->hydrate($rs, $startcol4);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj4 = $temp_obj1->getParentesco(); 				if ($temp_obj4->getPrimaryKey() === $obj4->getPrimaryKey()) {
					$newObject = false;
					$temp_obj4->addFamiliar($obj1); 					break;
				}
			}

			if ($newObject) {
				$obj4->initFamiliars();
				$obj4->addFamiliar($obj1);
			}

			$results[] = $obj1;
		}
		return $results;
	}


	
	public static function doCountJoinAllExceptPersonal(Criteria $criteria, $distinct = false, $con = null)
	{
				$criteria = clone $criteria;

				$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(FamiliarPeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(FamiliarPeer::COUNT);
		}

				foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$criteria->addJoin(FamiliarPeer::SEXO_ID, SexoPeer::ID);

		$criteria->addJoin(FamiliarPeer::PARENTESCO_ID, ParentescoPeer::ID);

		$rs = FamiliarPeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
						return 0;
		}
	}


	
	public static function doCountJoinAllExceptSexo(Criteria $criteria, $distinct = false, $con = null)
	{
				$criteria = clone $criteria;

				$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(FamiliarPeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(FamiliarPeer::COUNT);
		}

				foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$criteria->addJoin(FamiliarPeer::PERSONAL_ID, PersonalPeer::ID);

		$criteria->addJoin(FamiliarPeer::PARENTESCO_ID, ParentescoPeer::ID);

		$rs = FamiliarPeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
						return 0;
		}
	}


	
	public static function doCountJoinAllExceptParentesco(Criteria $criteria, $distinct = false, $con = null)
	{
				$criteria = clone $criteria;

				$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(FamiliarPeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(FamiliarPeer::COUNT);
		}

				foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$criteria->addJoin(FamiliarPeer::PERSONAL_ID, PersonalPeer::ID);

		$criteria->addJoin(FamiliarPeer::SEXO_ID, SexoPeer::ID);

		$rs = FamiliarPeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
						return 0;
		}
	}


	
	public static function doSelectJoinAllExceptPersonal(Criteria $c, $con = null)
	{
		$c = clone $c;

								if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		FamiliarPeer::addSelectColumns($c);
		$startcol2 = (FamiliarPeer::NUM_COLUMNS - FamiliarPeer::NUM_LAZY_LOAD_COLUMNS) + 1;

		SexoPeer::addSelectColumns($c);
		$startcol3 = $startcol2 + SexoPeer::NUM_COLUMNS;

		ParentescoPeer::addSelectColumns($c);
		$startcol4 = $startcol3 + ParentescoPeer::NUM_COLUMNS;

		$c->addJoin(FamiliarPeer::SEXO_ID, SexoPeer::ID);

		$c->addJoin(FamiliarPeer::PARENTESCO_ID, ParentescoPeer::ID);


		$rs = BasePeer::doSelect($c, $con);
		$results = array();

		while($rs->next()) {

			$omClass = FamiliarPeer::getOMClass();

			$cls = Propel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);

			$omClass = SexoPeer::getOMClass();


			$cls = Propel::import($omClass);
			$obj2  = new $cls();
			$obj2->hydrate($rs, $startcol2);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj2 = $temp_obj1->getSexo(); 				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
					$temp_obj2->addFamiliar($obj1);
					break;
				}
			}

			if ($newObject) {
				$obj2->initFamiliars();
				$obj2->addFamiliar($obj1);
			}

			$omClass = ParentescoPeer::getOMClass();


			$cls = Propel::import($omClass);
			$obj3  = new $cls();
			$obj3->hydrate($rs, $startcol3);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj3 = $temp_obj1->getParentesco(); 				if ($temp_obj3->getPrimaryKey() === $obj3->getPrimaryKey()) {
					$newObject = false;
					$temp_obj3->addFamiliar($obj1);
					break;
				}
			}

			if ($newObject) {
				$obj3->initFamiliars();
				$obj3->addFamiliar($obj1);
			}

			$results[] = $obj1;
		}
		return $results;
	}


	
	public static function doSelectJoinAllExceptSexo(Criteria $c, $con = null)
	{
		$c = clone $c;

								if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		FamiliarPeer::addSelectColumns($c);
		$startcol2 = (FamiliarPeer::NUM_COLUMNS - FamiliarPeer::NUM_LAZY_LOAD_COLUMNS) + 1;

		PersonalPeer::addSelectColumns($c);
		$startcol3 = $startcol2 + PersonalPeer::NUM_COLUMNS;

		ParentescoPeer::addSelectColumns($c);
		$startcol4 = $startcol3 + ParentescoPeer::NUM_COLUMNS;

		$c->addJoin(FamiliarPeer::PERSONAL_ID, PersonalPeer::ID);

		$c->addJoin(FamiliarPeer::PARENTESCO_ID, ParentescoPeer::ID);


		$rs = BasePeer::doSelect($c, $con);
		$results = array();

		while($rs->next()) {

			$omClass = FamiliarPeer::getOMClass();

			$cls = Propel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);

			$omClass = PersonalPeer::getOMClass();


			$cls = Propel::import($omClass);
			$obj2  = new $cls();
			$obj2->hydrate($rs, $startcol2);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj2 = $temp_obj1->getPersonal(); 				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
					$temp_obj2->addFamiliar($obj1);
					break;
				}
			}

			if ($newObject) {
				$obj2->initFamiliars();
				$obj2->addFamiliar($obj1);
			}

			$omClass = ParentescoPeer::getOMClass();


			$cls = Propel::import($omClass);
			$obj3  = new $cls();
			$obj3->hydrate($rs, $startcol3);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj3 = $temp_obj1->getParentesco(); 				if ($temp_obj3->getPrimaryKey() === $obj3->getPrimaryKey()) {
					$newObject = false;
					$temp_obj3->addFamiliar($obj1);
					break;
				}
			}

			if ($newObject) {
				$obj3->initFamiliars();
				$obj3->addFamiliar($obj1);
			}

			$results[] = $obj1;
		}
		return $results;
	}


	
	public static function doSelectJoinAllExceptParentesco(Criteria $c, $con = null)
	{
		$c = clone $c;

								if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		FamiliarPeer::addSelectColumns($c);
		$startcol2 = (FamiliarPeer::NUM_COLUMNS - FamiliarPeer::NUM_LAZY_LOAD_COLUMNS) + 1;

		PersonalPeer::addSelectColumns($c);
		$startcol3 = $startcol2 + PersonalPeer::NUM_COLUMNS;

		SexoPeer::addSelectColumns($c);
		$startcol4 = $startcol3 + SexoPeer::NUM_COLUMNS;

		$c->addJoin(FamiliarPeer::PERSONAL_ID, PersonalPeer::ID);

		$c->addJoin(FamiliarPeer::SEXO_ID, SexoPeer::ID);


		$rs = BasePeer::doSelect($c, $con);
		$results = array();

		while($rs->next()) {

			$omClass = FamiliarPeer::getOMClass();

			$cls = Propel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);

			$omClass = PersonalPeer::getOMClass();


			$cls = Propel::import($omClass);
			$obj2  = new $cls();
			$obj2->hydrate($rs, $startcol2);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj2 = $temp_obj1->getPersonal(); 				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
					$temp_obj2->addFamiliar($obj1);
					break;
				}
			}

			if ($newObject) {
				$obj2->initFamiliars();
				$obj2->addFamiliar($obj1);
			}

			$omClass = SexoPeer::getOMClass();


			$cls = Propel::import($omClass);
			$obj3  = new $cls();
			$obj3->hydrate($rs, $startcol3);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj3 = $temp_obj1->getSexo(); 				if ($temp_obj3->getPrimaryKey() === $obj3->getPrimaryKey()) {
					$newObject = false;
					$temp_obj3->addFamiliar($obj1);
					break;
				}
			}

			if ($newObject) {
				$obj3->initFamiliars();
				$obj3->addFamiliar($obj1);
			}

			$results[] = $obj1;
		}
		return $results;
	}

	
	public static function getTableMap()
	{
		return Propel::getDatabaseMap(self::DATABASE_NAME)->getTable(self::TABLE_NAME);
	}

	
	public static function getOMClass()
	{
		return FamiliarPeer::CLASS_DEFAULT;
	}

	
	public static function doInsert($values, $con = null)
	{

    foreach (sfMixer::getCallables('BaseFamiliarPeer:doInsert:pre') as $callable)
    {
      $ret = call_user_func($callable, 'BaseFamiliarPeer', $values, $con);
      if (false !== $ret)
      {
        return $ret;
      }
    }


		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		if ($values instanceof Criteria) {
			$criteria = clone $values; 		} else {
			$criteria = $values->buildCriteria(); 		}

		$criteria->remove(FamiliarPeer::ID); 

				$criteria->setDbName(self::DATABASE_NAME);

		try {
									$con->begin();
			$pk = BasePeer::doInsert($criteria, $con);
			$con->commit();
		} catch(PropelException $e) {
			$con->rollback();
			throw $e;
		}

		
    foreach (sfMixer::getCallables('BaseFamiliarPeer:doInsert:post') as $callable)
    {
      call_user_func($callable, 'BaseFamiliarPeer', $values, $con, $pk);
    }

    return $pk;
	}

	
	public static function doUpdate($values, $con = null)
	{

    foreach (sfMixer::getCallables('BaseFamiliarPeer:doUpdate:pre') as $callable)
    {
      $ret = call_user_func($callable, 'BaseFamiliarPeer', $values, $con);
      if (false !== $ret)
      {
        return $ret;
      }
    }


		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		$selectCriteria = new Criteria(self::DATABASE_NAME);

		if ($values instanceof Criteria) {
			$criteria = clone $values; 
			$comparison = $criteria->getComparison(FamiliarPeer::ID);
			$selectCriteria->add(FamiliarPeer::ID, $criteria->remove(FamiliarPeer::ID), $comparison);

		} else { 			$criteria = $values->buildCriteria(); 			$selectCriteria = $values->buildPkeyCriteria(); 		}

				$criteria->setDbName(self::DATABASE_NAME);

		$ret = BasePeer::doUpdate($selectCriteria, $criteria, $con);
	

    foreach (sfMixer::getCallables('BaseFamiliarPeer:doUpdate:post') as $callable)
    {
      call_user_func($callable, 'BaseFamiliarPeer', $values, $con, $ret);
    }

    return $ret;
  }

	
	public static function doDeleteAll($con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}
		$affectedRows = 0; 		try {
									$con->begin();
			$affectedRows += BasePeer::doDeleteAll(FamiliarPeer::TABLE_NAME, $con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	 public static function doDelete($values, $con = null)
	 {
		if ($con === null) {
			$con = Propel::getConnection(FamiliarPeer::DATABASE_NAME);
		}

		if ($values instanceof Criteria) {
			$criteria = clone $values; 		} elseif ($values instanceof Familiar) {

			$criteria = $values->buildPkeyCriteria();
		} else {
						$criteria = new Criteria(self::DATABASE_NAME);
			$criteria->add(FamiliarPeer::ID, (array) $values, Criteria::IN);
		}

				$criteria->setDbName(self::DATABASE_NAME);

		$affectedRows = 0; 
		try {
									$con->begin();
			
			$affectedRows += BasePeer::doDelete($criteria, $con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	public static function doValidate(Familiar $obj, $cols = null)
	{
		$columns = array();

		if ($cols) {
			$dbMap = Propel::getDatabaseMap(FamiliarPeer::DATABASE_NAME);
			$tableMap = $dbMap->getTable(FamiliarPeer::TABLE_NAME);

			if (! is_array($cols)) {
				$cols = array($cols);
			}

			foreach($cols as $colName) {
				if ($tableMap->containsColumn($colName)) {
					$get = 'get' . $tableMap->getColumn($colName)->getPhpName();
					$columns[$colName] = $obj->$get();
				}
			}
		} else {

		}

		$res =  BasePeer::doValidate(FamiliarPeer::DATABASE_NAME, FamiliarPeer::TABLE_NAME, $columns);
    if ($res !== true) {
        $request = sfContext::getInstance()->getRequest();
        foreach ($res as $failed) {
            $col = FamiliarPeer::translateFieldname($failed->getColumn(), BasePeer::TYPE_COLNAME, BasePeer::TYPE_PHPNAME);
            $request->setError($col, $failed->getMessage());
        }
    }

    return $res;
	}

	
	public static function retrieveByPK($pk, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		$criteria = new Criteria(FamiliarPeer::DATABASE_NAME);

		$criteria->add(FamiliarPeer::ID, $pk);


		$v = FamiliarPeer::doSelect($criteria, $con);

		return !empty($v) > 0 ? $v[0] : null;
	}

	
	public static function retrieveByPKs($pks, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		$objs = null;
		if (empty($pks)) {
			$objs = array();
		} else {
			$criteria = new Criteria();
			$criteria->add(FamiliarPeer::ID, $pks, Criteria::IN);
			$objs = FamiliarPeer::doSelect($criteria, $con);
		}
		return $objs;
	}

} 
if (Propel::isInit()) {
			try {
		BaseFamiliarPeer::getMapBuilder();
	} catch (Exception $e) {
		Propel::log('Could not initialize Peer: ' . $e->getMessage(), Propel::LOG_ERR);
	}
} else {
			require_once 'lib/model/map/FamiliarMapBuilder.php';
	Propel::registerMapBuilder('lib.model.map.FamiliarMapBuilder');
}
