<?php


abstract class BaseInasistenciaTipo extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $nombre;


	
	protected $observaciones;

	
	protected $collPersonalInasistenciass;

	
	protected $lastPersonalInasistenciasCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getNombre()
	{

		return $this->nombre;
	}

	
	public function getObservaciones()
	{

		return $this->observaciones;
	}

	
	public function setId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = InasistenciaTipoPeer::ID;
		}

	} 
	
	public function setNombre($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->nombre !== $v) {
			$this->nombre = $v;
			$this->modifiedColumns[] = InasistenciaTipoPeer::NOMBRE;
		}

	} 
	
	public function setObservaciones($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->observaciones !== $v) {
			$this->observaciones = $v;
			$this->modifiedColumns[] = InasistenciaTipoPeer::OBSERVACIONES;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->nombre = $rs->getString($startcol + 1);

			$this->observaciones = $rs->getString($startcol + 2);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 3; 
		} catch (Exception $e) {
			throw new PropelException("Error populating InasistenciaTipo object", $e);
		}
	}

	
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BaseInasistenciaTipo:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(InasistenciaTipoPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			InasistenciaTipoPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseInasistenciaTipo:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BaseInasistenciaTipo:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(InasistenciaTipoPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseInasistenciaTipo:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = InasistenciaTipoPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += InasistenciaTipoPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collPersonalInasistenciass !== null) {
				foreach($this->collPersonalInasistenciass as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = InasistenciaTipoPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collPersonalInasistenciass !== null) {
					foreach($this->collPersonalInasistenciass as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = InasistenciaTipoPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getNombre();
				break;
			case 2:
				return $this->getObservaciones();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = InasistenciaTipoPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getNombre(),
			$keys[2] => $this->getObservaciones(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = InasistenciaTipoPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setNombre($value);
				break;
			case 2:
				$this->setObservaciones($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = InasistenciaTipoPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setNombre($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setObservaciones($arr[$keys[2]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(InasistenciaTipoPeer::DATABASE_NAME);

		if ($this->isColumnModified(InasistenciaTipoPeer::ID)) $criteria->add(InasistenciaTipoPeer::ID, $this->id);
		if ($this->isColumnModified(InasistenciaTipoPeer::NOMBRE)) $criteria->add(InasistenciaTipoPeer::NOMBRE, $this->nombre);
		if ($this->isColumnModified(InasistenciaTipoPeer::OBSERVACIONES)) $criteria->add(InasistenciaTipoPeer::OBSERVACIONES, $this->observaciones);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(InasistenciaTipoPeer::DATABASE_NAME);

		$criteria->add(InasistenciaTipoPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setNombre($this->nombre);

		$copyObj->setObservaciones($this->observaciones);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getPersonalInasistenciass() as $relObj) {
				$copyObj->addPersonalInasistencias($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new InasistenciaTipoPeer();
		}
		return self::$peer;
	}

	
	public function initPersonalInasistenciass()
	{
		if ($this->collPersonalInasistenciass === null) {
			$this->collPersonalInasistenciass = array();
		}
	}

	
	public function getPersonalInasistenciass($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BasePersonalInasistenciasPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collPersonalInasistenciass === null) {
			if ($this->isNew()) {
			   $this->collPersonalInasistenciass = array();
			} else {

				$criteria->add(PersonalInasistenciasPeer::INASISTENCIA_TIPO_ID, $this->getId());

				PersonalInasistenciasPeer::addSelectColumns($criteria);
				$this->collPersonalInasistenciass = PersonalInasistenciasPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(PersonalInasistenciasPeer::INASISTENCIA_TIPO_ID, $this->getId());

				PersonalInasistenciasPeer::addSelectColumns($criteria);
				if (!isset($this->lastPersonalInasistenciasCriteria) || !$this->lastPersonalInasistenciasCriteria->equals($criteria)) {
					$this->collPersonalInasistenciass = PersonalInasistenciasPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastPersonalInasistenciasCriteria = $criteria;
		return $this->collPersonalInasistenciass;
	}

	
	public function countPersonalInasistenciass($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BasePersonalInasistenciasPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(PersonalInasistenciasPeer::INASISTENCIA_TIPO_ID, $this->getId());

		return PersonalInasistenciasPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addPersonalInasistencias(PersonalInasistencias $l)
	{
		$this->collPersonalInasistenciass[] = $l;
		$l->setInasistenciaTipo($this);
	}


	
	public function getPersonalInasistenciassJoinPersonal($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BasePersonalInasistenciasPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collPersonalInasistenciass === null) {
			if ($this->isNew()) {
				$this->collPersonalInasistenciass = array();
			} else {

				$criteria->add(PersonalInasistenciasPeer::INASISTENCIA_TIPO_ID, $this->getId());

				$this->collPersonalInasistenciass = PersonalInasistenciasPeer::doSelectJoinPersonal($criteria, $con);
			}
		} else {
									
			$criteria->add(PersonalInasistenciasPeer::INASISTENCIA_TIPO_ID, $this->getId());

			if (!isset($this->lastPersonalInasistenciasCriteria) || !$this->lastPersonalInasistenciasCriteria->equals($criteria)) {
				$this->collPersonalInasistenciass = PersonalInasistenciasPeer::doSelectJoinPersonal($criteria, $con);
			}
		}
		$this->lastPersonalInasistenciasCriteria = $criteria;

		return $this->collPersonalInasistenciass;
	}


	
	public function getPersonalInasistenciassJoinTurno($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BasePersonalInasistenciasPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collPersonalInasistenciass === null) {
			if ($this->isNew()) {
				$this->collPersonalInasistenciass = array();
			} else {

				$criteria->add(PersonalInasistenciasPeer::INASISTENCIA_TIPO_ID, $this->getId());

				$this->collPersonalInasistenciass = PersonalInasistenciasPeer::doSelectJoinTurno($criteria, $con);
			}
		} else {
									
			$criteria->add(PersonalInasistenciasPeer::INASISTENCIA_TIPO_ID, $this->getId());

			if (!isset($this->lastPersonalInasistenciasCriteria) || !$this->lastPersonalInasistenciasCriteria->equals($criteria)) {
				$this->collPersonalInasistenciass = PersonalInasistenciasPeer::doSelectJoinTurno($criteria, $con);
			}
		}
		$this->lastPersonalInasistenciasCriteria = $criteria;

		return $this->collPersonalInasistenciass;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseInasistenciaTipo:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseInasistenciaTipo::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} 