<?php


abstract class BaseLicenciaTipo extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $nombre;


	
	protected $anexo;


	
	protected $dias_maximo;


	
	protected $dias_minimo = 1;


	
	protected $dias_tipo_id;


	
	protected $observaciones;

	
	protected $aDiasTipo;

	
	protected $collPersonalLicenciass;

	
	protected $lastPersonalLicenciasCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getNombre()
	{

		return $this->nombre;
	}

	
	public function getAnexo()
	{

		return $this->anexo;
	}

	
	public function getDiasMaximo()
	{

		return $this->dias_maximo;
	}

	
	public function getDiasMinimo()
	{

		return $this->dias_minimo;
	}

	
	public function getDiasTipoId()
	{

		return $this->dias_tipo_id;
	}

	
	public function getObservaciones()
	{

		return $this->observaciones;
	}

	
	public function setId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = LicenciaTipoPeer::ID;
		}

	} 
	
	public function setNombre($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->nombre !== $v) {
			$this->nombre = $v;
			$this->modifiedColumns[] = LicenciaTipoPeer::NOMBRE;
		}

	} 
	
	public function setAnexo($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->anexo !== $v) {
			$this->anexo = $v;
			$this->modifiedColumns[] = LicenciaTipoPeer::ANEXO;
		}

	} 
	
	public function setDiasMaximo($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->dias_maximo !== $v) {
			$this->dias_maximo = $v;
			$this->modifiedColumns[] = LicenciaTipoPeer::DIAS_MAXIMO;
		}

	} 
	
	public function setDiasMinimo($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->dias_minimo !== $v || $v === 1) {
			$this->dias_minimo = $v;
			$this->modifiedColumns[] = LicenciaTipoPeer::DIAS_MINIMO;
		}

	} 
	
	public function setDiasTipoId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->dias_tipo_id !== $v) {
			$this->dias_tipo_id = $v;
			$this->modifiedColumns[] = LicenciaTipoPeer::DIAS_TIPO_ID;
		}

		if ($this->aDiasTipo !== null && $this->aDiasTipo->getId() !== $v) {
			$this->aDiasTipo = null;
		}

	} 
	
	public function setObservaciones($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->observaciones !== $v) {
			$this->observaciones = $v;
			$this->modifiedColumns[] = LicenciaTipoPeer::OBSERVACIONES;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->nombre = $rs->getString($startcol + 1);

			$this->anexo = $rs->getString($startcol + 2);

			$this->dias_maximo = $rs->getInt($startcol + 3);

			$this->dias_minimo = $rs->getInt($startcol + 4);

			$this->dias_tipo_id = $rs->getInt($startcol + 5);

			$this->observaciones = $rs->getString($startcol + 6);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 7; 
		} catch (Exception $e) {
			throw new PropelException("Error populating LicenciaTipo object", $e);
		}
	}

	
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BaseLicenciaTipo:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(LicenciaTipoPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			LicenciaTipoPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseLicenciaTipo:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BaseLicenciaTipo:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(LicenciaTipoPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseLicenciaTipo:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->aDiasTipo !== null) {
				if ($this->aDiasTipo->isModified()) {
					$affectedRows += $this->aDiasTipo->save($con);
				}
				$this->setDiasTipo($this->aDiasTipo);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = LicenciaTipoPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += LicenciaTipoPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collPersonalLicenciass !== null) {
				foreach($this->collPersonalLicenciass as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aDiasTipo !== null) {
				if (!$this->aDiasTipo->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aDiasTipo->getValidationFailures());
				}
			}


			if (($retval = LicenciaTipoPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collPersonalLicenciass !== null) {
					foreach($this->collPersonalLicenciass as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = LicenciaTipoPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getNombre();
				break;
			case 2:
				return $this->getAnexo();
				break;
			case 3:
				return $this->getDiasMaximo();
				break;
			case 4:
				return $this->getDiasMinimo();
				break;
			case 5:
				return $this->getDiasTipoId();
				break;
			case 6:
				return $this->getObservaciones();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = LicenciaTipoPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getNombre(),
			$keys[2] => $this->getAnexo(),
			$keys[3] => $this->getDiasMaximo(),
			$keys[4] => $this->getDiasMinimo(),
			$keys[5] => $this->getDiasTipoId(),
			$keys[6] => $this->getObservaciones(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = LicenciaTipoPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setNombre($value);
				break;
			case 2:
				$this->setAnexo($value);
				break;
			case 3:
				$this->setDiasMaximo($value);
				break;
			case 4:
				$this->setDiasMinimo($value);
				break;
			case 5:
				$this->setDiasTipoId($value);
				break;
			case 6:
				$this->setObservaciones($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = LicenciaTipoPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setNombre($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setAnexo($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setDiasMaximo($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setDiasMinimo($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setDiasTipoId($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setObservaciones($arr[$keys[6]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(LicenciaTipoPeer::DATABASE_NAME);

		if ($this->isColumnModified(LicenciaTipoPeer::ID)) $criteria->add(LicenciaTipoPeer::ID, $this->id);
		if ($this->isColumnModified(LicenciaTipoPeer::NOMBRE)) $criteria->add(LicenciaTipoPeer::NOMBRE, $this->nombre);
		if ($this->isColumnModified(LicenciaTipoPeer::ANEXO)) $criteria->add(LicenciaTipoPeer::ANEXO, $this->anexo);
		if ($this->isColumnModified(LicenciaTipoPeer::DIAS_MAXIMO)) $criteria->add(LicenciaTipoPeer::DIAS_MAXIMO, $this->dias_maximo);
		if ($this->isColumnModified(LicenciaTipoPeer::DIAS_MINIMO)) $criteria->add(LicenciaTipoPeer::DIAS_MINIMO, $this->dias_minimo);
		if ($this->isColumnModified(LicenciaTipoPeer::DIAS_TIPO_ID)) $criteria->add(LicenciaTipoPeer::DIAS_TIPO_ID, $this->dias_tipo_id);
		if ($this->isColumnModified(LicenciaTipoPeer::OBSERVACIONES)) $criteria->add(LicenciaTipoPeer::OBSERVACIONES, $this->observaciones);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(LicenciaTipoPeer::DATABASE_NAME);

		$criteria->add(LicenciaTipoPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setNombre($this->nombre);

		$copyObj->setAnexo($this->anexo);

		$copyObj->setDiasMaximo($this->dias_maximo);

		$copyObj->setDiasMinimo($this->dias_minimo);

		$copyObj->setDiasTipoId($this->dias_tipo_id);

		$copyObj->setObservaciones($this->observaciones);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getPersonalLicenciass() as $relObj) {
				$copyObj->addPersonalLicencias($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new LicenciaTipoPeer();
		}
		return self::$peer;
	}

	
	public function setDiasTipo($v)
	{


		if ($v === null) {
			$this->setDiasTipoId(NULL);
		} else {
			$this->setDiasTipoId($v->getId());
		}


		$this->aDiasTipo = $v;
	}


	
	public function getDiasTipo($con = null)
	{
		if ($this->aDiasTipo === null && ($this->dias_tipo_id !== null)) {
						include_once 'lib/model/om/BaseDiasTipoPeer.php';

			$this->aDiasTipo = DiasTipoPeer::retrieveByPK($this->dias_tipo_id, $con);

			
		}
		return $this->aDiasTipo;
	}

	
	public function initPersonalLicenciass()
	{
		if ($this->collPersonalLicenciass === null) {
			$this->collPersonalLicenciass = array();
		}
	}

	
	public function getPersonalLicenciass($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BasePersonalLicenciasPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collPersonalLicenciass === null) {
			if ($this->isNew()) {
			   $this->collPersonalLicenciass = array();
			} else {

				$criteria->add(PersonalLicenciasPeer::LICENCIA_TIPO_ID, $this->getId());

				PersonalLicenciasPeer::addSelectColumns($criteria);
				$this->collPersonalLicenciass = PersonalLicenciasPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(PersonalLicenciasPeer::LICENCIA_TIPO_ID, $this->getId());

				PersonalLicenciasPeer::addSelectColumns($criteria);
				if (!isset($this->lastPersonalLicenciasCriteria) || !$this->lastPersonalLicenciasCriteria->equals($criteria)) {
					$this->collPersonalLicenciass = PersonalLicenciasPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastPersonalLicenciasCriteria = $criteria;
		return $this->collPersonalLicenciass;
	}

	
	public function countPersonalLicenciass($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BasePersonalLicenciasPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(PersonalLicenciasPeer::LICENCIA_TIPO_ID, $this->getId());

		return PersonalLicenciasPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addPersonalLicencias(PersonalLicencias $l)
	{
		$this->collPersonalLicenciass[] = $l;
		$l->setLicenciaTipo($this);
	}


	
	public function getPersonalLicenciassJoinPersonal($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BasePersonalLicenciasPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collPersonalLicenciass === null) {
			if ($this->isNew()) {
				$this->collPersonalLicenciass = array();
			} else {

				$criteria->add(PersonalLicenciasPeer::LICENCIA_TIPO_ID, $this->getId());

				$this->collPersonalLicenciass = PersonalLicenciasPeer::doSelectJoinPersonal($criteria, $con);
			}
		} else {
									
			$criteria->add(PersonalLicenciasPeer::LICENCIA_TIPO_ID, $this->getId());

			if (!isset($this->lastPersonalLicenciasCriteria) || !$this->lastPersonalLicenciasCriteria->equals($criteria)) {
				$this->collPersonalLicenciass = PersonalLicenciasPeer::doSelectJoinPersonal($criteria, $con);
			}
		}
		$this->lastPersonalLicenciasCriteria = $criteria;

		return $this->collPersonalLicenciass;
	}


	
	public function getPersonalLicenciassJoinFamiliar($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BasePersonalLicenciasPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collPersonalLicenciass === null) {
			if ($this->isNew()) {
				$this->collPersonalLicenciass = array();
			} else {

				$criteria->add(PersonalLicenciasPeer::LICENCIA_TIPO_ID, $this->getId());

				$this->collPersonalLicenciass = PersonalLicenciasPeer::doSelectJoinFamiliar($criteria, $con);
			}
		} else {
									
			$criteria->add(PersonalLicenciasPeer::LICENCIA_TIPO_ID, $this->getId());

			if (!isset($this->lastPersonalLicenciasCriteria) || !$this->lastPersonalLicenciasCriteria->equals($criteria)) {
				$this->collPersonalLicenciass = PersonalLicenciasPeer::doSelectJoinFamiliar($criteria, $con);
			}
		}
		$this->lastPersonalLicenciasCriteria = $criteria;

		return $this->collPersonalLicenciass;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseLicenciaTipo:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseLicenciaTipo::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} 