<?php


abstract class BaseNotificacion extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $fecha;


	
	protected $referencia;


	
	protected $enviada = false;


	
	protected $adjuntos;


	
	protected $cuerpo;

	
	protected $collNotificacionConsejeros;

	
	protected $lastNotificacionConsejeroCriteria = null;

	
	protected $collNotificacionComisions;

	
	protected $lastNotificacionComisionCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getFecha($format = '%d/%m/%Y')
	{

		if ($this->fecha === null || $this->fecha === '') {
			return null;
		} elseif (!is_int($this->fecha)) {
						$ts = strtotime($this->fecha);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [fecha] as date/time value: " . var_export($this->fecha, true));
			}
		} else {
			$ts = $this->fecha;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getReferencia()
	{

		return $this->referencia;
	}

	
	public function getEnviada()
	{

		return $this->enviada;
	}

	
	public function getAdjuntos()
	{

		return $this->adjuntos;
	}

	
	public function getCuerpo()
	{

		return $this->cuerpo;
	}

	
	public function setId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = NotificacionPeer::ID;
		}

	} 
	
	public function setFecha($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [fecha] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->fecha !== $ts) {
			$this->fecha = $ts;
			$this->modifiedColumns[] = NotificacionPeer::FECHA;
		}

	} 
	
	public function setReferencia($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->referencia !== $v) {
			$this->referencia = $v;
			$this->modifiedColumns[] = NotificacionPeer::REFERENCIA;
		}

	} 
	
	public function setEnviada($v)
	{

		if ($this->enviada !== $v || $v === false) {
			$this->enviada = $v;
			$this->modifiedColumns[] = NotificacionPeer::ENVIADA;
		}

	} 
	
	public function setAdjuntos($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->adjuntos !== $v) {
			$this->adjuntos = $v;
			$this->modifiedColumns[] = NotificacionPeer::ADJUNTOS;
		}

	} 
	
	public function setCuerpo($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->cuerpo !== $v) {
			$this->cuerpo = $v;
			$this->modifiedColumns[] = NotificacionPeer::CUERPO;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->fecha = $rs->getDate($startcol + 1, null);

			$this->referencia = $rs->getString($startcol + 2);

			$this->enviada = $rs->getBoolean($startcol + 3);

			$this->adjuntos = $rs->getString($startcol + 4);

			$this->cuerpo = $rs->getString($startcol + 5);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 6; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Notificacion object", $e);
		}
	}

	
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BaseNotificacion:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(NotificacionPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			NotificacionPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseNotificacion:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BaseNotificacion:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(NotificacionPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseNotificacion:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = NotificacionPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += NotificacionPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collNotificacionConsejeros !== null) {
				foreach($this->collNotificacionConsejeros as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collNotificacionComisions !== null) {
				foreach($this->collNotificacionComisions as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = NotificacionPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collNotificacionConsejeros !== null) {
					foreach($this->collNotificacionConsejeros as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collNotificacionComisions !== null) {
					foreach($this->collNotificacionComisions as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = NotificacionPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getFecha();
				break;
			case 2:
				return $this->getReferencia();
				break;
			case 3:
				return $this->getEnviada();
				break;
			case 4:
				return $this->getAdjuntos();
				break;
			case 5:
				return $this->getCuerpo();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = NotificacionPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getFecha(),
			$keys[2] => $this->getReferencia(),
			$keys[3] => $this->getEnviada(),
			$keys[4] => $this->getAdjuntos(),
			$keys[5] => $this->getCuerpo(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = NotificacionPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setFecha($value);
				break;
			case 2:
				$this->setReferencia($value);
				break;
			case 3:
				$this->setEnviada($value);
				break;
			case 4:
				$this->setAdjuntos($value);
				break;
			case 5:
				$this->setCuerpo($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = NotificacionPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setFecha($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setReferencia($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setEnviada($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setAdjuntos($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setCuerpo($arr[$keys[5]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(NotificacionPeer::DATABASE_NAME);

		if ($this->isColumnModified(NotificacionPeer::ID)) $criteria->add(NotificacionPeer::ID, $this->id);
		if ($this->isColumnModified(NotificacionPeer::FECHA)) $criteria->add(NotificacionPeer::FECHA, $this->fecha);
		if ($this->isColumnModified(NotificacionPeer::REFERENCIA)) $criteria->add(NotificacionPeer::REFERENCIA, $this->referencia);
		if ($this->isColumnModified(NotificacionPeer::ENVIADA)) $criteria->add(NotificacionPeer::ENVIADA, $this->enviada);
		if ($this->isColumnModified(NotificacionPeer::ADJUNTOS)) $criteria->add(NotificacionPeer::ADJUNTOS, $this->adjuntos);
		if ($this->isColumnModified(NotificacionPeer::CUERPO)) $criteria->add(NotificacionPeer::CUERPO, $this->cuerpo);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(NotificacionPeer::DATABASE_NAME);

		$criteria->add(NotificacionPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setFecha($this->fecha);

		$copyObj->setReferencia($this->referencia);

		$copyObj->setEnviada($this->enviada);

		$copyObj->setAdjuntos($this->adjuntos);

		$copyObj->setCuerpo($this->cuerpo);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getNotificacionConsejeros() as $relObj) {
				$copyObj->addNotificacionConsejero($relObj->copy($deepCopy));
			}

			foreach($this->getNotificacionComisions() as $relObj) {
				$copyObj->addNotificacionComision($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new NotificacionPeer();
		}
		return self::$peer;
	}

	
	public function initNotificacionConsejeros()
	{
		if ($this->collNotificacionConsejeros === null) {
			$this->collNotificacionConsejeros = array();
		}
	}

	
	public function getNotificacionConsejeros($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseNotificacionConsejeroPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collNotificacionConsejeros === null) {
			if ($this->isNew()) {
			   $this->collNotificacionConsejeros = array();
			} else {

				$criteria->add(NotificacionConsejeroPeer::NOTIFICACION_ID, $this->getId());

				NotificacionConsejeroPeer::addSelectColumns($criteria);
				$this->collNotificacionConsejeros = NotificacionConsejeroPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(NotificacionConsejeroPeer::NOTIFICACION_ID, $this->getId());

				NotificacionConsejeroPeer::addSelectColumns($criteria);
				if (!isset($this->lastNotificacionConsejeroCriteria) || !$this->lastNotificacionConsejeroCriteria->equals($criteria)) {
					$this->collNotificacionConsejeros = NotificacionConsejeroPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastNotificacionConsejeroCriteria = $criteria;
		return $this->collNotificacionConsejeros;
	}

	
	public function countNotificacionConsejeros($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseNotificacionConsejeroPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(NotificacionConsejeroPeer::NOTIFICACION_ID, $this->getId());

		return NotificacionConsejeroPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addNotificacionConsejero(NotificacionConsejero $l)
	{
		$this->collNotificacionConsejeros[] = $l;
		$l->setNotificacion($this);
	}


	
	public function getNotificacionConsejerosJoinConsejero($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseNotificacionConsejeroPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collNotificacionConsejeros === null) {
			if ($this->isNew()) {
				$this->collNotificacionConsejeros = array();
			} else {

				$criteria->add(NotificacionConsejeroPeer::NOTIFICACION_ID, $this->getId());

				$this->collNotificacionConsejeros = NotificacionConsejeroPeer::doSelectJoinConsejero($criteria, $con);
			}
		} else {
									
			$criteria->add(NotificacionConsejeroPeer::NOTIFICACION_ID, $this->getId());

			if (!isset($this->lastNotificacionConsejeroCriteria) || !$this->lastNotificacionConsejeroCriteria->equals($criteria)) {
				$this->collNotificacionConsejeros = NotificacionConsejeroPeer::doSelectJoinConsejero($criteria, $con);
			}
		}
		$this->lastNotificacionConsejeroCriteria = $criteria;

		return $this->collNotificacionConsejeros;
	}


	
	public function getNotificacionConsejerosJoinClaustro($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseNotificacionConsejeroPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collNotificacionConsejeros === null) {
			if ($this->isNew()) {
				$this->collNotificacionConsejeros = array();
			} else {

				$criteria->add(NotificacionConsejeroPeer::NOTIFICACION_ID, $this->getId());

				$this->collNotificacionConsejeros = NotificacionConsejeroPeer::doSelectJoinClaustro($criteria, $con);
			}
		} else {
									
			$criteria->add(NotificacionConsejeroPeer::NOTIFICACION_ID, $this->getId());

			if (!isset($this->lastNotificacionConsejeroCriteria) || !$this->lastNotificacionConsejeroCriteria->equals($criteria)) {
				$this->collNotificacionConsejeros = NotificacionConsejeroPeer::doSelectJoinClaustro($criteria, $con);
			}
		}
		$this->lastNotificacionConsejeroCriteria = $criteria;

		return $this->collNotificacionConsejeros;
	}

	
	public function initNotificacionComisions()
	{
		if ($this->collNotificacionComisions === null) {
			$this->collNotificacionComisions = array();
		}
	}

	
	public function getNotificacionComisions($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseNotificacionComisionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collNotificacionComisions === null) {
			if ($this->isNew()) {
			   $this->collNotificacionComisions = array();
			} else {

				$criteria->add(NotificacionComisionPeer::NOTIFICACION_ID, $this->getId());

				NotificacionComisionPeer::addSelectColumns($criteria);
				$this->collNotificacionComisions = NotificacionComisionPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(NotificacionComisionPeer::NOTIFICACION_ID, $this->getId());

				NotificacionComisionPeer::addSelectColumns($criteria);
				if (!isset($this->lastNotificacionComisionCriteria) || !$this->lastNotificacionComisionCriteria->equals($criteria)) {
					$this->collNotificacionComisions = NotificacionComisionPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastNotificacionComisionCriteria = $criteria;
		return $this->collNotificacionComisions;
	}

	
	public function countNotificacionComisions($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseNotificacionComisionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(NotificacionComisionPeer::NOTIFICACION_ID, $this->getId());

		return NotificacionComisionPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addNotificacionComision(NotificacionComision $l)
	{
		$this->collNotificacionComisions[] = $l;
		$l->setNotificacion($this);
	}


	
	public function getNotificacionComisionsJoinComision($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseNotificacionComisionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collNotificacionComisions === null) {
			if ($this->isNew()) {
				$this->collNotificacionComisions = array();
			} else {

				$criteria->add(NotificacionComisionPeer::NOTIFICACION_ID, $this->getId());

				$this->collNotificacionComisions = NotificacionComisionPeer::doSelectJoinComision($criteria, $con);
			}
		} else {
									
			$criteria->add(NotificacionComisionPeer::NOTIFICACION_ID, $this->getId());

			if (!isset($this->lastNotificacionComisionCriteria) || !$this->lastNotificacionComisionCriteria->equals($criteria)) {
				$this->collNotificacionComisions = NotificacionComisionPeer::doSelectJoinComision($criteria, $con);
			}
		}
		$this->lastNotificacionComisionCriteria = $criteria;

		return $this->collNotificacionComisions;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseNotificacion:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseNotificacion::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} 