<?php


abstract class BaseNotificacionAdjunto extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $notificacion_id;


	
	protected $path;


	
	protected $descripcion;

	
	protected $aNotificacion;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getNotificacionId()
	{

		return $this->notificacion_id;
	}

	
	public function getPath()
	{

		return $this->path;
	}

	
	public function getDescripcion()
	{

		return $this->descripcion;
	}

	
	public function setId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = NotificacionAdjuntoPeer::ID;
		}

	} 
	
	public function setNotificacionId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->notificacion_id !== $v) {
			$this->notificacion_id = $v;
			$this->modifiedColumns[] = NotificacionAdjuntoPeer::NOTIFICACION_ID;
		}

		if ($this->aNotificacion !== null && $this->aNotificacion->getId() !== $v) {
			$this->aNotificacion = null;
		}

	} 
	
	public function setPath($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->path !== $v) {
			$this->path = $v;
			$this->modifiedColumns[] = NotificacionAdjuntoPeer::PATH;
		}

	} 
	
	public function setDescripcion($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->descripcion !== $v) {
			$this->descripcion = $v;
			$this->modifiedColumns[] = NotificacionAdjuntoPeer::DESCRIPCION;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->notificacion_id = $rs->getInt($startcol + 1);

			$this->path = $rs->getString($startcol + 2);

			$this->descripcion = $rs->getString($startcol + 3);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 4; 
		} catch (Exception $e) {
			throw new PropelException("Error populating NotificacionAdjunto object", $e);
		}
	}

	
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BaseNotificacionAdjunto:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(NotificacionAdjuntoPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			NotificacionAdjuntoPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseNotificacionAdjunto:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BaseNotificacionAdjunto:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(NotificacionAdjuntoPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseNotificacionAdjunto:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->aNotificacion !== null) {
				if ($this->aNotificacion->isModified()) {
					$affectedRows += $this->aNotificacion->save($con);
				}
				$this->setNotificacion($this->aNotificacion);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = NotificacionAdjuntoPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += NotificacionAdjuntoPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aNotificacion !== null) {
				if (!$this->aNotificacion->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aNotificacion->getValidationFailures());
				}
			}


			if (($retval = NotificacionAdjuntoPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = NotificacionAdjuntoPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getNotificacionId();
				break;
			case 2:
				return $this->getPath();
				break;
			case 3:
				return $this->getDescripcion();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = NotificacionAdjuntoPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getNotificacionId(),
			$keys[2] => $this->getPath(),
			$keys[3] => $this->getDescripcion(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = NotificacionAdjuntoPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setNotificacionId($value);
				break;
			case 2:
				$this->setPath($value);
				break;
			case 3:
				$this->setDescripcion($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = NotificacionAdjuntoPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setNotificacionId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setPath($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setDescripcion($arr[$keys[3]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(NotificacionAdjuntoPeer::DATABASE_NAME);

		if ($this->isColumnModified(NotificacionAdjuntoPeer::ID)) $criteria->add(NotificacionAdjuntoPeer::ID, $this->id);
		if ($this->isColumnModified(NotificacionAdjuntoPeer::NOTIFICACION_ID)) $criteria->add(NotificacionAdjuntoPeer::NOTIFICACION_ID, $this->notificacion_id);
		if ($this->isColumnModified(NotificacionAdjuntoPeer::PATH)) $criteria->add(NotificacionAdjuntoPeer::PATH, $this->path);
		if ($this->isColumnModified(NotificacionAdjuntoPeer::DESCRIPCION)) $criteria->add(NotificacionAdjuntoPeer::DESCRIPCION, $this->descripcion);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(NotificacionAdjuntoPeer::DATABASE_NAME);

		$criteria->add(NotificacionAdjuntoPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setNotificacionId($this->notificacion_id);

		$copyObj->setPath($this->path);

		$copyObj->setDescripcion($this->descripcion);


		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new NotificacionAdjuntoPeer();
		}
		return self::$peer;
	}

	
	public function setNotificacion($v)
	{


		if ($v === null) {
			$this->setNotificacionId(NULL);
		} else {
			$this->setNotificacionId($v->getId());
		}


		$this->aNotificacion = $v;
	}


	
	public function getNotificacion($con = null)
	{
		if ($this->aNotificacion === null && ($this->notificacion_id !== null)) {
						include_once 'lib/model/om/BaseNotificacionPeer.php';

			$this->aNotificacion = NotificacionPeer::retrieveByPK($this->notificacion_id, $con);

			
		}
		return $this->aNotificacion;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseNotificacionAdjunto:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseNotificacionAdjunto::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} 