<?php


abstract class BaseOrganica extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $claustro_id;


	
	protected $cantidad;

	
	protected $aClaustro;

	
	protected $collOrganicaConsejeros;

	
	protected $lastOrganicaConsejeroCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getClaustroId()
	{

		return $this->claustro_id;
	}

	
	public function getCantidad()
	{

		return $this->cantidad;
	}

	
	public function setId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = OrganicaPeer::ID;
		}

	} 
	
	public function setClaustroId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->claustro_id !== $v) {
			$this->claustro_id = $v;
			$this->modifiedColumns[] = OrganicaPeer::CLAUSTRO_ID;
		}

		if ($this->aClaustro !== null && $this->aClaustro->getId() !== $v) {
			$this->aClaustro = null;
		}

	} 
	
	public function setCantidad($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->cantidad !== $v) {
			$this->cantidad = $v;
			$this->modifiedColumns[] = OrganicaPeer::CANTIDAD;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->claustro_id = $rs->getInt($startcol + 1);

			$this->cantidad = $rs->getInt($startcol + 2);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 3; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Organica object", $e);
		}
	}

	
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BaseOrganica:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(OrganicaPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			OrganicaPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseOrganica:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BaseOrganica:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(OrganicaPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseOrganica:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->aClaustro !== null) {
				if ($this->aClaustro->isModified()) {
					$affectedRows += $this->aClaustro->save($con);
				}
				$this->setClaustro($this->aClaustro);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = OrganicaPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += OrganicaPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collOrganicaConsejeros !== null) {
				foreach($this->collOrganicaConsejeros as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aClaustro !== null) {
				if (!$this->aClaustro->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aClaustro->getValidationFailures());
				}
			}


			if (($retval = OrganicaPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collOrganicaConsejeros !== null) {
					foreach($this->collOrganicaConsejeros as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = OrganicaPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getClaustroId();
				break;
			case 2:
				return $this->getCantidad();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = OrganicaPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getClaustroId(),
			$keys[2] => $this->getCantidad(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = OrganicaPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setClaustroId($value);
				break;
			case 2:
				$this->setCantidad($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = OrganicaPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setClaustroId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setCantidad($arr[$keys[2]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(OrganicaPeer::DATABASE_NAME);

		if ($this->isColumnModified(OrganicaPeer::ID)) $criteria->add(OrganicaPeer::ID, $this->id);
		if ($this->isColumnModified(OrganicaPeer::CLAUSTRO_ID)) $criteria->add(OrganicaPeer::CLAUSTRO_ID, $this->claustro_id);
		if ($this->isColumnModified(OrganicaPeer::CANTIDAD)) $criteria->add(OrganicaPeer::CANTIDAD, $this->cantidad);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(OrganicaPeer::DATABASE_NAME);

		$criteria->add(OrganicaPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setClaustroId($this->claustro_id);

		$copyObj->setCantidad($this->cantidad);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getOrganicaConsejeros() as $relObj) {
				$copyObj->addOrganicaConsejero($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new OrganicaPeer();
		}
		return self::$peer;
	}

	
	public function setClaustro($v)
	{


		if ($v === null) {
			$this->setClaustroId(NULL);
		} else {
			$this->setClaustroId($v->getId());
		}


		$this->aClaustro = $v;
	}


	
	public function getClaustro($con = null)
	{
		if ($this->aClaustro === null && ($this->claustro_id !== null)) {
						include_once 'lib/model/om/BaseClaustroPeer.php';

			$this->aClaustro = ClaustroPeer::retrieveByPK($this->claustro_id, $con);

			
		}
		return $this->aClaustro;
	}

	
	public function initOrganicaConsejeros()
	{
		if ($this->collOrganicaConsejeros === null) {
			$this->collOrganicaConsejeros = array();
		}
	}

	
	public function getOrganicaConsejeros($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseOrganicaConsejeroPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collOrganicaConsejeros === null) {
			if ($this->isNew()) {
			   $this->collOrganicaConsejeros = array();
			} else {

				$criteria->add(OrganicaConsejeroPeer::ORGANICA_ID, $this->getId());

				OrganicaConsejeroPeer::addSelectColumns($criteria);
				$this->collOrganicaConsejeros = OrganicaConsejeroPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(OrganicaConsejeroPeer::ORGANICA_ID, $this->getId());

				OrganicaConsejeroPeer::addSelectColumns($criteria);
				if (!isset($this->lastOrganicaConsejeroCriteria) || !$this->lastOrganicaConsejeroCriteria->equals($criteria)) {
					$this->collOrganicaConsejeros = OrganicaConsejeroPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastOrganicaConsejeroCriteria = $criteria;
		return $this->collOrganicaConsejeros;
	}

	
	public function countOrganicaConsejeros($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseOrganicaConsejeroPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(OrganicaConsejeroPeer::ORGANICA_ID, $this->getId());

		return OrganicaConsejeroPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addOrganicaConsejero(OrganicaConsejero $l)
	{
		$this->collOrganicaConsejeros[] = $l;
		$l->setOrganica($this);
	}


	
	public function getOrganicaConsejerosJoinConsejero($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseOrganicaConsejeroPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collOrganicaConsejeros === null) {
			if ($this->isNew()) {
				$this->collOrganicaConsejeros = array();
			} else {

				$criteria->add(OrganicaConsejeroPeer::ORGANICA_ID, $this->getId());

				$this->collOrganicaConsejeros = OrganicaConsejeroPeer::doSelectJoinConsejero($criteria, $con);
			}
		} else {
									
			$criteria->add(OrganicaConsejeroPeer::ORGANICA_ID, $this->getId());

			if (!isset($this->lastOrganicaConsejeroCriteria) || !$this->lastOrganicaConsejeroCriteria->equals($criteria)) {
				$this->collOrganicaConsejeros = OrganicaConsejeroPeer::doSelectJoinConsejero($criteria, $con);
			}
		}
		$this->lastOrganicaConsejeroCriteria = $criteria;

		return $this->collOrganicaConsejeros;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseOrganica:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseOrganica::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} 