<?php


abstract class BaseOrganicaConsejero extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $organica_id;


	
	protected $consejero_id;

	
	protected $aOrganica;

	
	protected $aConsejero;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getOrganicaId()
	{

		return $this->organica_id;
	}

	
	public function getConsejeroId()
	{

		return $this->consejero_id;
	}

	
	public function setId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = OrganicaConsejeroPeer::ID;
		}

	} 
	
	public function setOrganicaId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->organica_id !== $v) {
			$this->organica_id = $v;
			$this->modifiedColumns[] = OrganicaConsejeroPeer::ORGANICA_ID;
		}

		if ($this->aOrganica !== null && $this->aOrganica->getId() !== $v) {
			$this->aOrganica = null;
		}

	} 
	
	public function setConsejeroId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->consejero_id !== $v) {
			$this->consejero_id = $v;
			$this->modifiedColumns[] = OrganicaConsejeroPeer::CONSEJERO_ID;
		}

		if ($this->aConsejero !== null && $this->aConsejero->getId() !== $v) {
			$this->aConsejero = null;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->organica_id = $rs->getInt($startcol + 1);

			$this->consejero_id = $rs->getInt($startcol + 2);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 3; 
		} catch (Exception $e) {
			throw new PropelException("Error populating OrganicaConsejero object", $e);
		}
	}

	
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BaseOrganicaConsejero:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(OrganicaConsejeroPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			OrganicaConsejeroPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseOrganicaConsejero:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BaseOrganicaConsejero:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(OrganicaConsejeroPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseOrganicaConsejero:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->aOrganica !== null) {
				if ($this->aOrganica->isModified()) {
					$affectedRows += $this->aOrganica->save($con);
				}
				$this->setOrganica($this->aOrganica);
			}

			if ($this->aConsejero !== null) {
				if ($this->aConsejero->isModified()) {
					$affectedRows += $this->aConsejero->save($con);
				}
				$this->setConsejero($this->aConsejero);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = OrganicaConsejeroPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += OrganicaConsejeroPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aOrganica !== null) {
				if (!$this->aOrganica->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aOrganica->getValidationFailures());
				}
			}

			if ($this->aConsejero !== null) {
				if (!$this->aConsejero->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aConsejero->getValidationFailures());
				}
			}


			if (($retval = OrganicaConsejeroPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = OrganicaConsejeroPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getOrganicaId();
				break;
			case 2:
				return $this->getConsejeroId();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = OrganicaConsejeroPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getOrganicaId(),
			$keys[2] => $this->getConsejeroId(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = OrganicaConsejeroPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setOrganicaId($value);
				break;
			case 2:
				$this->setConsejeroId($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = OrganicaConsejeroPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setOrganicaId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setConsejeroId($arr[$keys[2]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(OrganicaConsejeroPeer::DATABASE_NAME);

		if ($this->isColumnModified(OrganicaConsejeroPeer::ID)) $criteria->add(OrganicaConsejeroPeer::ID, $this->id);
		if ($this->isColumnModified(OrganicaConsejeroPeer::ORGANICA_ID)) $criteria->add(OrganicaConsejeroPeer::ORGANICA_ID, $this->organica_id);
		if ($this->isColumnModified(OrganicaConsejeroPeer::CONSEJERO_ID)) $criteria->add(OrganicaConsejeroPeer::CONSEJERO_ID, $this->consejero_id);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(OrganicaConsejeroPeer::DATABASE_NAME);

		$criteria->add(OrganicaConsejeroPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setOrganicaId($this->organica_id);

		$copyObj->setConsejeroId($this->consejero_id);


		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new OrganicaConsejeroPeer();
		}
		return self::$peer;
	}

	
	public function setOrganica($v)
	{


		if ($v === null) {
			$this->setOrganicaId(NULL);
		} else {
			$this->setOrganicaId($v->getId());
		}


		$this->aOrganica = $v;
	}


	
	public function getOrganica($con = null)
	{
		if ($this->aOrganica === null && ($this->organica_id !== null)) {
						include_once 'lib/model/om/BaseOrganicaPeer.php';

			$this->aOrganica = OrganicaPeer::retrieveByPK($this->organica_id, $con);

			
		}
		return $this->aOrganica;
	}

	
	public function setConsejero($v)
	{


		if ($v === null) {
			$this->setConsejeroId(NULL);
		} else {
			$this->setConsejeroId($v->getId());
		}


		$this->aConsejero = $v;
	}


	
	public function getConsejero($con = null)
	{
		if ($this->aConsejero === null && ($this->consejero_id !== null)) {
						include_once 'lib/model/om/BaseConsejeroPeer.php';

			$this->aConsejero = ConsejeroPeer::retrieveByPK($this->consejero_id, $con);

			
		}
		return $this->aConsejero;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseOrganicaConsejero:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseOrganicaConsejero::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} 