<?php


abstract class BasePersonalFamiliar extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $personal_id;


	
	protected $familiar_id;

	
	protected $aPersonal;

	
	protected $aFamiliar;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getPersonalId()
	{

		return $this->personal_id;
	}

	
	public function getFamiliarId()
	{

		return $this->familiar_id;
	}

	
	public function setId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = PersonalFamiliarPeer::ID;
		}

	} 
	
	public function setPersonalId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->personal_id !== $v) {
			$this->personal_id = $v;
			$this->modifiedColumns[] = PersonalFamiliarPeer::PERSONAL_ID;
		}

		if ($this->aPersonal !== null && $this->aPersonal->getId() !== $v) {
			$this->aPersonal = null;
		}

	} 
	
	public function setFamiliarId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->familiar_id !== $v) {
			$this->familiar_id = $v;
			$this->modifiedColumns[] = PersonalFamiliarPeer::FAMILIAR_ID;
		}

		if ($this->aFamiliar !== null && $this->aFamiliar->getId() !== $v) {
			$this->aFamiliar = null;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->personal_id = $rs->getInt($startcol + 1);

			$this->familiar_id = $rs->getInt($startcol + 2);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 3; 
		} catch (Exception $e) {
			throw new PropelException("Error populating PersonalFamiliar object", $e);
		}
	}

	
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BasePersonalFamiliar:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(PersonalFamiliarPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			PersonalFamiliarPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BasePersonalFamiliar:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BasePersonalFamiliar:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(PersonalFamiliarPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BasePersonalFamiliar:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->aPersonal !== null) {
				if ($this->aPersonal->isModified()) {
					$affectedRows += $this->aPersonal->save($con);
				}
				$this->setPersonal($this->aPersonal);
			}

			if ($this->aFamiliar !== null) {
				if ($this->aFamiliar->isModified()) {
					$affectedRows += $this->aFamiliar->save($con);
				}
				$this->setFamiliar($this->aFamiliar);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = PersonalFamiliarPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += PersonalFamiliarPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aPersonal !== null) {
				if (!$this->aPersonal->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aPersonal->getValidationFailures());
				}
			}

			if ($this->aFamiliar !== null) {
				if (!$this->aFamiliar->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aFamiliar->getValidationFailures());
				}
			}


			if (($retval = PersonalFamiliarPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = PersonalFamiliarPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getPersonalId();
				break;
			case 2:
				return $this->getFamiliarId();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = PersonalFamiliarPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getPersonalId(),
			$keys[2] => $this->getFamiliarId(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = PersonalFamiliarPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setPersonalId($value);
				break;
			case 2:
				$this->setFamiliarId($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = PersonalFamiliarPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setPersonalId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setFamiliarId($arr[$keys[2]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(PersonalFamiliarPeer::DATABASE_NAME);

		if ($this->isColumnModified(PersonalFamiliarPeer::ID)) $criteria->add(PersonalFamiliarPeer::ID, $this->id);
		if ($this->isColumnModified(PersonalFamiliarPeer::PERSONAL_ID)) $criteria->add(PersonalFamiliarPeer::PERSONAL_ID, $this->personal_id);
		if ($this->isColumnModified(PersonalFamiliarPeer::FAMILIAR_ID)) $criteria->add(PersonalFamiliarPeer::FAMILIAR_ID, $this->familiar_id);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(PersonalFamiliarPeer::DATABASE_NAME);

		$criteria->add(PersonalFamiliarPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setPersonalId($this->personal_id);

		$copyObj->setFamiliarId($this->familiar_id);


		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new PersonalFamiliarPeer();
		}
		return self::$peer;
	}

	
	public function setPersonal($v)
	{


		if ($v === null) {
			$this->setPersonalId(NULL);
		} else {
			$this->setPersonalId($v->getId());
		}


		$this->aPersonal = $v;
	}


	
	public function getPersonal($con = null)
	{
		if ($this->aPersonal === null && ($this->personal_id !== null)) {
						include_once 'lib/model/om/BasePersonalPeer.php';

			$this->aPersonal = PersonalPeer::retrieveByPK($this->personal_id, $con);

			
		}
		return $this->aPersonal;
	}

	
	public function setFamiliar($v)
	{


		if ($v === null) {
			$this->setFamiliarId(NULL);
		} else {
			$this->setFamiliarId($v->getId());
		}


		$this->aFamiliar = $v;
	}


	
	public function getFamiliar($con = null)
	{
		if ($this->aFamiliar === null && ($this->familiar_id !== null)) {
						include_once 'lib/model/om/BaseFamiliarPeer.php';

			$this->aFamiliar = FamiliarPeer::retrieveByPK($this->familiar_id, $con);

			
		}
		return $this->aFamiliar;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BasePersonalFamiliar:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BasePersonalFamiliar::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} 