<?php


abstract class BasePersonalInasistencias extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $id_establecimiento = 1;


	
	protected $personal_id = 0;


	
	protected $inasistencia_tipo_id;


	
	protected $hora_entrada;


	
	protected $hora_salida;


	
	protected $fecha;


	
	protected $observaciones;


	
	protected $turno_id;


	
	protected $cargo_id = 0;


	
	protected $cantidad_dias = 0;

	
	protected $aPersonal;

	
	protected $aInasistenciaTipo;

	
	protected $aTurno;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getIdEstablecimiento()
	{

		return $this->id_establecimiento;
	}

	
	public function getPersonalId()
	{

		return $this->personal_id;
	}

	
	public function getInasistenciaTipoId()
	{

		return $this->inasistencia_tipo_id;
	}

	
	public function getHoraEntrada($format = 'H:i:s')
	{

		if ($this->hora_entrada === null || $this->hora_entrada === '') {
			return null;
		} elseif (!is_int($this->hora_entrada)) {
						$ts = strtotime($this->hora_entrada);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [hora_entrada] as date/time value: " . var_export($this->hora_entrada, true));
			}
		} else {
			$ts = $this->hora_entrada;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getHoraSalida($format = 'H:i:s')
	{

		if ($this->hora_salida === null || $this->hora_salida === '') {
			return null;
		} elseif (!is_int($this->hora_salida)) {
						$ts = strtotime($this->hora_salida);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [hora_salida] as date/time value: " . var_export($this->hora_salida, true));
			}
		} else {
			$ts = $this->hora_salida;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getFecha($format = '%d/%m/%Y')
	{

		if ($this->fecha === null || $this->fecha === '') {
			return null;
		} elseif (!is_int($this->fecha)) {
						$ts = strtotime($this->fecha);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [fecha] as date/time value: " . var_export($this->fecha, true));
			}
		} else {
			$ts = $this->fecha;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getObservaciones()
	{

		return $this->observaciones;
	}

	
	public function getTurnoId()
	{

		return $this->turno_id;
	}

	
	public function getCargoId()
	{

		return $this->cargo_id;
	}

	
	public function getCantidadDias()
	{

		return $this->cantidad_dias;
	}

	
	public function setId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = PersonalInasistenciasPeer::ID;
		}

	} 
	
	public function setIdEstablecimiento($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id_establecimiento !== $v || $v === 1) {
			$this->id_establecimiento = $v;
			$this->modifiedColumns[] = PersonalInasistenciasPeer::ID_ESTABLECIMIENTO;
		}

	} 
	
	public function setPersonalId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->personal_id !== $v || $v === 0) {
			$this->personal_id = $v;
			$this->modifiedColumns[] = PersonalInasistenciasPeer::PERSONAL_ID;
		}

		if ($this->aPersonal !== null && $this->aPersonal->getId() !== $v) {
			$this->aPersonal = null;
		}

	} 
	
	public function setInasistenciaTipoId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->inasistencia_tipo_id !== $v) {
			$this->inasistencia_tipo_id = $v;
			$this->modifiedColumns[] = PersonalInasistenciasPeer::INASISTENCIA_TIPO_ID;
		}

		if ($this->aInasistenciaTipo !== null && $this->aInasistenciaTipo->getId() !== $v) {
			$this->aInasistenciaTipo = null;
		}

	} 
	
	public function setHoraEntrada($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [hora_entrada] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->hora_entrada !== $ts) {
			$this->hora_entrada = $ts;
			$this->modifiedColumns[] = PersonalInasistenciasPeer::HORA_ENTRADA;
		}

	} 
	
	public function setHoraSalida($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [hora_salida] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->hora_salida !== $ts) {
			$this->hora_salida = $ts;
			$this->modifiedColumns[] = PersonalInasistenciasPeer::HORA_SALIDA;
		}

	} 
	
	public function setFecha($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [fecha] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->fecha !== $ts) {
			$this->fecha = $ts;
			$this->modifiedColumns[] = PersonalInasistenciasPeer::FECHA;
		}

	} 
	
	public function setObservaciones($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->observaciones !== $v) {
			$this->observaciones = $v;
			$this->modifiedColumns[] = PersonalInasistenciasPeer::OBSERVACIONES;
		}

	} 
	
	public function setTurnoId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->turno_id !== $v) {
			$this->turno_id = $v;
			$this->modifiedColumns[] = PersonalInasistenciasPeer::TURNO_ID;
		}

		if ($this->aTurno !== null && $this->aTurno->getId() !== $v) {
			$this->aTurno = null;
		}

	} 
	
	public function setCargoId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->cargo_id !== $v || $v === 0) {
			$this->cargo_id = $v;
			$this->modifiedColumns[] = PersonalInasistenciasPeer::CARGO_ID;
		}

	} 
	
	public function setCantidadDias($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->cantidad_dias !== $v || $v === 0) {
			$this->cantidad_dias = $v;
			$this->modifiedColumns[] = PersonalInasistenciasPeer::CANTIDAD_DIAS;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->id_establecimiento = $rs->getInt($startcol + 1);

			$this->personal_id = $rs->getInt($startcol + 2);

			$this->inasistencia_tipo_id = $rs->getInt($startcol + 3);

			$this->hora_entrada = $rs->getTime($startcol + 4, null);

			$this->hora_salida = $rs->getTime($startcol + 5, null);

			$this->fecha = $rs->getDate($startcol + 6, null);

			$this->observaciones = $rs->getString($startcol + 7);

			$this->turno_id = $rs->getInt($startcol + 8);

			$this->cargo_id = $rs->getInt($startcol + 9);

			$this->cantidad_dias = $rs->getInt($startcol + 10);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 11; 
		} catch (Exception $e) {
			throw new PropelException("Error populating PersonalInasistencias object", $e);
		}
	}

	
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BasePersonalInasistencias:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(PersonalInasistenciasPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			PersonalInasistenciasPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BasePersonalInasistencias:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BasePersonalInasistencias:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(PersonalInasistenciasPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BasePersonalInasistencias:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->aPersonal !== null) {
				if ($this->aPersonal->isModified()) {
					$affectedRows += $this->aPersonal->save($con);
				}
				$this->setPersonal($this->aPersonal);
			}

			if ($this->aInasistenciaTipo !== null) {
				if ($this->aInasistenciaTipo->isModified()) {
					$affectedRows += $this->aInasistenciaTipo->save($con);
				}
				$this->setInasistenciaTipo($this->aInasistenciaTipo);
			}

			if ($this->aTurno !== null) {
				if ($this->aTurno->isModified()) {
					$affectedRows += $this->aTurno->save($con);
				}
				$this->setTurno($this->aTurno);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = PersonalInasistenciasPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += PersonalInasistenciasPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aPersonal !== null) {
				if (!$this->aPersonal->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aPersonal->getValidationFailures());
				}
			}

			if ($this->aInasistenciaTipo !== null) {
				if (!$this->aInasistenciaTipo->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aInasistenciaTipo->getValidationFailures());
				}
			}

			if ($this->aTurno !== null) {
				if (!$this->aTurno->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aTurno->getValidationFailures());
				}
			}


			if (($retval = PersonalInasistenciasPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = PersonalInasistenciasPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getIdEstablecimiento();
				break;
			case 2:
				return $this->getPersonalId();
				break;
			case 3:
				return $this->getInasistenciaTipoId();
				break;
			case 4:
				return $this->getHoraEntrada();
				break;
			case 5:
				return $this->getHoraSalida();
				break;
			case 6:
				return $this->getFecha();
				break;
			case 7:
				return $this->getObservaciones();
				break;
			case 8:
				return $this->getTurnoId();
				break;
			case 9:
				return $this->getCargoId();
				break;
			case 10:
				return $this->getCantidadDias();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = PersonalInasistenciasPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getIdEstablecimiento(),
			$keys[2] => $this->getPersonalId(),
			$keys[3] => $this->getInasistenciaTipoId(),
			$keys[4] => $this->getHoraEntrada(),
			$keys[5] => $this->getHoraSalida(),
			$keys[6] => $this->getFecha(),
			$keys[7] => $this->getObservaciones(),
			$keys[8] => $this->getTurnoId(),
			$keys[9] => $this->getCargoId(),
			$keys[10] => $this->getCantidadDias(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = PersonalInasistenciasPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setIdEstablecimiento($value);
				break;
			case 2:
				$this->setPersonalId($value);
				break;
			case 3:
				$this->setInasistenciaTipoId($value);
				break;
			case 4:
				$this->setHoraEntrada($value);
				break;
			case 5:
				$this->setHoraSalida($value);
				break;
			case 6:
				$this->setFecha($value);
				break;
			case 7:
				$this->setObservaciones($value);
				break;
			case 8:
				$this->setTurnoId($value);
				break;
			case 9:
				$this->setCargoId($value);
				break;
			case 10:
				$this->setCantidadDias($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = PersonalInasistenciasPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setIdEstablecimiento($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setPersonalId($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setInasistenciaTipoId($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setHoraEntrada($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setHoraSalida($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setFecha($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setObservaciones($arr[$keys[7]]);
		if (array_key_exists($keys[8], $arr)) $this->setTurnoId($arr[$keys[8]]);
		if (array_key_exists($keys[9], $arr)) $this->setCargoId($arr[$keys[9]]);
		if (array_key_exists($keys[10], $arr)) $this->setCantidadDias($arr[$keys[10]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(PersonalInasistenciasPeer::DATABASE_NAME);

		if ($this->isColumnModified(PersonalInasistenciasPeer::ID)) $criteria->add(PersonalInasistenciasPeer::ID, $this->id);
		if ($this->isColumnModified(PersonalInasistenciasPeer::ID_ESTABLECIMIENTO)) $criteria->add(PersonalInasistenciasPeer::ID_ESTABLECIMIENTO, $this->id_establecimiento);
		if ($this->isColumnModified(PersonalInasistenciasPeer::PERSONAL_ID)) $criteria->add(PersonalInasistenciasPeer::PERSONAL_ID, $this->personal_id);
		if ($this->isColumnModified(PersonalInasistenciasPeer::INASISTENCIA_TIPO_ID)) $criteria->add(PersonalInasistenciasPeer::INASISTENCIA_TIPO_ID, $this->inasistencia_tipo_id);
		if ($this->isColumnModified(PersonalInasistenciasPeer::HORA_ENTRADA)) $criteria->add(PersonalInasistenciasPeer::HORA_ENTRADA, $this->hora_entrada);
		if ($this->isColumnModified(PersonalInasistenciasPeer::HORA_SALIDA)) $criteria->add(PersonalInasistenciasPeer::HORA_SALIDA, $this->hora_salida);
		if ($this->isColumnModified(PersonalInasistenciasPeer::FECHA)) $criteria->add(PersonalInasistenciasPeer::FECHA, $this->fecha);
		if ($this->isColumnModified(PersonalInasistenciasPeer::OBSERVACIONES)) $criteria->add(PersonalInasistenciasPeer::OBSERVACIONES, $this->observaciones);
		if ($this->isColumnModified(PersonalInasistenciasPeer::TURNO_ID)) $criteria->add(PersonalInasistenciasPeer::TURNO_ID, $this->turno_id);
		if ($this->isColumnModified(PersonalInasistenciasPeer::CARGO_ID)) $criteria->add(PersonalInasistenciasPeer::CARGO_ID, $this->cargo_id);
		if ($this->isColumnModified(PersonalInasistenciasPeer::CANTIDAD_DIAS)) $criteria->add(PersonalInasistenciasPeer::CANTIDAD_DIAS, $this->cantidad_dias);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(PersonalInasistenciasPeer::DATABASE_NAME);

		$criteria->add(PersonalInasistenciasPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setIdEstablecimiento($this->id_establecimiento);

		$copyObj->setPersonalId($this->personal_id);

		$copyObj->setInasistenciaTipoId($this->inasistencia_tipo_id);

		$copyObj->setHoraEntrada($this->hora_entrada);

		$copyObj->setHoraSalida($this->hora_salida);

		$copyObj->setFecha($this->fecha);

		$copyObj->setObservaciones($this->observaciones);

		$copyObj->setTurnoId($this->turno_id);

		$copyObj->setCargoId($this->cargo_id);

		$copyObj->setCantidadDias($this->cantidad_dias);


		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new PersonalInasistenciasPeer();
		}
		return self::$peer;
	}

	
	public function setPersonal($v)
	{


		if ($v === null) {
			$this->setPersonalId('null');
		} else {
			$this->setPersonalId($v->getId());
		}


		$this->aPersonal = $v;
	}


	
	public function getPersonal($con = null)
	{
		if ($this->aPersonal === null && ($this->personal_id !== null)) {
						include_once 'lib/model/om/BasePersonalPeer.php';

			$this->aPersonal = PersonalPeer::retrieveByPK($this->personal_id, $con);

			
		}
		return $this->aPersonal;
	}

	
	public function setInasistenciaTipo($v)
	{


		if ($v === null) {
			$this->setInasistenciaTipoId(NULL);
		} else {
			$this->setInasistenciaTipoId($v->getId());
		}


		$this->aInasistenciaTipo = $v;
	}


	
	public function getInasistenciaTipo($con = null)
	{
		if ($this->aInasistenciaTipo === null && ($this->inasistencia_tipo_id !== null)) {
						include_once 'lib/model/om/BaseInasistenciaTipoPeer.php';

			$this->aInasistenciaTipo = InasistenciaTipoPeer::retrieveByPK($this->inasistencia_tipo_id, $con);

			
		}
		return $this->aInasistenciaTipo;
	}

	
	public function setTurno($v)
	{


		if ($v === null) {
			$this->setTurnoId(NULL);
		} else {
			$this->setTurnoId($v->getId());
		}


		$this->aTurno = $v;
	}


	
	public function getTurno($con = null)
	{
		if ($this->aTurno === null && ($this->turno_id !== null)) {
						include_once 'lib/model/om/BaseTurnoPeer.php';

			$this->aTurno = TurnoPeer::retrieveByPK($this->turno_id, $con);

			
		}
		return $this->aTurno;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BasePersonalInasistencias:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BasePersonalInasistencias::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} 