<?php


abstract class BasePersonalLicencias extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $id_establecimiento = 1;


	
	protected $personal_id;


	
	protected $licencia_tipo_id;


	
	protected $fecha_inicio;


	
	protected $fecha_fin;


	
	protected $observaciones;


	
	protected $familiar_id;


	
	protected $cargo_id = 0;


	
	protected $cantidad_dias = 0;

	
	protected $aPersonal;

	
	protected $aLicenciaTipo;

	
	protected $aFamiliar;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getIdEstablecimiento()
	{

		return $this->id_establecimiento;
	}

	
	public function getPersonalId()
	{

		return $this->personal_id;
	}

	
	public function getLicenciaTipoId()
	{

		return $this->licencia_tipo_id;
	}

	
	public function getFechaInicio($format = '%d/%m/%Y')
	{

		if ($this->fecha_inicio === null || $this->fecha_inicio === '') {
			return null;
		} elseif (!is_int($this->fecha_inicio)) {
						$ts = strtotime($this->fecha_inicio);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [fecha_inicio] as date/time value: " . var_export($this->fecha_inicio, true));
			}
		} else {
			$ts = $this->fecha_inicio;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getFechaFin($format = '%d/%m/%Y')
	{

		if ($this->fecha_fin === null || $this->fecha_fin === '') {
			return null;
		} elseif (!is_int($this->fecha_fin)) {
						$ts = strtotime($this->fecha_fin);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [fecha_fin] as date/time value: " . var_export($this->fecha_fin, true));
			}
		} else {
			$ts = $this->fecha_fin;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getObservaciones()
	{

		return $this->observaciones;
	}

	
	public function getFamiliarId()
	{

		return $this->familiar_id;
	}

	
	public function getCargoId()
	{

		return $this->cargo_id;
	}

	
	public function getCantidadDias()
	{

		return $this->cantidad_dias;
	}

	
	public function setId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = PersonalLicenciasPeer::ID;
		}

	} 
	
	public function setIdEstablecimiento($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id_establecimiento !== $v || $v === 1) {
			$this->id_establecimiento = $v;
			$this->modifiedColumns[] = PersonalLicenciasPeer::ID_ESTABLECIMIENTO;
		}

	} 
	
	public function setPersonalId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->personal_id !== $v) {
			$this->personal_id = $v;
			$this->modifiedColumns[] = PersonalLicenciasPeer::PERSONAL_ID;
		}

		if ($this->aPersonal !== null && $this->aPersonal->getId() !== $v) {
			$this->aPersonal = null;
		}

	} 
	
	public function setLicenciaTipoId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->licencia_tipo_id !== $v) {
			$this->licencia_tipo_id = $v;
			$this->modifiedColumns[] = PersonalLicenciasPeer::LICENCIA_TIPO_ID;
		}

		if ($this->aLicenciaTipo !== null && $this->aLicenciaTipo->getId() !== $v) {
			$this->aLicenciaTipo = null;
		}

	} 
	
	public function setFechaInicio($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [fecha_inicio] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->fecha_inicio !== $ts) {
			$this->fecha_inicio = $ts;
			$this->modifiedColumns[] = PersonalLicenciasPeer::FECHA_INICIO;
		}

	} 
	
	public function setFechaFin($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [fecha_fin] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->fecha_fin !== $ts) {
			$this->fecha_fin = $ts;
			$this->modifiedColumns[] = PersonalLicenciasPeer::FECHA_FIN;
		}

	} 
	
	public function setObservaciones($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->observaciones !== $v) {
			$this->observaciones = $v;
			$this->modifiedColumns[] = PersonalLicenciasPeer::OBSERVACIONES;
		}

	} 
	
	public function setFamiliarId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->familiar_id !== $v) {
			$this->familiar_id = $v;
			$this->modifiedColumns[] = PersonalLicenciasPeer::FAMILIAR_ID;
		}

		if ($this->aFamiliar !== null && $this->aFamiliar->getId() !== $v) {
			$this->aFamiliar = null;
		}

	} 
	
	public function setCargoId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->cargo_id !== $v || $v === 0) {
			$this->cargo_id = $v;
			$this->modifiedColumns[] = PersonalLicenciasPeer::CARGO_ID;
		}

	} 
	
	public function setCantidadDias($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->cantidad_dias !== $v || $v === 0) {
			$this->cantidad_dias = $v;
			$this->modifiedColumns[] = PersonalLicenciasPeer::CANTIDAD_DIAS;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->id_establecimiento = $rs->getInt($startcol + 1);

			$this->personal_id = $rs->getInt($startcol + 2);

			$this->licencia_tipo_id = $rs->getInt($startcol + 3);

			$this->fecha_inicio = $rs->getDate($startcol + 4, null);

			$this->fecha_fin = $rs->getDate($startcol + 5, null);

			$this->observaciones = $rs->getString($startcol + 6);

			$this->familiar_id = $rs->getInt($startcol + 7);

			$this->cargo_id = $rs->getInt($startcol + 8);

			$this->cantidad_dias = $rs->getInt($startcol + 9);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 10; 
		} catch (Exception $e) {
			throw new PropelException("Error populating PersonalLicencias object", $e);
		}
	}

	
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BasePersonalLicencias:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(PersonalLicenciasPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			PersonalLicenciasPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BasePersonalLicencias:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BasePersonalLicencias:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(PersonalLicenciasPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BasePersonalLicencias:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->aPersonal !== null) {
				if ($this->aPersonal->isModified()) {
					$affectedRows += $this->aPersonal->save($con);
				}
				$this->setPersonal($this->aPersonal);
			}

			if ($this->aLicenciaTipo !== null) {
				if ($this->aLicenciaTipo->isModified()) {
					$affectedRows += $this->aLicenciaTipo->save($con);
				}
				$this->setLicenciaTipo($this->aLicenciaTipo);
			}

			if ($this->aFamiliar !== null) {
				if ($this->aFamiliar->isModified()) {
					$affectedRows += $this->aFamiliar->save($con);
				}
				$this->setFamiliar($this->aFamiliar);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = PersonalLicenciasPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += PersonalLicenciasPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aPersonal !== null) {
				if (!$this->aPersonal->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aPersonal->getValidationFailures());
				}
			}

			if ($this->aLicenciaTipo !== null) {
				if (!$this->aLicenciaTipo->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aLicenciaTipo->getValidationFailures());
				}
			}

			if ($this->aFamiliar !== null) {
				if (!$this->aFamiliar->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aFamiliar->getValidationFailures());
				}
			}


			if (($retval = PersonalLicenciasPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = PersonalLicenciasPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getIdEstablecimiento();
				break;
			case 2:
				return $this->getPersonalId();
				break;
			case 3:
				return $this->getLicenciaTipoId();
				break;
			case 4:
				return $this->getFechaInicio();
				break;
			case 5:
				return $this->getFechaFin();
				break;
			case 6:
				return $this->getObservaciones();
				break;
			case 7:
				return $this->getFamiliarId();
				break;
			case 8:
				return $this->getCargoId();
				break;
			case 9:
				return $this->getCantidadDias();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = PersonalLicenciasPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getIdEstablecimiento(),
			$keys[2] => $this->getPersonalId(),
			$keys[3] => $this->getLicenciaTipoId(),
			$keys[4] => $this->getFechaInicio(),
			$keys[5] => $this->getFechaFin(),
			$keys[6] => $this->getObservaciones(),
			$keys[7] => $this->getFamiliarId(),
			$keys[8] => $this->getCargoId(),
			$keys[9] => $this->getCantidadDias(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = PersonalLicenciasPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setIdEstablecimiento($value);
				break;
			case 2:
				$this->setPersonalId($value);
				break;
			case 3:
				$this->setLicenciaTipoId($value);
				break;
			case 4:
				$this->setFechaInicio($value);
				break;
			case 5:
				$this->setFechaFin($value);
				break;
			case 6:
				$this->setObservaciones($value);
				break;
			case 7:
				$this->setFamiliarId($value);
				break;
			case 8:
				$this->setCargoId($value);
				break;
			case 9:
				$this->setCantidadDias($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = PersonalLicenciasPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setIdEstablecimiento($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setPersonalId($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setLicenciaTipoId($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setFechaInicio($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setFechaFin($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setObservaciones($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setFamiliarId($arr[$keys[7]]);
		if (array_key_exists($keys[8], $arr)) $this->setCargoId($arr[$keys[8]]);
		if (array_key_exists($keys[9], $arr)) $this->setCantidadDias($arr[$keys[9]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(PersonalLicenciasPeer::DATABASE_NAME);

		if ($this->isColumnModified(PersonalLicenciasPeer::ID)) $criteria->add(PersonalLicenciasPeer::ID, $this->id);
		if ($this->isColumnModified(PersonalLicenciasPeer::ID_ESTABLECIMIENTO)) $criteria->add(PersonalLicenciasPeer::ID_ESTABLECIMIENTO, $this->id_establecimiento);
		if ($this->isColumnModified(PersonalLicenciasPeer::PERSONAL_ID)) $criteria->add(PersonalLicenciasPeer::PERSONAL_ID, $this->personal_id);
		if ($this->isColumnModified(PersonalLicenciasPeer::LICENCIA_TIPO_ID)) $criteria->add(PersonalLicenciasPeer::LICENCIA_TIPO_ID, $this->licencia_tipo_id);
		if ($this->isColumnModified(PersonalLicenciasPeer::FECHA_INICIO)) $criteria->add(PersonalLicenciasPeer::FECHA_INICIO, $this->fecha_inicio);
		if ($this->isColumnModified(PersonalLicenciasPeer::FECHA_FIN)) $criteria->add(PersonalLicenciasPeer::FECHA_FIN, $this->fecha_fin);
		if ($this->isColumnModified(PersonalLicenciasPeer::OBSERVACIONES)) $criteria->add(PersonalLicenciasPeer::OBSERVACIONES, $this->observaciones);
		if ($this->isColumnModified(PersonalLicenciasPeer::FAMILIAR_ID)) $criteria->add(PersonalLicenciasPeer::FAMILIAR_ID, $this->familiar_id);
		if ($this->isColumnModified(PersonalLicenciasPeer::CARGO_ID)) $criteria->add(PersonalLicenciasPeer::CARGO_ID, $this->cargo_id);
		if ($this->isColumnModified(PersonalLicenciasPeer::CANTIDAD_DIAS)) $criteria->add(PersonalLicenciasPeer::CANTIDAD_DIAS, $this->cantidad_dias);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(PersonalLicenciasPeer::DATABASE_NAME);

		$criteria->add(PersonalLicenciasPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setIdEstablecimiento($this->id_establecimiento);

		$copyObj->setPersonalId($this->personal_id);

		$copyObj->setLicenciaTipoId($this->licencia_tipo_id);

		$copyObj->setFechaInicio($this->fecha_inicio);

		$copyObj->setFechaFin($this->fecha_fin);

		$copyObj->setObservaciones($this->observaciones);

		$copyObj->setFamiliarId($this->familiar_id);

		$copyObj->setCargoId($this->cargo_id);

		$copyObj->setCantidadDias($this->cantidad_dias);


		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new PersonalLicenciasPeer();
		}
		return self::$peer;
	}

	
	public function setPersonal($v)
	{


		if ($v === null) {
			$this->setPersonalId(NULL);
		} else {
			$this->setPersonalId($v->getId());
		}


		$this->aPersonal = $v;
	}


	
	public function getPersonal($con = null)
	{
		if ($this->aPersonal === null && ($this->personal_id !== null)) {
						include_once 'lib/model/om/BasePersonalPeer.php';

			$this->aPersonal = PersonalPeer::retrieveByPK($this->personal_id, $con);

			
		}
		return $this->aPersonal;
	}

	
	public function setLicenciaTipo($v)
	{


		if ($v === null) {
			$this->setLicenciaTipoId(NULL);
		} else {
			$this->setLicenciaTipoId($v->getId());
		}


		$this->aLicenciaTipo = $v;
	}


	
	public function getLicenciaTipo($con = null)
	{
		if ($this->aLicenciaTipo === null && ($this->licencia_tipo_id !== null)) {
						include_once 'lib/model/om/BaseLicenciaTipoPeer.php';

			$this->aLicenciaTipo = LicenciaTipoPeer::retrieveByPK($this->licencia_tipo_id, $con);

			
		}
		return $this->aLicenciaTipo;
	}

	
	public function setFamiliar($v)
	{


		if ($v === null) {
			$this->setFamiliarId(NULL);
		} else {
			$this->setFamiliarId($v->getId());
		}


		$this->aFamiliar = $v;
	}


	
	public function getFamiliar($con = null)
	{
		if ($this->aFamiliar === null && ($this->familiar_id !== null)) {
						include_once 'lib/model/om/BaseFamiliarPeer.php';

			$this->aFamiliar = FamiliarPeer::retrieveByPK($this->familiar_id, $con);

			
		}
		return $this->aFamiliar;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BasePersonalLicencias:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BasePersonalLicencias::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} 