<?php


abstract class BasePersonalTurno extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $turno_id;


	
	protected $personal_id;


	
	protected $hora_entrada = 1293526800;


	
	protected $hora_salida = 1293548400;


	
	protected $activo = true;


	
	protected $observaciones;

	
	protected $aTurno;

	
	protected $aPersonal;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getTurnoId()
	{

		return $this->turno_id;
	}

	
	public function getPersonalId()
	{

		return $this->personal_id;
	}

	
	public function getHoraEntrada($format = 'H:i:s')
	{

		if ($this->hora_entrada === null || $this->hora_entrada === '') {
			return null;
		} elseif (!is_int($this->hora_entrada)) {
						$ts = strtotime($this->hora_entrada);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [hora_entrada] as date/time value: " . var_export($this->hora_entrada, true));
			}
		} else {
			$ts = $this->hora_entrada;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getHoraSalida($format = 'H:i:s')
	{

		if ($this->hora_salida === null || $this->hora_salida === '') {
			return null;
		} elseif (!is_int($this->hora_salida)) {
						$ts = strtotime($this->hora_salida);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [hora_salida] as date/time value: " . var_export($this->hora_salida, true));
			}
		} else {
			$ts = $this->hora_salida;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getActivo()
	{

		return $this->activo;
	}

	
	public function getObservaciones()
	{

		return $this->observaciones;
	}

	
	public function setId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = PersonalTurnoPeer::ID;
		}

	} 
	
	public function setTurnoId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->turno_id !== $v) {
			$this->turno_id = $v;
			$this->modifiedColumns[] = PersonalTurnoPeer::TURNO_ID;
		}

		if ($this->aTurno !== null && $this->aTurno->getId() !== $v) {
			$this->aTurno = null;
		}

	} 
	
	public function setPersonalId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->personal_id !== $v) {
			$this->personal_id = $v;
			$this->modifiedColumns[] = PersonalTurnoPeer::PERSONAL_ID;
		}

		if ($this->aPersonal !== null && $this->aPersonal->getId() !== $v) {
			$this->aPersonal = null;
		}

	} 
	
	public function setHoraEntrada($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [hora_entrada] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->hora_entrada !== $ts || $ts === 1293526800) {
			$this->hora_entrada = $ts;
			$this->modifiedColumns[] = PersonalTurnoPeer::HORA_ENTRADA;
		}

	} 
	
	public function setHoraSalida($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [hora_salida] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->hora_salida !== $ts || $ts === 1293548400) {
			$this->hora_salida = $ts;
			$this->modifiedColumns[] = PersonalTurnoPeer::HORA_SALIDA;
		}

	} 
	
	public function setActivo($v)
	{

		if ($this->activo !== $v || $v === true) {
			$this->activo = $v;
			$this->modifiedColumns[] = PersonalTurnoPeer::ACTIVO;
		}

	} 
	
	public function setObservaciones($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->observaciones !== $v) {
			$this->observaciones = $v;
			$this->modifiedColumns[] = PersonalTurnoPeer::OBSERVACIONES;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->turno_id = $rs->getInt($startcol + 1);

			$this->personal_id = $rs->getInt($startcol + 2);

			$this->hora_entrada = $rs->getTime($startcol + 3, null);

			$this->hora_salida = $rs->getTime($startcol + 4, null);

			$this->activo = $rs->getBoolean($startcol + 5);

			$this->observaciones = $rs->getString($startcol + 6);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 7; 
		} catch (Exception $e) {
			throw new PropelException("Error populating PersonalTurno object", $e);
		}
	}

	
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BasePersonalTurno:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(PersonalTurnoPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			PersonalTurnoPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BasePersonalTurno:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BasePersonalTurno:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(PersonalTurnoPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BasePersonalTurno:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->aTurno !== null) {
				if ($this->aTurno->isModified()) {
					$affectedRows += $this->aTurno->save($con);
				}
				$this->setTurno($this->aTurno);
			}

			if ($this->aPersonal !== null) {
				if ($this->aPersonal->isModified()) {
					$affectedRows += $this->aPersonal->save($con);
				}
				$this->setPersonal($this->aPersonal);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = PersonalTurnoPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += PersonalTurnoPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aTurno !== null) {
				if (!$this->aTurno->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aTurno->getValidationFailures());
				}
			}

			if ($this->aPersonal !== null) {
				if (!$this->aPersonal->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aPersonal->getValidationFailures());
				}
			}


			if (($retval = PersonalTurnoPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = PersonalTurnoPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getTurnoId();
				break;
			case 2:
				return $this->getPersonalId();
				break;
			case 3:
				return $this->getHoraEntrada();
				break;
			case 4:
				return $this->getHoraSalida();
				break;
			case 5:
				return $this->getActivo();
				break;
			case 6:
				return $this->getObservaciones();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = PersonalTurnoPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getTurnoId(),
			$keys[2] => $this->getPersonalId(),
			$keys[3] => $this->getHoraEntrada(),
			$keys[4] => $this->getHoraSalida(),
			$keys[5] => $this->getActivo(),
			$keys[6] => $this->getObservaciones(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = PersonalTurnoPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setTurnoId($value);
				break;
			case 2:
				$this->setPersonalId($value);
				break;
			case 3:
				$this->setHoraEntrada($value);
				break;
			case 4:
				$this->setHoraSalida($value);
				break;
			case 5:
				$this->setActivo($value);
				break;
			case 6:
				$this->setObservaciones($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = PersonalTurnoPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setTurnoId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setPersonalId($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setHoraEntrada($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setHoraSalida($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setActivo($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setObservaciones($arr[$keys[6]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(PersonalTurnoPeer::DATABASE_NAME);

		if ($this->isColumnModified(PersonalTurnoPeer::ID)) $criteria->add(PersonalTurnoPeer::ID, $this->id);
		if ($this->isColumnModified(PersonalTurnoPeer::TURNO_ID)) $criteria->add(PersonalTurnoPeer::TURNO_ID, $this->turno_id);
		if ($this->isColumnModified(PersonalTurnoPeer::PERSONAL_ID)) $criteria->add(PersonalTurnoPeer::PERSONAL_ID, $this->personal_id);
		if ($this->isColumnModified(PersonalTurnoPeer::HORA_ENTRADA)) $criteria->add(PersonalTurnoPeer::HORA_ENTRADA, $this->hora_entrada);
		if ($this->isColumnModified(PersonalTurnoPeer::HORA_SALIDA)) $criteria->add(PersonalTurnoPeer::HORA_SALIDA, $this->hora_salida);
		if ($this->isColumnModified(PersonalTurnoPeer::ACTIVO)) $criteria->add(PersonalTurnoPeer::ACTIVO, $this->activo);
		if ($this->isColumnModified(PersonalTurnoPeer::OBSERVACIONES)) $criteria->add(PersonalTurnoPeer::OBSERVACIONES, $this->observaciones);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(PersonalTurnoPeer::DATABASE_NAME);

		$criteria->add(PersonalTurnoPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setTurnoId($this->turno_id);

		$copyObj->setPersonalId($this->personal_id);

		$copyObj->setHoraEntrada($this->hora_entrada);

		$copyObj->setHoraSalida($this->hora_salida);

		$copyObj->setActivo($this->activo);

		$copyObj->setObservaciones($this->observaciones);


		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new PersonalTurnoPeer();
		}
		return self::$peer;
	}

	
	public function setTurno($v)
	{


		if ($v === null) {
			$this->setTurnoId(NULL);
		} else {
			$this->setTurnoId($v->getId());
		}


		$this->aTurno = $v;
	}


	
	public function getTurno($con = null)
	{
		if ($this->aTurno === null && ($this->turno_id !== null)) {
						include_once 'lib/model/om/BaseTurnoPeer.php';

			$this->aTurno = TurnoPeer::retrieveByPK($this->turno_id, $con);

			
		}
		return $this->aTurno;
	}

	
	public function setPersonal($v)
	{


		if ($v === null) {
			$this->setPersonalId(NULL);
		} else {
			$this->setPersonalId($v->getId());
		}


		$this->aPersonal = $v;
	}


	
	public function getPersonal($con = null)
	{
		if ($this->aPersonal === null && ($this->personal_id !== null)) {
						include_once 'lib/model/om/BasePersonalPeer.php';

			$this->aPersonal = PersonalPeer::retrieveByPK($this->personal_id, $con);

			
		}
		return $this->aPersonal;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BasePersonalTurno:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BasePersonalTurno::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} 