<?php


abstract class BasePersonalTurnoPeer {

	
	const DATABASE_NAME = 'propel';

	
	const TABLE_NAME = 'personal_turno';

	
	const CLASS_DEFAULT = 'lib.model.PersonalTurno';

	
	const NUM_COLUMNS = 7;

	
	const NUM_LAZY_LOAD_COLUMNS = 0;


	
	const ID = 'personal_turno.ID';

	
	const TURNO_ID = 'personal_turno.TURNO_ID';

	
	const PERSONAL_ID = 'personal_turno.PERSONAL_ID';

	
	const HORA_ENTRADA = 'personal_turno.HORA_ENTRADA';

	
	const HORA_SALIDA = 'personal_turno.HORA_SALIDA';

	
	const ACTIVO = 'personal_turno.ACTIVO';

	
	const OBSERVACIONES = 'personal_turno.OBSERVACIONES';

	
	private static $phpNameMap = null;


	
	private static $fieldNames = array (
		BasePeer::TYPE_PHPNAME => array ('Id', 'TurnoId', 'PersonalId', 'HoraEntrada', 'HoraSalida', 'Activo', 'Observaciones', ),
		BasePeer::TYPE_COLNAME => array (PersonalTurnoPeer::ID, PersonalTurnoPeer::TURNO_ID, PersonalTurnoPeer::PERSONAL_ID, PersonalTurnoPeer::HORA_ENTRADA, PersonalTurnoPeer::HORA_SALIDA, PersonalTurnoPeer::ACTIVO, PersonalTurnoPeer::OBSERVACIONES, ),
		BasePeer::TYPE_FIELDNAME => array ('id', 'turno_id', 'personal_id', 'hora_entrada', 'hora_salida', 'activo', 'observaciones', ),
		BasePeer::TYPE_NUM => array (0, 1, 2, 3, 4, 5, 6, )
	);

	
	private static $fieldKeys = array (
		BasePeer::TYPE_PHPNAME => array ('Id' => 0, 'TurnoId' => 1, 'PersonalId' => 2, 'HoraEntrada' => 3, 'HoraSalida' => 4, 'Activo' => 5, 'Observaciones' => 6, ),
		BasePeer::TYPE_COLNAME => array (PersonalTurnoPeer::ID => 0, PersonalTurnoPeer::TURNO_ID => 1, PersonalTurnoPeer::PERSONAL_ID => 2, PersonalTurnoPeer::HORA_ENTRADA => 3, PersonalTurnoPeer::HORA_SALIDA => 4, PersonalTurnoPeer::ACTIVO => 5, PersonalTurnoPeer::OBSERVACIONES => 6, ),
		BasePeer::TYPE_FIELDNAME => array ('id' => 0, 'turno_id' => 1, 'personal_id' => 2, 'hora_entrada' => 3, 'hora_salida' => 4, 'activo' => 5, 'observaciones' => 6, ),
		BasePeer::TYPE_NUM => array (0, 1, 2, 3, 4, 5, 6, )
	);

	
	public static function getMapBuilder()
	{
		include_once 'lib/model/map/PersonalTurnoMapBuilder.php';
		return BasePeer::getMapBuilder('lib.model.map.PersonalTurnoMapBuilder');
	}
	
	public static function getPhpNameMap()
	{
		if (self::$phpNameMap === null) {
			$map = PersonalTurnoPeer::getTableMap();
			$columns = $map->getColumns();
			$nameMap = array();
			foreach ($columns as $column) {
				$nameMap[$column->getPhpName()] = $column->getColumnName();
			}
			self::$phpNameMap = $nameMap;
		}
		return self::$phpNameMap;
	}
	
	static public function translateFieldName($name, $fromType, $toType)
	{
		$toNames = self::getFieldNames($toType);
		$key = isset(self::$fieldKeys[$fromType][$name]) ? self::$fieldKeys[$fromType][$name] : null;
		if ($key === null) {
			throw new PropelException("'$name' could not be found in the field names of type '$fromType'. These are: " . print_r(self::$fieldKeys[$fromType], true));
		}
		return $toNames[$key];
	}

	

	static public function getFieldNames($type = BasePeer::TYPE_PHPNAME)
	{
		if (!array_key_exists($type, self::$fieldNames)) {
			throw new PropelException('Method getFieldNames() expects the parameter $type to be one of the class constants TYPE_PHPNAME, TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM. ' . $type . ' was given.');
		}
		return self::$fieldNames[$type];
	}

	
	public static function alias($alias, $column)
	{
		return str_replace(PersonalTurnoPeer::TABLE_NAME.'.', $alias.'.', $column);
	}

	
	public static function addSelectColumns(Criteria $criteria)
	{

		$criteria->addSelectColumn(PersonalTurnoPeer::ID);

		$criteria->addSelectColumn(PersonalTurnoPeer::TURNO_ID);

		$criteria->addSelectColumn(PersonalTurnoPeer::PERSONAL_ID);

		$criteria->addSelectColumn(PersonalTurnoPeer::HORA_ENTRADA);

		$criteria->addSelectColumn(PersonalTurnoPeer::HORA_SALIDA);

		$criteria->addSelectColumn(PersonalTurnoPeer::ACTIVO);

		$criteria->addSelectColumn(PersonalTurnoPeer::OBSERVACIONES);

	}

	const COUNT = 'COUNT(personal_turno.ID)';
	const COUNT_DISTINCT = 'COUNT(DISTINCT personal_turno.ID)';

	
	public static function doCount(Criteria $criteria, $distinct = false, $con = null)
	{
				$criteria = clone $criteria;

				$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(PersonalTurnoPeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(PersonalTurnoPeer::COUNT);
		}

				foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$rs = PersonalTurnoPeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
						return 0;
		}
	}
	
	public static function doSelectOne(Criteria $criteria, $con = null)
	{
		$critcopy = clone $criteria;
		$critcopy->setLimit(1);
		$objects = PersonalTurnoPeer::doSelect($critcopy, $con);
		if ($objects) {
			return $objects[0];
		}
		return null;
	}
	
	public static function doSelect(Criteria $criteria, $con = null)
	{
		return PersonalTurnoPeer::populateObjects(PersonalTurnoPeer::doSelectRS($criteria, $con));
	}
	
	public static function doSelectRS(Criteria $criteria, $con = null)
	{

    foreach (sfMixer::getCallables('BasePersonalTurnoPeer:addDoSelectRS:addDoSelectRS') as $callable)
    {
      call_user_func($callable, 'BasePersonalTurnoPeer', $criteria, $con);
    }


		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		if (!$criteria->getSelectColumns()) {
			$criteria = clone $criteria;
			PersonalTurnoPeer::addSelectColumns($criteria);
		}

				$criteria->setDbName(self::DATABASE_NAME);

						return BasePeer::doSelect($criteria, $con);
	}
	
	public static function populateObjects(ResultSet $rs)
	{
		$results = array();
	
				$cls = PersonalTurnoPeer::getOMClass();
		$cls = Propel::import($cls);
				while($rs->next()) {
		
			$obj = new $cls();
			$obj->hydrate($rs);
			$results[] = $obj;
			
		}
		return $results;
	}

	
	public static function doCountJoinTurno(Criteria $criteria, $distinct = false, $con = null)
	{
				$criteria = clone $criteria;

				$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(PersonalTurnoPeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(PersonalTurnoPeer::COUNT);
		}

				foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$criteria->addJoin(PersonalTurnoPeer::TURNO_ID, TurnoPeer::ID);

		$rs = PersonalTurnoPeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
						return 0;
		}
	}


	
	public static function doCountJoinPersonal(Criteria $criteria, $distinct = false, $con = null)
	{
				$criteria = clone $criteria;

				$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(PersonalTurnoPeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(PersonalTurnoPeer::COUNT);
		}

				foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$criteria->addJoin(PersonalTurnoPeer::PERSONAL_ID, PersonalPeer::ID);

		$rs = PersonalTurnoPeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
						return 0;
		}
	}


	
	public static function doSelectJoinTurno(Criteria $c, $con = null)
	{
		$c = clone $c;

				if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		PersonalTurnoPeer::addSelectColumns($c);
		$startcol = (PersonalTurnoPeer::NUM_COLUMNS - PersonalTurnoPeer::NUM_LAZY_LOAD_COLUMNS) + 1;
		TurnoPeer::addSelectColumns($c);

		$c->addJoin(PersonalTurnoPeer::TURNO_ID, TurnoPeer::ID);
		$rs = BasePeer::doSelect($c, $con);
		$results = array();

		while($rs->next()) {

			$omClass = PersonalTurnoPeer::getOMClass();

			$cls = Propel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);

			$omClass = TurnoPeer::getOMClass();

			$cls = Propel::import($omClass);
			$obj2 = new $cls();
			$obj2->hydrate($rs, $startcol);

			$newObject = true;
			foreach($results as $temp_obj1) {
				$temp_obj2 = $temp_obj1->getTurno(); 				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
										$temp_obj2->addPersonalTurno($obj1); 					break;
				}
			}
			if ($newObject) {
				$obj2->initPersonalTurnos();
				$obj2->addPersonalTurno($obj1); 			}
			$results[] = $obj1;
		}
		return $results;
	}


	
	public static function doSelectJoinPersonal(Criteria $c, $con = null)
	{
		$c = clone $c;

				if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		PersonalTurnoPeer::addSelectColumns($c);
		$startcol = (PersonalTurnoPeer::NUM_COLUMNS - PersonalTurnoPeer::NUM_LAZY_LOAD_COLUMNS) + 1;
		PersonalPeer::addSelectColumns($c);

		$c->addJoin(PersonalTurnoPeer::PERSONAL_ID, PersonalPeer::ID);
		$rs = BasePeer::doSelect($c, $con);
		$results = array();

		while($rs->next()) {

			$omClass = PersonalTurnoPeer::getOMClass();

			$cls = Propel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);

			$omClass = PersonalPeer::getOMClass();

			$cls = Propel::import($omClass);
			$obj2 = new $cls();
			$obj2->hydrate($rs, $startcol);

			$newObject = true;
			foreach($results as $temp_obj1) {
				$temp_obj2 = $temp_obj1->getPersonal(); 				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
										$temp_obj2->addPersonalTurno($obj1); 					break;
				}
			}
			if ($newObject) {
				$obj2->initPersonalTurnos();
				$obj2->addPersonalTurno($obj1); 			}
			$results[] = $obj1;
		}
		return $results;
	}


	
	public static function doCountJoinAll(Criteria $criteria, $distinct = false, $con = null)
	{
		$criteria = clone $criteria;

				$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(PersonalTurnoPeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(PersonalTurnoPeer::COUNT);
		}

				foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$criteria->addJoin(PersonalTurnoPeer::TURNO_ID, TurnoPeer::ID);

		$criteria->addJoin(PersonalTurnoPeer::PERSONAL_ID, PersonalPeer::ID);

		$rs = PersonalTurnoPeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
						return 0;
		}
	}


	
	public static function doSelectJoinAll(Criteria $c, $con = null)
	{
		$c = clone $c;

				if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		PersonalTurnoPeer::addSelectColumns($c);
		$startcol2 = (PersonalTurnoPeer::NUM_COLUMNS - PersonalTurnoPeer::NUM_LAZY_LOAD_COLUMNS) + 1;

		TurnoPeer::addSelectColumns($c);
		$startcol3 = $startcol2 + TurnoPeer::NUM_COLUMNS;

		PersonalPeer::addSelectColumns($c);
		$startcol4 = $startcol3 + PersonalPeer::NUM_COLUMNS;

		$c->addJoin(PersonalTurnoPeer::TURNO_ID, TurnoPeer::ID);

		$c->addJoin(PersonalTurnoPeer::PERSONAL_ID, PersonalPeer::ID);

		$rs = BasePeer::doSelect($c, $con);
		$results = array();

		while($rs->next()) {

			$omClass = PersonalTurnoPeer::getOMClass();


			$cls = Propel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);


					
			$omClass = TurnoPeer::getOMClass();


			$cls = Propel::import($omClass);
			$obj2 = new $cls();
			$obj2->hydrate($rs, $startcol2);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj2 = $temp_obj1->getTurno(); 				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
					$temp_obj2->addPersonalTurno($obj1); 					break;
				}
			}

			if ($newObject) {
				$obj2->initPersonalTurnos();
				$obj2->addPersonalTurno($obj1);
			}


					
			$omClass = PersonalPeer::getOMClass();


			$cls = Propel::import($omClass);
			$obj3 = new $cls();
			$obj3->hydrate($rs, $startcol3);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj3 = $temp_obj1->getPersonal(); 				if ($temp_obj3->getPrimaryKey() === $obj3->getPrimaryKey()) {
					$newObject = false;
					$temp_obj3->addPersonalTurno($obj1); 					break;
				}
			}

			if ($newObject) {
				$obj3->initPersonalTurnos();
				$obj3->addPersonalTurno($obj1);
			}

			$results[] = $obj1;
		}
		return $results;
	}


	
	public static function doCountJoinAllExceptTurno(Criteria $criteria, $distinct = false, $con = null)
	{
				$criteria = clone $criteria;

				$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(PersonalTurnoPeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(PersonalTurnoPeer::COUNT);
		}

				foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$criteria->addJoin(PersonalTurnoPeer::PERSONAL_ID, PersonalPeer::ID);

		$rs = PersonalTurnoPeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
						return 0;
		}
	}


	
	public static function doCountJoinAllExceptPersonal(Criteria $criteria, $distinct = false, $con = null)
	{
				$criteria = clone $criteria;

				$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(PersonalTurnoPeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(PersonalTurnoPeer::COUNT);
		}

				foreach($criteria->getGroupByColumns() as $column)
		{
			$criteria->addSelectColumn($column);
		}

		$criteria->addJoin(PersonalTurnoPeer::TURNO_ID, TurnoPeer::ID);

		$rs = PersonalTurnoPeer::doSelectRS($criteria, $con);
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
						return 0;
		}
	}


	
	public static function doSelectJoinAllExceptTurno(Criteria $c, $con = null)
	{
		$c = clone $c;

								if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		PersonalTurnoPeer::addSelectColumns($c);
		$startcol2 = (PersonalTurnoPeer::NUM_COLUMNS - PersonalTurnoPeer::NUM_LAZY_LOAD_COLUMNS) + 1;

		PersonalPeer::addSelectColumns($c);
		$startcol3 = $startcol2 + PersonalPeer::NUM_COLUMNS;

		$c->addJoin(PersonalTurnoPeer::PERSONAL_ID, PersonalPeer::ID);


		$rs = BasePeer::doSelect($c, $con);
		$results = array();

		while($rs->next()) {

			$omClass = PersonalTurnoPeer::getOMClass();

			$cls = Propel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);

			$omClass = PersonalPeer::getOMClass();


			$cls = Propel::import($omClass);
			$obj2  = new $cls();
			$obj2->hydrate($rs, $startcol2);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj2 = $temp_obj1->getPersonal(); 				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
					$temp_obj2->addPersonalTurno($obj1);
					break;
				}
			}

			if ($newObject) {
				$obj2->initPersonalTurnos();
				$obj2->addPersonalTurno($obj1);
			}

			$results[] = $obj1;
		}
		return $results;
	}


	
	public static function doSelectJoinAllExceptPersonal(Criteria $c, $con = null)
	{
		$c = clone $c;

								if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		PersonalTurnoPeer::addSelectColumns($c);
		$startcol2 = (PersonalTurnoPeer::NUM_COLUMNS - PersonalTurnoPeer::NUM_LAZY_LOAD_COLUMNS) + 1;

		TurnoPeer::addSelectColumns($c);
		$startcol3 = $startcol2 + TurnoPeer::NUM_COLUMNS;

		$c->addJoin(PersonalTurnoPeer::TURNO_ID, TurnoPeer::ID);


		$rs = BasePeer::doSelect($c, $con);
		$results = array();

		while($rs->next()) {

			$omClass = PersonalTurnoPeer::getOMClass();

			$cls = Propel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);

			$omClass = TurnoPeer::getOMClass();


			$cls = Propel::import($omClass);
			$obj2  = new $cls();
			$obj2->hydrate($rs, $startcol2);

			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj2 = $temp_obj1->getTurno(); 				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
					$temp_obj2->addPersonalTurno($obj1);
					break;
				}
			}

			if ($newObject) {
				$obj2->initPersonalTurnos();
				$obj2->addPersonalTurno($obj1);
			}

			$results[] = $obj1;
		}
		return $results;
	}

	
	public static function getTableMap()
	{
		return Propel::getDatabaseMap(self::DATABASE_NAME)->getTable(self::TABLE_NAME);
	}

	
	public static function getOMClass()
	{
		return PersonalTurnoPeer::CLASS_DEFAULT;
	}

	
	public static function doInsert($values, $con = null)
	{

    foreach (sfMixer::getCallables('BasePersonalTurnoPeer:doInsert:pre') as $callable)
    {
      $ret = call_user_func($callable, 'BasePersonalTurnoPeer', $values, $con);
      if (false !== $ret)
      {
        return $ret;
      }
    }


		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		if ($values instanceof Criteria) {
			$criteria = clone $values; 		} else {
			$criteria = $values->buildCriteria(); 		}

		$criteria->remove(PersonalTurnoPeer::ID); 

				$criteria->setDbName(self::DATABASE_NAME);

		try {
									$con->begin();
			$pk = BasePeer::doInsert($criteria, $con);
			$con->commit();
		} catch(PropelException $e) {
			$con->rollback();
			throw $e;
		}

		
    foreach (sfMixer::getCallables('BasePersonalTurnoPeer:doInsert:post') as $callable)
    {
      call_user_func($callable, 'BasePersonalTurnoPeer', $values, $con, $pk);
    }

    return $pk;
	}

	
	public static function doUpdate($values, $con = null)
	{

    foreach (sfMixer::getCallables('BasePersonalTurnoPeer:doUpdate:pre') as $callable)
    {
      $ret = call_user_func($callable, 'BasePersonalTurnoPeer', $values, $con);
      if (false !== $ret)
      {
        return $ret;
      }
    }


		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		$selectCriteria = new Criteria(self::DATABASE_NAME);

		if ($values instanceof Criteria) {
			$criteria = clone $values; 
			$comparison = $criteria->getComparison(PersonalTurnoPeer::ID);
			$selectCriteria->add(PersonalTurnoPeer::ID, $criteria->remove(PersonalTurnoPeer::ID), $comparison);

		} else { 			$criteria = $values->buildCriteria(); 			$selectCriteria = $values->buildPkeyCriteria(); 		}

				$criteria->setDbName(self::DATABASE_NAME);

		$ret = BasePeer::doUpdate($selectCriteria, $criteria, $con);
	

    foreach (sfMixer::getCallables('BasePersonalTurnoPeer:doUpdate:post') as $callable)
    {
      call_user_func($callable, 'BasePersonalTurnoPeer', $values, $con, $ret);
    }

    return $ret;
  }

	
	public static function doDeleteAll($con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}
		$affectedRows = 0; 		try {
									$con->begin();
			$affectedRows += BasePeer::doDeleteAll(PersonalTurnoPeer::TABLE_NAME, $con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	 public static function doDelete($values, $con = null)
	 {
		if ($con === null) {
			$con = Propel::getConnection(PersonalTurnoPeer::DATABASE_NAME);
		}

		if ($values instanceof Criteria) {
			$criteria = clone $values; 		} elseif ($values instanceof PersonalTurno) {

			$criteria = $values->buildPkeyCriteria();
		} else {
						$criteria = new Criteria(self::DATABASE_NAME);
			$criteria->add(PersonalTurnoPeer::ID, (array) $values, Criteria::IN);
		}

				$criteria->setDbName(self::DATABASE_NAME);

		$affectedRows = 0; 
		try {
									$con->begin();
			
			$affectedRows += BasePeer::doDelete($criteria, $con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	public static function doValidate(PersonalTurno $obj, $cols = null)
	{
		$columns = array();

		if ($cols) {
			$dbMap = Propel::getDatabaseMap(PersonalTurnoPeer::DATABASE_NAME);
			$tableMap = $dbMap->getTable(PersonalTurnoPeer::TABLE_NAME);

			if (! is_array($cols)) {
				$cols = array($cols);
			}

			foreach($cols as $colName) {
				if ($tableMap->containsColumn($colName)) {
					$get = 'get' . $tableMap->getColumn($colName)->getPhpName();
					$columns[$colName] = $obj->$get();
				}
			}
		} else {

		}

		$res =  BasePeer::doValidate(PersonalTurnoPeer::DATABASE_NAME, PersonalTurnoPeer::TABLE_NAME, $columns);
    if ($res !== true) {
        $request = sfContext::getInstance()->getRequest();
        foreach ($res as $failed) {
            $col = PersonalTurnoPeer::translateFieldname($failed->getColumn(), BasePeer::TYPE_COLNAME, BasePeer::TYPE_PHPNAME);
            $request->setError($col, $failed->getMessage());
        }
    }

    return $res;
	}

	
	public static function retrieveByPK($pk, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		$criteria = new Criteria(PersonalTurnoPeer::DATABASE_NAME);

		$criteria->add(PersonalTurnoPeer::ID, $pk);


		$v = PersonalTurnoPeer::doSelect($criteria, $con);

		return !empty($v) > 0 ? $v[0] : null;
	}

	
	public static function retrieveByPKs($pks, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}

		$objs = null;
		if (empty($pks)) {
			$objs = array();
		} else {
			$criteria = new Criteria();
			$criteria->add(PersonalTurnoPeer::ID, $pks, Criteria::IN);
			$objs = PersonalTurnoPeer::doSelect($criteria, $con);
		}
		return $objs;
	}

} 
if (Propel::isInit()) {
			try {
		BasePersonalTurnoPeer::getMapBuilder();
	} catch (Exception $e) {
		Propel::log('Could not initialize Peer: ' . $e->getMessage(), Propel::LOG_ERR);
	}
} else {
			require_once 'lib/model/map/PersonalTurnoMapBuilder.php';
	Propel::registerMapBuilder('lib.model.map.PersonalTurnoMapBuilder');
}
