<?php


abstract class BaseReunion extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $titulo;


	
	protected $etiquetas;


	
	protected $lugar;


	
	protected $fecha;


	
	protected $orden_deldia;


	
	protected $created_at;

	
	protected $collReunionAsistencias;

	
	protected $lastReunionAsistenciaCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getTitulo()
	{

		return $this->titulo;
	}

	
	public function getEtiquetas()
	{

		return $this->etiquetas;
	}

	
	public function getLugar()
	{

		return $this->lugar;
	}

	
	public function getFecha($format = 'd/m/Y H:i:s')
	{

		if ($this->fecha === null || $this->fecha === '') {
			return null;
		} elseif (!is_int($this->fecha)) {
						$ts = strtotime($this->fecha);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [fecha] as date/time value: " . var_export($this->fecha, true));
			}
		} else {
			$ts = $this->fecha;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getOrdenDeldia()
	{

		return $this->orden_deldia;
	}

	
	public function getCreatedAt($format = 'd/m/Y H:i:s')
	{

		if ($this->created_at === null || $this->created_at === '') {
			return null;
		} elseif (!is_int($this->created_at)) {
						$ts = strtotime($this->created_at);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [created_at] as date/time value: " . var_export($this->created_at, true));
			}
		} else {
			$ts = $this->created_at;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function setId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = ReunionPeer::ID;
		}

	} 
	
	public function setTitulo($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->titulo !== $v) {
			$this->titulo = $v;
			$this->modifiedColumns[] = ReunionPeer::TITULO;
		}

	} 
	
	public function setEtiquetas($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->etiquetas !== $v) {
			$this->etiquetas = $v;
			$this->modifiedColumns[] = ReunionPeer::ETIQUETAS;
		}

	} 
	
	public function setLugar($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->lugar !== $v) {
			$this->lugar = $v;
			$this->modifiedColumns[] = ReunionPeer::LUGAR;
		}

	} 
	
	public function setFecha($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [fecha] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->fecha !== $ts) {
			$this->fecha = $ts;
			$this->modifiedColumns[] = ReunionPeer::FECHA;
		}

	} 
	
	public function setOrdenDeldia($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->orden_deldia !== $v) {
			$this->orden_deldia = $v;
			$this->modifiedColumns[] = ReunionPeer::ORDEN_DELDIA;
		}

	} 
	
	public function setCreatedAt($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [created_at] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->created_at !== $ts) {
			$this->created_at = $ts;
			$this->modifiedColumns[] = ReunionPeer::CREATED_AT;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->titulo = $rs->getString($startcol + 1);

			$this->etiquetas = $rs->getString($startcol + 2);

			$this->lugar = $rs->getString($startcol + 3);

			$this->fecha = $rs->getTimestamp($startcol + 4, null);

			$this->orden_deldia = $rs->getString($startcol + 5);

			$this->created_at = $rs->getTimestamp($startcol + 6, null);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 7; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Reunion object", $e);
		}
	}

	
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BaseReunion:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ReunionPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			ReunionPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseReunion:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BaseReunion:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


    if ($this->isNew() && !$this->isColumnModified(ReunionPeer::CREATED_AT))
    {
      $this->setCreatedAt(time());
    }

		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ReunionPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseReunion:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = ReunionPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += ReunionPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collReunionAsistencias !== null) {
				foreach($this->collReunionAsistencias as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = ReunionPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collReunionAsistencias !== null) {
					foreach($this->collReunionAsistencias as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ReunionPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getTitulo();
				break;
			case 2:
				return $this->getEtiquetas();
				break;
			case 3:
				return $this->getLugar();
				break;
			case 4:
				return $this->getFecha();
				break;
			case 5:
				return $this->getOrdenDeldia();
				break;
			case 6:
				return $this->getCreatedAt();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ReunionPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getTitulo(),
			$keys[2] => $this->getEtiquetas(),
			$keys[3] => $this->getLugar(),
			$keys[4] => $this->getFecha(),
			$keys[5] => $this->getOrdenDeldia(),
			$keys[6] => $this->getCreatedAt(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ReunionPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setTitulo($value);
				break;
			case 2:
				$this->setEtiquetas($value);
				break;
			case 3:
				$this->setLugar($value);
				break;
			case 4:
				$this->setFecha($value);
				break;
			case 5:
				$this->setOrdenDeldia($value);
				break;
			case 6:
				$this->setCreatedAt($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ReunionPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setTitulo($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setEtiquetas($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setLugar($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setFecha($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setOrdenDeldia($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setCreatedAt($arr[$keys[6]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(ReunionPeer::DATABASE_NAME);

		if ($this->isColumnModified(ReunionPeer::ID)) $criteria->add(ReunionPeer::ID, $this->id);
		if ($this->isColumnModified(ReunionPeer::TITULO)) $criteria->add(ReunionPeer::TITULO, $this->titulo);
		if ($this->isColumnModified(ReunionPeer::ETIQUETAS)) $criteria->add(ReunionPeer::ETIQUETAS, $this->etiquetas);
		if ($this->isColumnModified(ReunionPeer::LUGAR)) $criteria->add(ReunionPeer::LUGAR, $this->lugar);
		if ($this->isColumnModified(ReunionPeer::FECHA)) $criteria->add(ReunionPeer::FECHA, $this->fecha);
		if ($this->isColumnModified(ReunionPeer::ORDEN_DELDIA)) $criteria->add(ReunionPeer::ORDEN_DELDIA, $this->orden_deldia);
		if ($this->isColumnModified(ReunionPeer::CREATED_AT)) $criteria->add(ReunionPeer::CREATED_AT, $this->created_at);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(ReunionPeer::DATABASE_NAME);

		$criteria->add(ReunionPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setTitulo($this->titulo);

		$copyObj->setEtiquetas($this->etiquetas);

		$copyObj->setLugar($this->lugar);

		$copyObj->setFecha($this->fecha);

		$copyObj->setOrdenDeldia($this->orden_deldia);

		$copyObj->setCreatedAt($this->created_at);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getReunionAsistencias() as $relObj) {
				$copyObj->addReunionAsistencia($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new ReunionPeer();
		}
		return self::$peer;
	}

	
	public function initReunionAsistencias()
	{
		if ($this->collReunionAsistencias === null) {
			$this->collReunionAsistencias = array();
		}
	}

	
	public function getReunionAsistencias($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseReunionAsistenciaPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collReunionAsistencias === null) {
			if ($this->isNew()) {
			   $this->collReunionAsistencias = array();
			} else {

				$criteria->add(ReunionAsistenciaPeer::REUNION_ID, $this->getId());

				ReunionAsistenciaPeer::addSelectColumns($criteria);
				$this->collReunionAsistencias = ReunionAsistenciaPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(ReunionAsistenciaPeer::REUNION_ID, $this->getId());

				ReunionAsistenciaPeer::addSelectColumns($criteria);
				if (!isset($this->lastReunionAsistenciaCriteria) || !$this->lastReunionAsistenciaCriteria->equals($criteria)) {
					$this->collReunionAsistencias = ReunionAsistenciaPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastReunionAsistenciaCriteria = $criteria;
		return $this->collReunionAsistencias;
	}

	
	public function countReunionAsistencias($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseReunionAsistenciaPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(ReunionAsistenciaPeer::REUNION_ID, $this->getId());

		return ReunionAsistenciaPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addReunionAsistencia(ReunionAsistencia $l)
	{
		$this->collReunionAsistencias[] = $l;
		$l->setReunion($this);
	}


	
	public function getReunionAsistenciasJoinConsejero($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseReunionAsistenciaPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collReunionAsistencias === null) {
			if ($this->isNew()) {
				$this->collReunionAsistencias = array();
			} else {

				$criteria->add(ReunionAsistenciaPeer::REUNION_ID, $this->getId());

				$this->collReunionAsistencias = ReunionAsistenciaPeer::doSelectJoinConsejero($criteria, $con);
			}
		} else {
									
			$criteria->add(ReunionAsistenciaPeer::REUNION_ID, $this->getId());

			if (!isset($this->lastReunionAsistenciaCriteria) || !$this->lastReunionAsistenciaCriteria->equals($criteria)) {
				$this->collReunionAsistencias = ReunionAsistenciaPeer::doSelectJoinConsejero($criteria, $con);
			}
		}
		$this->lastReunionAsistenciaCriteria = $criteria;

		return $this->collReunionAsistencias;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseReunion:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseReunion::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} 