<?php


abstract class BaseReunionAsistencia extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $reunion_id;


	
	protected $consejero_id;


	
	protected $confirma_asistencia = false;


	
	protected $confirma_fecha;


	
	protected $asistio = false;


	
	protected $motivo;

	
	protected $aReunion;

	
	protected $aConsejero;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getReunionId()
	{

		return $this->reunion_id;
	}

	
	public function getConsejeroId()
	{

		return $this->consejero_id;
	}

	
	public function getConfirmaAsistencia()
	{

		return $this->confirma_asistencia;
	}

	
	public function getConfirmaFecha($format = '%d/%m/%Y')
	{

		if ($this->confirma_fecha === null || $this->confirma_fecha === '') {
			return null;
		} elseif (!is_int($this->confirma_fecha)) {
						$ts = strtotime($this->confirma_fecha);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [confirma_fecha] as date/time value: " . var_export($this->confirma_fecha, true));
			}
		} else {
			$ts = $this->confirma_fecha;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getAsistio()
	{

		return $this->asistio;
	}

	
	public function getMotivo()
	{

		return $this->motivo;
	}

	
	public function setId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = ReunionAsistenciaPeer::ID;
		}

	} 
	
	public function setReunionId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->reunion_id !== $v) {
			$this->reunion_id = $v;
			$this->modifiedColumns[] = ReunionAsistenciaPeer::REUNION_ID;
		}

		if ($this->aReunion !== null && $this->aReunion->getId() !== $v) {
			$this->aReunion = null;
		}

	} 
	
	public function setConsejeroId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->consejero_id !== $v) {
			$this->consejero_id = $v;
			$this->modifiedColumns[] = ReunionAsistenciaPeer::CONSEJERO_ID;
		}

		if ($this->aConsejero !== null && $this->aConsejero->getId() !== $v) {
			$this->aConsejero = null;
		}

	} 
	
	public function setConfirmaAsistencia($v)
	{

		if ($this->confirma_asistencia !== $v || $v === false) {
			$this->confirma_asistencia = $v;
			$this->modifiedColumns[] = ReunionAsistenciaPeer::CONFIRMA_ASISTENCIA;
		}

	} 
	
	public function setConfirmaFecha($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [confirma_fecha] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->confirma_fecha !== $ts) {
			$this->confirma_fecha = $ts;
			$this->modifiedColumns[] = ReunionAsistenciaPeer::CONFIRMA_FECHA;
		}

	} 
	
	public function setAsistio($v)
	{

		if ($this->asistio !== $v || $v === false) {
			$this->asistio = $v;
			$this->modifiedColumns[] = ReunionAsistenciaPeer::ASISTIO;
		}

	} 
	
	public function setMotivo($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->motivo !== $v) {
			$this->motivo = $v;
			$this->modifiedColumns[] = ReunionAsistenciaPeer::MOTIVO;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->reunion_id = $rs->getInt($startcol + 1);

			$this->consejero_id = $rs->getInt($startcol + 2);

			$this->confirma_asistencia = $rs->getBoolean($startcol + 3);

			$this->confirma_fecha = $rs->getDate($startcol + 4, null);

			$this->asistio = $rs->getBoolean($startcol + 5);

			$this->motivo = $rs->getString($startcol + 6);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 7; 
		} catch (Exception $e) {
			throw new PropelException("Error populating ReunionAsistencia object", $e);
		}
	}

	
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BaseReunionAsistencia:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ReunionAsistenciaPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			ReunionAsistenciaPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseReunionAsistencia:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BaseReunionAsistencia:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ReunionAsistenciaPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseReunionAsistencia:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->aReunion !== null) {
				if ($this->aReunion->isModified()) {
					$affectedRows += $this->aReunion->save($con);
				}
				$this->setReunion($this->aReunion);
			}

			if ($this->aConsejero !== null) {
				if ($this->aConsejero->isModified()) {
					$affectedRows += $this->aConsejero->save($con);
				}
				$this->setConsejero($this->aConsejero);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = ReunionAsistenciaPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += ReunionAsistenciaPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aReunion !== null) {
				if (!$this->aReunion->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aReunion->getValidationFailures());
				}
			}

			if ($this->aConsejero !== null) {
				if (!$this->aConsejero->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aConsejero->getValidationFailures());
				}
			}


			if (($retval = ReunionAsistenciaPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ReunionAsistenciaPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getReunionId();
				break;
			case 2:
				return $this->getConsejeroId();
				break;
			case 3:
				return $this->getConfirmaAsistencia();
				break;
			case 4:
				return $this->getConfirmaFecha();
				break;
			case 5:
				return $this->getAsistio();
				break;
			case 6:
				return $this->getMotivo();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ReunionAsistenciaPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getReunionId(),
			$keys[2] => $this->getConsejeroId(),
			$keys[3] => $this->getConfirmaAsistencia(),
			$keys[4] => $this->getConfirmaFecha(),
			$keys[5] => $this->getAsistio(),
			$keys[6] => $this->getMotivo(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = ReunionAsistenciaPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setReunionId($value);
				break;
			case 2:
				$this->setConsejeroId($value);
				break;
			case 3:
				$this->setConfirmaAsistencia($value);
				break;
			case 4:
				$this->setConfirmaFecha($value);
				break;
			case 5:
				$this->setAsistio($value);
				break;
			case 6:
				$this->setMotivo($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = ReunionAsistenciaPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setReunionId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setConsejeroId($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setConfirmaAsistencia($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setConfirmaFecha($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setAsistio($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setMotivo($arr[$keys[6]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(ReunionAsistenciaPeer::DATABASE_NAME);

		if ($this->isColumnModified(ReunionAsistenciaPeer::ID)) $criteria->add(ReunionAsistenciaPeer::ID, $this->id);
		if ($this->isColumnModified(ReunionAsistenciaPeer::REUNION_ID)) $criteria->add(ReunionAsistenciaPeer::REUNION_ID, $this->reunion_id);
		if ($this->isColumnModified(ReunionAsistenciaPeer::CONSEJERO_ID)) $criteria->add(ReunionAsistenciaPeer::CONSEJERO_ID, $this->consejero_id);
		if ($this->isColumnModified(ReunionAsistenciaPeer::CONFIRMA_ASISTENCIA)) $criteria->add(ReunionAsistenciaPeer::CONFIRMA_ASISTENCIA, $this->confirma_asistencia);
		if ($this->isColumnModified(ReunionAsistenciaPeer::CONFIRMA_FECHA)) $criteria->add(ReunionAsistenciaPeer::CONFIRMA_FECHA, $this->confirma_fecha);
		if ($this->isColumnModified(ReunionAsistenciaPeer::ASISTIO)) $criteria->add(ReunionAsistenciaPeer::ASISTIO, $this->asistio);
		if ($this->isColumnModified(ReunionAsistenciaPeer::MOTIVO)) $criteria->add(ReunionAsistenciaPeer::MOTIVO, $this->motivo);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(ReunionAsistenciaPeer::DATABASE_NAME);

		$criteria->add(ReunionAsistenciaPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setReunionId($this->reunion_id);

		$copyObj->setConsejeroId($this->consejero_id);

		$copyObj->setConfirmaAsistencia($this->confirma_asistencia);

		$copyObj->setConfirmaFecha($this->confirma_fecha);

		$copyObj->setAsistio($this->asistio);

		$copyObj->setMotivo($this->motivo);


		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new ReunionAsistenciaPeer();
		}
		return self::$peer;
	}

	
	public function setReunion($v)
	{


		if ($v === null) {
			$this->setReunionId(NULL);
		} else {
			$this->setReunionId($v->getId());
		}


		$this->aReunion = $v;
	}


	
	public function getReunion($con = null)
	{
		if ($this->aReunion === null && ($this->reunion_id !== null)) {
						include_once 'lib/model/om/BaseReunionPeer.php';

			$this->aReunion = ReunionPeer::retrieveByPK($this->reunion_id, $con);

			
		}
		return $this->aReunion;
	}

	
	public function setConsejero($v)
	{


		if ($v === null) {
			$this->setConsejeroId(NULL);
		} else {
			$this->setConsejeroId($v->getId());
		}


		$this->aConsejero = $v;
	}


	
	public function getConsejero($con = null)
	{
		if ($this->aConsejero === null && ($this->consejero_id !== null)) {
						include_once 'lib/model/om/BaseConsejeroPeer.php';

			$this->aConsejero = ConsejeroPeer::retrieveByPK($this->consejero_id, $con);

			
		}
		return $this->aConsejero;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseReunionAsistencia:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseReunionAsistencia::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} 