<?php


abstract class BaseTurno extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $nombre;

	
	protected $collPersonalTurnos;

	
	protected $lastPersonalTurnoCriteria = null;

	
	protected $collPersonalInasistenciass;

	
	protected $lastPersonalInasistenciasCriteria = null;

	
	protected $collArtAlumnos;

	
	protected $lastArtAlumnoCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getNombre()
	{

		return $this->nombre;
	}

	
	public function setId($v)
	{

						if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = TurnoPeer::ID;
		}

	} 
	
	public function setNombre($v)
	{

						if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->nombre !== $v) {
			$this->nombre = $v;
			$this->modifiedColumns[] = TurnoPeer::NOMBRE;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->nombre = $rs->getString($startcol + 1);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 2; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Turno object", $e);
		}
	}

	
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BaseTurno:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(TurnoPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			TurnoPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseTurno:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BaseTurno:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(TurnoPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseTurno:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = TurnoPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += TurnoPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collPersonalTurnos !== null) {
				foreach($this->collPersonalTurnos as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collPersonalInasistenciass !== null) {
				foreach($this->collPersonalInasistenciass as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collArtAlumnos !== null) {
				foreach($this->collArtAlumnos as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = TurnoPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collPersonalTurnos !== null) {
					foreach($this->collPersonalTurnos as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collPersonalInasistenciass !== null) {
					foreach($this->collPersonalInasistenciass as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collArtAlumnos !== null) {
					foreach($this->collArtAlumnos as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = TurnoPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getNombre();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = TurnoPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getNombre(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = TurnoPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setNombre($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = TurnoPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setNombre($arr[$keys[1]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(TurnoPeer::DATABASE_NAME);

		if ($this->isColumnModified(TurnoPeer::ID)) $criteria->add(TurnoPeer::ID, $this->id);
		if ($this->isColumnModified(TurnoPeer::NOMBRE)) $criteria->add(TurnoPeer::NOMBRE, $this->nombre);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(TurnoPeer::DATABASE_NAME);

		$criteria->add(TurnoPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setNombre($this->nombre);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getPersonalTurnos() as $relObj) {
				$copyObj->addPersonalTurno($relObj->copy($deepCopy));
			}

			foreach($this->getPersonalInasistenciass() as $relObj) {
				$copyObj->addPersonalInasistencias($relObj->copy($deepCopy));
			}

			foreach($this->getArtAlumnos() as $relObj) {
				$copyObj->addArtAlumno($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new TurnoPeer();
		}
		return self::$peer;
	}

	
	public function initPersonalTurnos()
	{
		if ($this->collPersonalTurnos === null) {
			$this->collPersonalTurnos = array();
		}
	}

	
	public function getPersonalTurnos($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BasePersonalTurnoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collPersonalTurnos === null) {
			if ($this->isNew()) {
			   $this->collPersonalTurnos = array();
			} else {

				$criteria->add(PersonalTurnoPeer::TURNO_ID, $this->getId());

				PersonalTurnoPeer::addSelectColumns($criteria);
				$this->collPersonalTurnos = PersonalTurnoPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(PersonalTurnoPeer::TURNO_ID, $this->getId());

				PersonalTurnoPeer::addSelectColumns($criteria);
				if (!isset($this->lastPersonalTurnoCriteria) || !$this->lastPersonalTurnoCriteria->equals($criteria)) {
					$this->collPersonalTurnos = PersonalTurnoPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastPersonalTurnoCriteria = $criteria;
		return $this->collPersonalTurnos;
	}

	
	public function countPersonalTurnos($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BasePersonalTurnoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(PersonalTurnoPeer::TURNO_ID, $this->getId());

		return PersonalTurnoPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addPersonalTurno(PersonalTurno $l)
	{
		$this->collPersonalTurnos[] = $l;
		$l->setTurno($this);
	}


	
	public function getPersonalTurnosJoinPersonal($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BasePersonalTurnoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collPersonalTurnos === null) {
			if ($this->isNew()) {
				$this->collPersonalTurnos = array();
			} else {

				$criteria->add(PersonalTurnoPeer::TURNO_ID, $this->getId());

				$this->collPersonalTurnos = PersonalTurnoPeer::doSelectJoinPersonal($criteria, $con);
			}
		} else {
									
			$criteria->add(PersonalTurnoPeer::TURNO_ID, $this->getId());

			if (!isset($this->lastPersonalTurnoCriteria) || !$this->lastPersonalTurnoCriteria->equals($criteria)) {
				$this->collPersonalTurnos = PersonalTurnoPeer::doSelectJoinPersonal($criteria, $con);
			}
		}
		$this->lastPersonalTurnoCriteria = $criteria;

		return $this->collPersonalTurnos;
	}

	
	public function initPersonalInasistenciass()
	{
		if ($this->collPersonalInasistenciass === null) {
			$this->collPersonalInasistenciass = array();
		}
	}

	
	public function getPersonalInasistenciass($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BasePersonalInasistenciasPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collPersonalInasistenciass === null) {
			if ($this->isNew()) {
			   $this->collPersonalInasistenciass = array();
			} else {

				$criteria->add(PersonalInasistenciasPeer::TURNO_ID, $this->getId());

				PersonalInasistenciasPeer::addSelectColumns($criteria);
				$this->collPersonalInasistenciass = PersonalInasistenciasPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(PersonalInasistenciasPeer::TURNO_ID, $this->getId());

				PersonalInasistenciasPeer::addSelectColumns($criteria);
				if (!isset($this->lastPersonalInasistenciasCriteria) || !$this->lastPersonalInasistenciasCriteria->equals($criteria)) {
					$this->collPersonalInasistenciass = PersonalInasistenciasPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastPersonalInasistenciasCriteria = $criteria;
		return $this->collPersonalInasistenciass;
	}

	
	public function countPersonalInasistenciass($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BasePersonalInasistenciasPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(PersonalInasistenciasPeer::TURNO_ID, $this->getId());

		return PersonalInasistenciasPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addPersonalInasistencias(PersonalInasistencias $l)
	{
		$this->collPersonalInasistenciass[] = $l;
		$l->setTurno($this);
	}


	
	public function getPersonalInasistenciassJoinPersonal($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BasePersonalInasistenciasPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collPersonalInasistenciass === null) {
			if ($this->isNew()) {
				$this->collPersonalInasistenciass = array();
			} else {

				$criteria->add(PersonalInasistenciasPeer::TURNO_ID, $this->getId());

				$this->collPersonalInasistenciass = PersonalInasistenciasPeer::doSelectJoinPersonal($criteria, $con);
			}
		} else {
									
			$criteria->add(PersonalInasistenciasPeer::TURNO_ID, $this->getId());

			if (!isset($this->lastPersonalInasistenciasCriteria) || !$this->lastPersonalInasistenciasCriteria->equals($criteria)) {
				$this->collPersonalInasistenciass = PersonalInasistenciasPeer::doSelectJoinPersonal($criteria, $con);
			}
		}
		$this->lastPersonalInasistenciasCriteria = $criteria;

		return $this->collPersonalInasistenciass;
	}


	
	public function getPersonalInasistenciassJoinInasistenciaTipo($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BasePersonalInasistenciasPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collPersonalInasistenciass === null) {
			if ($this->isNew()) {
				$this->collPersonalInasistenciass = array();
			} else {

				$criteria->add(PersonalInasistenciasPeer::TURNO_ID, $this->getId());

				$this->collPersonalInasistenciass = PersonalInasistenciasPeer::doSelectJoinInasistenciaTipo($criteria, $con);
			}
		} else {
									
			$criteria->add(PersonalInasistenciasPeer::TURNO_ID, $this->getId());

			if (!isset($this->lastPersonalInasistenciasCriteria) || !$this->lastPersonalInasistenciasCriteria->equals($criteria)) {
				$this->collPersonalInasistenciass = PersonalInasistenciasPeer::doSelectJoinInasistenciaTipo($criteria, $con);
			}
		}
		$this->lastPersonalInasistenciasCriteria = $criteria;

		return $this->collPersonalInasistenciass;
	}

	
	public function initArtAlumnos()
	{
		if ($this->collArtAlumnos === null) {
			$this->collArtAlumnos = array();
		}
	}

	
	public function getArtAlumnos($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseArtAlumnoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collArtAlumnos === null) {
			if ($this->isNew()) {
			   $this->collArtAlumnos = array();
			} else {

				$criteria->add(ArtAlumnoPeer::ESCUELA_TURNO_ID, $this->getId());

				ArtAlumnoPeer::addSelectColumns($criteria);
				$this->collArtAlumnos = ArtAlumnoPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(ArtAlumnoPeer::ESCUELA_TURNO_ID, $this->getId());

				ArtAlumnoPeer::addSelectColumns($criteria);
				if (!isset($this->lastArtAlumnoCriteria) || !$this->lastArtAlumnoCriteria->equals($criteria)) {
					$this->collArtAlumnos = ArtAlumnoPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastArtAlumnoCriteria = $criteria;
		return $this->collArtAlumnos;
	}

	
	public function countArtAlumnos($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseArtAlumnoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(ArtAlumnoPeer::ESCUELA_TURNO_ID, $this->getId());

		return ArtAlumnoPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addArtAlumno(ArtAlumno $l)
	{
		$this->collArtAlumnos[] = $l;
		$l->setTurno($this);
	}


	
	public function getArtAlumnosJoinLocalidadRelatedByConLocalidadesId($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseArtAlumnoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collArtAlumnos === null) {
			if ($this->isNew()) {
				$this->collArtAlumnos = array();
			} else {

				$criteria->add(ArtAlumnoPeer::ESCUELA_TURNO_ID, $this->getId());

				$this->collArtAlumnos = ArtAlumnoPeer::doSelectJoinLocalidadRelatedByConLocalidadesId($criteria, $con);
			}
		} else {
									
			$criteria->add(ArtAlumnoPeer::ESCUELA_TURNO_ID, $this->getId());

			if (!isset($this->lastArtAlumnoCriteria) || !$this->lastArtAlumnoCriteria->equals($criteria)) {
				$this->collArtAlumnos = ArtAlumnoPeer::doSelectJoinLocalidadRelatedByConLocalidadesId($criteria, $con);
			}
		}
		$this->lastArtAlumnoCriteria = $criteria;

		return $this->collArtAlumnos;
	}


	
	public function getArtAlumnosJoinProvinciaRelatedByEscuelaConProvinciasId($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseArtAlumnoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collArtAlumnos === null) {
			if ($this->isNew()) {
				$this->collArtAlumnos = array();
			} else {

				$criteria->add(ArtAlumnoPeer::ESCUELA_TURNO_ID, $this->getId());

				$this->collArtAlumnos = ArtAlumnoPeer::doSelectJoinProvinciaRelatedByEscuelaConProvinciasId($criteria, $con);
			}
		} else {
									
			$criteria->add(ArtAlumnoPeer::ESCUELA_TURNO_ID, $this->getId());

			if (!isset($this->lastArtAlumnoCriteria) || !$this->lastArtAlumnoCriteria->equals($criteria)) {
				$this->collArtAlumnos = ArtAlumnoPeer::doSelectJoinProvinciaRelatedByEscuelaConProvinciasId($criteria, $con);
			}
		}
		$this->lastArtAlumnoCriteria = $criteria;

		return $this->collArtAlumnos;
	}


	
	public function getArtAlumnosJoinLocalidadRelatedByEscuelaConLocalidadesId($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseArtAlumnoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collArtAlumnos === null) {
			if ($this->isNew()) {
				$this->collArtAlumnos = array();
			} else {

				$criteria->add(ArtAlumnoPeer::ESCUELA_TURNO_ID, $this->getId());

				$this->collArtAlumnos = ArtAlumnoPeer::doSelectJoinLocalidadRelatedByEscuelaConLocalidadesId($criteria, $con);
			}
		} else {
									
			$criteria->add(ArtAlumnoPeer::ESCUELA_TURNO_ID, $this->getId());

			if (!isset($this->lastArtAlumnoCriteria) || !$this->lastArtAlumnoCriteria->equals($criteria)) {
				$this->collArtAlumnos = ArtAlumnoPeer::doSelectJoinLocalidadRelatedByEscuelaConLocalidadesId($criteria, $con);
			}
		}
		$this->lastArtAlumnoCriteria = $criteria;

		return $this->collArtAlumnos;
	}


	
	public function getArtAlumnosJoinProvinciaRelatedByConProvinciasId($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseArtAlumnoPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collArtAlumnos === null) {
			if ($this->isNew()) {
				$this->collArtAlumnos = array();
			} else {

				$criteria->add(ArtAlumnoPeer::ESCUELA_TURNO_ID, $this->getId());

				$this->collArtAlumnos = ArtAlumnoPeer::doSelectJoinProvinciaRelatedByConProvinciasId($criteria, $con);
			}
		} else {
									
			$criteria->add(ArtAlumnoPeer::ESCUELA_TURNO_ID, $this->getId());

			if (!isset($this->lastArtAlumnoCriteria) || !$this->lastArtAlumnoCriteria->equals($criteria)) {
				$this->collArtAlumnos = ArtAlumnoPeer::doSelectJoinProvinciaRelatedByConProvinciasId($criteria, $con);
			}
		}
		$this->lastArtAlumnoCriteria = $criteria;

		return $this->collArtAlumnos;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseTurno:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseTurno::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} 