<?php
/**
 * config parameters
 *
 * For the full copyright and license information, please view the LICENSE file that was distributed with this source code.
 *
 * @author Bart Vanderstukken <bart@digitalbase.eu>
 * @copyright (c) 2007-2008 Digital Base BVBA <{@link mailto:info@digitalbase.eu info@digitalbase.eu}>
 * @package dbFusionChart
 * @todo create separate objects for different versions (Free & V3)
 */

/**
 * Change this constant to manipulate the xml output
 */
//define("VERSION", "FREE");
define("VERSION", "V3");


/**
 * URL to swf files that control the flash, and thus the chart
 *
 * Change this constant, if you have purchased {@link http://www.fusioncharts.com/ FusionCharts V3}<br />
 * OR copy your swf files to this location
 *
 * You'll probably have to change the values in the array {@link dbFusionChart}::$types as well
 */
define("SWFPATH", "/uader_cs/plugins/dbFusionChartPlugin/web/swf/");

if(VERSION == "FREE")
{
  /**
   * name of XML root element ("chart" for {@link http://www.fusioncharts.com/ non-free version})
   */
  define("ROOTTAG", "graph");
  /**
   * id attribute for a set-node ("label" for {@link http://www.fusioncharts.com/ non-free version})
   */
  define("LABEL", "name");
  /**
   * id attribute for a set-node ("toolText" for {@link http://www.fusioncharts.com/ non-free version})
   */
  define("TOOLTIP", "hoverText");
  /**
   * id attribute for a set-node ("showLabel" for {@link http://www.fusioncharts.com/ non-free version})
   */
  define("SHOWLABEL", "showName");
}
elseif(VERSION == "V3")
{
  define("ROOTTAG", "chart");
  define("LABEL", "label");
  define("TOOLTIP", "toolText");
  define("SHOWLABEL", "showLabel");
}