<?php
/**
 * This file is part of the {@link http://trac.symfony-project.com/wiki/dbFusionChartPlugin dbFusionChartPlugin}
 *
 * For the full copyright and license information, please view the LICENSE file that was distributed with this source code.
 *
 * @author Bart Vanderstukken <bart@digitalbase.eu>
 * @copyright (c) 2007-2008 Digital Base BVBA <{@link mailto:info@digitalbase.eu info@digitalbase.eu}>
 * @package dbFusionChart
 */

/**
 * @param string $type valid chart type, determines used swf file
 * @param string $dataURL path to xml
 * @param string $width chart's width in pixels
 * @param string $height chart's height in pixels
 * @param string $divname if not provided, id will be "chart_div_" + random(0,999)
 * @param string $chartname if not provided, id will be "ch_" + random(0,999)
 * @return dbFusionChart "auto-stringed" through dbFusionChart's magic __toString function
 */
function dbfusionchart_js($type = dbFusionChart::Column2D, $dataURL, $width = 400, $height = 400, $divname = "", $chartname = "") {
  use_helper("Javascript");

  $response = sfContext::getInstance()->getResponse();
  $response->addJavascript(sfConfig::get('db_fusionchart_js_dir'). 'FusionCharts.js');

  return new dbFusionChart($type, $dataURL, $width, $height, "", $divname, $chartname);
}