<?php

class sfGuardPropelAuthoredBehavior
{
  static protected $enabled = true;

  public function preSave($object, $con = null)
  {
    if (self::$enabled) {
      $user = sfContext::getInstance()->getUser();

      $class = get_class($object);
      $column = sfConfig::get('propel_behavior_sfGuardPropelAuthoredBehavior_'.$class.'_column', null);

      if ($column != null) {
        $setter = 'set'.call_user_func(array($class.'Peer', 'translateFieldName'), $column, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_PHPNAME);
      }
      else {
        $setter = 'set'.sfConfig::get('app_sf_guard_plugin_profile_class', 'sfGuardUserProfile').'Id';
      }

      if ($user->isAuthenticated())
      {
        $object->$setter($user->getProfile()->getId());
      }
      else
      {
        $object->$setter(NULL);
      }
    }
  }

  public static function disable()
  {
    self::$enabled = false;
  }

  public static function enable()
  {
    self::$enabled = true;
  }
}
